/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.48.0-dev-20240418(8503aef01e4f06dff414c15904a1d961e25eb8eb)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/base/common/arrays","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(O){for(var n=[],r=0,x=O.length;r<x;r++)n[r]=X[O[r]];return n};const Re=this,Ae=typeof global=="object"?global:{};var ue;(function(O){O.global=Re;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(ue||(ue={}));var ue;(function(O){class n{constructor(g,m,p){this.type=g,this.detail=m,this.timestamp=p}}O.LoaderEvent=n;class r{constructor(g){this._events=[new n(1,"",g)]}record(g,m){this._events.push(new n(g,m,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=r;class x{record(g,m){}getEvents(){return[]}}x.INSTANCE=new x,O.NullLoaderEventRecorder=x})(ue||(ue={}));var ue;(function(O){class n{static fileUriToFilePath(x,A){if(A=decodeURI(A).replace(/%23/g,"#"),x){if(/^file:\/\/\//.test(A))return A.substr(8);if(/^file:\/\//.test(A))return A.substr(5)}else if(/^file:\/\//.test(A))return A.substr(7);return A}static startsWith(x,A){return x.length>=A.length&&x.substr(0,A.length)===A}static endsWith(x,A){return x.length>=A.length&&x.substr(x.length-A.length)===A}static containsQueryString(x){return/^[^\#]*\?/gi.test(x)}static isAbsolutePath(x){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(x)}static forEachProperty(x,A){if(x){let g;for(g in x)x.hasOwnProperty(g)&&A(g,x[g])}}static isEmpty(x){let A=!0;return n.forEachProperty(x,()=>{A=!1}),A}static recursiveClone(x){if(!x||typeof x!="object"||x instanceof RegExp||!Array.isArray(x)&&Object.getPrototypeOf(x)!==Object.prototype)return x;let A=Array.isArray(x)?[]:{};return n.forEachProperty(x,(g,m)=>{m&&typeof m=="object"?A[g]=n.recursiveClone(m):A[g]=m}),A}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(x){return n.startsWith(x,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(ue||(ue={}));var ue;(function(O){function n(A){if(A instanceof Error)return A;const g=new Error(A.message||String(A)||"Unknown Error");return A.stack&&(g.stack=A.stack),g}O.ensureError=n;class r{static validateConfigurationOptions(g){function m(p){if(p.phase==="loading"){console.error('Loading "'+p.moduleId+'" failed'),console.error(p),console.error("Here are the modules that depend on it:"),console.error(p.neededBy);return}if(p.phase==="factory"){console.error('The factory function of "'+p.moduleId+'" has thrown an exception'),console.error(p),console.error("Here are the modules that depend on it:"),console.error(p.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=m),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(O.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const p=n(new Error("INVALID cached data configuration, 'path' MUST be set"));p.phase="configuration",g.onError(p),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,m=null){let p=O.Utilities.recursiveClone(m||{});return O.Utilities.forEachProperty(g,(o,a)=>{o==="ignoreDuplicateModules"&&typeof p.ignoreDuplicateModules<"u"?p.ignoreDuplicateModules=p.ignoreDuplicateModules.concat(a):o==="paths"&&typeof p.paths<"u"?O.Utilities.forEachProperty(a,(v,e)=>p.paths[v]=e):o==="config"&&typeof p.config<"u"?O.Utilities.forEachProperty(a,(v,e)=>p.config[v]=e):p[o]=O.Utilities.recursiveClone(a)}),r.validateConfigurationOptions(p)}}O.ConfigurationOptionsUtil=r;class x{constructor(g,m){if(this._env=g,this.options=r.mergeConfigurationOptions(m),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let p=this.options.nodeRequire.main.filename,o=Math.max(p.lastIndexOf("/"),p.lastIndexOf("\\"));this.options.baseUrl=p.substring(0,o+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(g,m)=>{Array.isArray(m)?this.sortedPathsRules.push({from:g,to:m}):this.sortedPathsRules.push({from:g,to:[m]})}),this.sortedPathsRules.sort((g,m)=>m.from.length-g.from.length)}cloneAndMerge(g){return new x(this._env,r.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let m;for(let p=0,o=this.sortedPathsRules.length;p<o;p++)if(m=this.sortedPathsRules[p],O.Utilities.startsWith(g,m.from)){let a=[];for(let v=0,e=m.to.length;v<e;v++)a.push(m.to[v]+g.substr(m.from.length));return a}return[g]}_addUrlArgsToUrl(g){return O.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let m=0,p=g.length;m<p;m++)g[m]=this._addUrlArgsToUrl(g[m]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let m=g,p;if(!O.Utilities.endsWith(m,".js")&&!O.Utilities.isAbsolutePath(m)){p=this._applyPaths(m);for(let o=0,a=p.length;o<a;o++)this.isBuild()&&p[o]==="empty:"||(O.Utilities.isAbsolutePath(p[o])||(p[o]=this.options.baseUrl+p[o]),!O.Utilities.endsWith(p[o],".js")&&!O.Utilities.containsQueryString(p[o])&&(p[o]=p[o]+".js"))}else!O.Utilities.endsWith(m,".js")&&!O.Utilities.containsQueryString(m)&&(m=m+".js"),p=[m];return this._addUrlArgsIfNecessaryToUrls(p)}requireToUrl(g){let m=g;return O.Utilities.isAbsolutePath(m)||(m=this._applyPaths(m)[0],O.Utilities.isAbsolutePath(m)||(m=this.options.baseUrl+m)),this._addUrlArgsIfNecessaryToUrl(m)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}O.Configuration=x})(ue||(ue={}));var ue;(function(O){class n{constructor(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}load(a,v,e,f){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new A;else if(this._env.isElectronRenderer){const{preferScriptTags:u}=a.getConfig().getOptionsLiteral();u?this._scriptLoader=new r:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new r;let s={callback:e,errorback:f};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(s);return}this._callbackMap[v]=[s],this._scriptLoader.load(a,v,()=>this.triggerCallback(v),u=>this.triggerErrorback(v,u))}triggerCallback(a){let v=this._callbackMap[a];delete this._callbackMap[a];for(let e=0;e<v.length;e++)v[e].callback()}triggerErrorback(a,v){let e=this._callbackMap[a];delete this._callbackMap[a];for(let f=0;f<e.length;f++)e[f].errorback(v)}}class r{attachListeners(a,v,e){let f=()=>{a.removeEventListener("load",s),a.removeEventListener("error",u)},s=c=>{f(),v()},u=c=>{f(),e(c)};a.addEventListener("load",s),a.addEventListener("error",u)}load(a,v,e,f){if(/^node\|/.test(v)){let s=a.getConfig().getOptionsLiteral(),u=m(a.getRecorder(),s.nodeRequire||O.global.nodeRequire),c=v.split("|"),h=null;try{h=u(c[1])}catch(y){f(y);return}a.enqueueDefineAnonymousModule([],()=>h),e()}else{let s=document.createElement("script");s.setAttribute("async","async"),s.setAttribute("type","text/javascript"),this.attachListeners(s,e,f);const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();u&&(v=u.createScriptURL(v)),s.setAttribute("src",v);const{cspNonce:c}=a.getConfig().getOptionsLiteral();c&&s.setAttribute("nonce",c),document.getElementsByTagName("head")[0].appendChild(s)}}}function x(o){const{trustedTypesPolicy:a}=o.getConfig().getOptionsLiteral();try{return(a?self.eval(a.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class A{constructor(){this._cachedCanUseEval=null}_canUseEval(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=x(a)),this._cachedCanUseEval}load(a,v,e,f){if(/^node\|/.test(v)){const s=a.getConfig().getOptionsLiteral(),u=m(a.getRecorder(),s.nodeRequire||O.global.nodeRequire),c=v.split("|");let h=null;try{h=u(c[1])}catch(y){f(y);return}a.enqueueDefineAnonymousModule([],function(){return h}),e()}else{const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(a)){fetch(v).then(c=>{if(c.status!==200)throw new Error(c.statusText);return c.text()}).then(c=>{c=`${c}
//# sourceURL=${v}`,(s?self.eval(s.createScript("",c)):new Function(c)).call(self),e()}).then(void 0,f);return}try{s&&(v=s.createScriptURL(v)),importScripts(v),e()}catch(c){f(c)}}}}class g{constructor(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))}_initNodeRequire(a,v){const{nodeCachedData:e}=v.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const f=this,s=a("module");function u(c){const h=c.constructor;let y=function(N){try{return c.require(N)}finally{}};return y.resolve=function(N,R){return h._resolveFilename(N,c,!1,R)},y.resolve.paths=function(N){return h._resolveLookupPaths(N,c)},y.main=process.mainModule,y.extensions=h._extensions,y.cache=h._cache,y}s.prototype._compile=function(c,h){const y=s.wrap(c.replace(/^#!.*/,"")),C=v.getRecorder(),N=f._getCachedDataPath(e,h),R={filename:h};let w;try{const E=f._fs.readFileSync(N);w=E.slice(0,16),R.cachedData=E.slice(16),C.record(60,N)}catch{C.record(61,N)}const i=new f._vm.Script(y,R),l=i.runInThisContext(R),d=f._path.dirname(h),L=u(this),b=[this.exports,L,this,h,d,process,Ae,Buffer],_=l.apply(this.exports,b);return f._handleCachedData(i,y,N,!R.cachedData,v),f._verifyCachedData(i,y,N,w,v),_}}load(a,v,e,f){const s=a.getConfig().getOptionsLiteral(),u=m(a.getRecorder(),s.nodeRequire||O.global.nodeRequire),c=s.nodeInstrumenter||function(y){return y};this._init(u),this._initNodeRequire(u,a);let h=a.getRecorder();if(/^node\|/.test(v)){let y=v.split("|"),C=null;try{C=u(y[1])}catch(N){f(N);return}a.enqueueDefineAnonymousModule([],()=>C),e()}else{v=O.Utilities.fileUriToFilePath(this._env.isWindows,v);const y=this._path.normalize(v),C=this._getElectronRendererScriptPathOrUri(y),N=!!s.nodeCachedData,R=N?this._getCachedDataPath(s.nodeCachedData,v):void 0;this._readSourceAndCachedData(y,R,h,(w,i,l,d)=>{if(w){f(w);return}let L;i.charCodeAt(0)===g._BOM?L=g._PREFIX+i.substring(1)+g._SUFFIX:L=g._PREFIX+i+g._SUFFIX,L=c(L,y);const b={filename:C,cachedData:l},_=this._createAndEvalScript(a,L,b,e,f);this._handleCachedData(_,L,R,N&&!l,a),this._verifyCachedData(_,L,R,d,a)})}}_createAndEvalScript(a,v,e,f,s){const u=a.getRecorder();u.record(31,e.filename);const c=new this._vm.Script(v,e),h=c.runInThisContext(e),y=a.getGlobalAMDDefineFunc();let C=!1;const N=function(){return C=!0,y.apply(null,arguments)};return N.amd=y.amd,h.call(O.global,a.getGlobalAMDRequireFunc(),N,e.filename,this._path.dirname(e.filename)),u.record(32,e.filename),C?f():s(new Error(`Didn't receive define call in ${e.filename}!`)),c}_getElectronRendererScriptPathOrUri(a){if(!this._env.isElectronRenderer)return a;let v=a.match(/^([a-z])\:(.*)/i);return v?`file:///${(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/")}`:`file://${a}`}_getCachedDataPath(a,v){const e=this._crypto.createHash("md5").update(v,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),f=this._path.basename(v).replace(/\.js$/,"");return this._path.join(a.path,`${f}-${e}.code`)}_handleCachedData(a,v,e,f,s){a.cachedDataRejected?this._fs.unlink(e,u=>{s.getRecorder().record(62,e),this._createAndWriteCachedData(a,v,e,s),u&&s.getConfig().onError(u)}):f&&this._createAndWriteCachedData(a,v,e,s)}_createAndWriteCachedData(a,v,e,f){let s=Math.ceil(f.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),u=-1,c=0,h;const y=()=>{setTimeout(()=>{h||(h=this._crypto.createHash("md5").update(v,"utf8").digest());const C=a.createCachedData();if(!(C.length===0||C.length===u||c>=5)){if(C.length<u){y();return}u=C.length,this._fs.writeFile(e,Buffer.concat([h,C]),N=>{N&&f.getConfig().onError(N),f.getRecorder().record(63,e),y()})}},s*Math.pow(4,c++))};y()}_readSourceAndCachedData(a,v,e,f){if(!v)this._fs.readFile(a,{encoding:"utf8"},f);else{let s,u,c,h=2;const y=C=>{C?f(C):--h===0&&f(void 0,s,u,c)};this._fs.readFile(a,{encoding:"utf8"},(C,N)=>{s=N,y(C)}),this._fs.readFile(v,(C,N)=>{!C&&N&&N.length>0?(c=N.slice(0,16),u=N.slice(16),e.record(60,v)):e.record(61,v),y()})}}_verifyCachedData(a,v,e,f,s){f&&(a.cachedDataRejected||setTimeout(()=>{const u=this._crypto.createHash("md5").update(v,"utf8").digest();f.equals(u)||(s.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,c=>{c&&s.getConfig().onError(c)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function m(o,a){if(a.__$__isRecorded)return a;const v=function(f){o.record(33,f);try{return a(f)}finally{o.record(34,f)}};return v.__$__isRecorded=!0,v}O.ensureRecordedNodeRequire=m;function p(o){return new n(o)}O.createScriptLoader=p})(ue||(ue={}));var ue;(function(O){class n{constructor(o){let a=o.lastIndexOf("/");a!==-1?this.fromModulePath=o.substr(0,a+1):this.fromModulePath=""}static _normalizeModuleId(o){let a=o,v;for(v=/\/\.\//;v.test(a);)a=a.replace(v,"/");for(a=a.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(a);)a=a.replace(v,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a}resolveModule(o){let a=o;return O.Utilities.isAbsolutePath(a)||(O.Utilities.startsWith(a,"./")||O.Utilities.startsWith(a,"../"))&&(a=n._normalizeModuleId(this.fromModulePath+a)),a}}n.ROOT=new n(""),O.ModuleIdResolver=n;class r{constructor(o,a,v,e,f,s){this.id=o,this.strId=a,this.dependencies=v,this._callback=e,this._errorback=f,this.moduleIdResolver=s,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(o,a){try{return{returnedValue:o.apply(O.global,a),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}}static _invokeFactory(o,a,v,e){return o.shouldInvokeFactory(a)?o.shouldCatchError()?this._safeInvokeFunction(v,e):{returnedValue:v.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(o,a,v,e){this._isComplete=!0;let f=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);let s=r._invokeFactory(a,this.strId,this._callback,v);f=s.producedError,o.record(22,this.strId),!f&&typeof s.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=s.returnedValue)}else this.exports=this._callback;if(f){let s=O.ensureError(f);s.phase="factory",s.moduleId=this.strId,s.neededBy=e(this.id),this.error=s,a.onError(s)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1}isComplete(){return this._isComplete}}O.Module=r;class x{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(o){let a=this._strModuleIdToIntModuleId.get(o);return typeof a>"u"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(o,a),this._intModuleIdToStrModuleId[a]=o),a}getStrModuleId(o){return this._intModuleIdToStrModuleId[o]}}class A{constructor(o){this.id=o}}A.EXPORTS=new A(0),A.MODULE=new A(1),A.REQUIRE=new A(2),O.RegularDependency=A;class g{constructor(o,a,v){this.id=o,this.pluginId=a,this.pluginParam=v}}O.PluginDependency=g;class m{constructor(o,a,v,e,f=0){this._env=o,this._scriptLoader=a,this._loaderAvailableTimestamp=f,this._defineFunc=v,this._requireFunc=e,this._moduleIdProvider=new x,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(o,a){let v=s=>s.replace(/\\/g,"/"),e=v(o),f=a.split(/\n/);for(let s=0;s<f.length;s++){let u=f[s].match(/(.*):(\d+):(\d+)\)?$/);if(u){let c=u[1],h=u[2],y=u[3],C=Math.max(c.lastIndexOf(" ")+1,c.lastIndexOf("(")+1);if(c=c.substr(C),c=v(c),c===e){let N={line:parseInt(h,10),col:parseInt(y,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+o)}getBuildInfo(){if(!this._config.isBuild())return null;let o=[],a=0;for(let v=0,e=this._modules2.length;v<e;v++){let f=this._modules2[v];if(!f)continue;let s=this._buildInfoPath[f.id]||null,u=this._buildInfoDefineStack[f.id]||null,c=this._buildInfoDependencies[f.id];o[a++]={id:f.strId,path:s,defineLocation:s&&u?m._findRelevantLocationInStack(s,u):null,dependencies:c,shim:null,exports:f.exports}}return o}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(o,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:o,callback:a}}defineModule(o,a,v,e,f,s=new n(o)){let u=this._moduleIdProvider.getModuleId(o);if(this._modules2[u]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}let c=new r(u,o,this._normalizeDependencies(a,s),v,e,s);this._modules2[u]=c,this._config.isBuild()&&(this._buildInfoDefineStack[u]=f,this._buildInfoDependencies[u]=(c.dependencies||[]).map(h=>this._moduleIdProvider.getStrModuleId(h.id))),this._resolve(c)}_normalizeDependency(o,a){if(o==="exports")return A.EXPORTS;if(o==="module")return A.MODULE;if(o==="require")return A.REQUIRE;let v=o.indexOf("!");if(v>=0){let e=a.resolveModule(o.substr(0,v)),f=a.resolveModule(o.substr(v+1)),s=this._moduleIdProvider.getModuleId(e+"!"+f),u=this._moduleIdProvider.getModuleId(e);return new g(s,u,f)}return new A(this._moduleIdProvider.getModuleId(a.resolveModule(o)))}_normalizeDependencies(o,a){let v=[],e=0;for(let f=0,s=o.length;f<s;f++)v[e++]=this._normalizeDependency(o[f],a);return v}_relativeRequire(o,a,v,e){if(typeof a=="string")return this.synchronousRequire(a,o);this.defineModule(O.Utilities.generateAnonymousModule(),a,v,e,null,o)}synchronousRequire(o,a=new n(o)){let v=this._normalizeDependency(o,a),e=this._modules2[v.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(o,a){let v=this._config.shouldRecordStats();a?this._config=new O.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!v&&(this._recorder=null)}getConfig(){return this._config}_onLoad(o){if(this._currentAnonymousDefineCall!==null){let a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),a.dependencies,a.callback,null,a.stack)}}_createLoadError(o,a){let v=this._moduleIdProvider.getStrModuleId(o),e=(this._inverseDependencies2[o]||[]).map(s=>this._moduleIdProvider.getStrModuleId(s));const f=O.ensureError(a);return f.phase="loading",f.moduleId=v,f.neededBy=e,f}_onLoadError(o,a){const v=this._createLoadError(o,a);this._modules2[o]||(this._modules2[o]=new r(o,this._moduleIdProvider.getStrModuleId(o),[],()=>{},null,null));let e=[];for(let u=0,c=this._moduleIdProvider.getMaxModuleId();u<c;u++)e[u]=!1;let f=!1,s=[];for(s.push(o),e[o]=!0;s.length>0;){let u=s.shift(),c=this._modules2[u];c&&(f=c.onDependencyError(v)||f);let h=this._inverseDependencies2[u];if(h)for(let y=0,C=h.length;y<C;y++){let N=h[y];e[N]||(s.push(N),e[N]=!0)}}f||this._config.onError(v)}_hasDependencyPath(o,a){let v=this._modules2[o];if(!v)return!1;let e=[];for(let s=0,u=this._moduleIdProvider.getMaxModuleId();s<u;s++)e[s]=!1;let f=[];for(f.push(v),e[o]=!0;f.length>0;){let u=f.shift().dependencies;if(u)for(let c=0,h=u.length;c<h;c++){let y=u[c];if(y.id===a)return!0;let C=this._modules2[y.id];C&&!e[y.id]&&(e[y.id]=!0,f.push(C))}}return!1}_findCyclePath(o,a,v){if(o===a||v===50)return[o];let e=this._modules2[o];if(!e)return null;let f=e.dependencies;if(f)for(let s=0,u=f.length;s<u;s++){let c=this._findCyclePath(f[s].id,a,v+1);if(c!==null)return c.push(o),c}return null}_createRequire(o){let a=(v,e,f)=>this._relativeRequire(o,v,e,f);return a.toUrl=v=>this._config.requireToUrl(o.resolveModule(v)),a.getStats=()=>this.getLoaderEvents(),a.hasDependencyCycle=()=>this._hasDependencyCycle,a.config=(v,e=!1)=>{this.configure(v,e)},a.__$__nodeRequire=O.global.nodeRequire,a}_loadModule(o){if(this._modules2[o]||this._knownModules2[o])return;this._knownModules2[o]=!0;let a=this._moduleIdProvider.getStrModuleId(o),v=this._config.moduleIdToPaths(a),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(a.indexOf("/")===-1||e.test(a))&&v.push("node|"+a);let f=-1,s=u=>{if(f++,f>=v.length)this._onLoadError(o,u);else{let c=v[f],h=this.getRecorder();if(this._config.isBuild()&&c==="empty:"){this._buildInfoPath[o]=c,this.defineModule(this._moduleIdProvider.getStrModuleId(o),[],null,null,null),this._onLoad(o);return}h.record(10,c),this._scriptLoader.load(this,c,()=>{this._config.isBuild()&&(this._buildInfoPath[o]=c),h.record(11,c),this._onLoad(o)},y=>{h.record(12,c),s(y)})}};s(null)}_loadPluginDependency(o,a){if(this._modules2[a.id]||this._knownModules2[a.id])return;this._knownModules2[a.id]=!0;let v=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(a.id),[],e,null,null)};v.error=e=>{this._config.onError(this._createLoadError(a.id,e))},o.load(a.pluginParam,this._createRequire(n.ROOT),v,this._config.getOptionsLiteral())}_resolve(o){let a=o.dependencies;if(a)for(let v=0,e=a.length;v<e;v++){let f=a[v];if(f===A.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(f===A.MODULE){o.unresolvedDependenciesCount--;continue}if(f===A.REQUIRE){o.unresolvedDependenciesCount--;continue}let s=this._modules2[f.id];if(s&&s.isComplete()){if(s.error){o.onDependencyError(s.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");let u=this._findCyclePath(f.id,o.id,0)||[];u.reverse(),u.push(f.id),console.warn(u.map(c=>this._moduleIdProvider.getStrModuleId(c)).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(o.id),f instanceof g){let u=this._modules2[f.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,f);continue}let c=this._inversePluginDependencies2.get(f.pluginId);c||(c=[],this._inversePluginDependencies2.set(f.pluginId,c)),c.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}_onModuleComplete(o){let a=this.getRecorder();if(o.isComplete())return;let v=o.dependencies,e=[];if(v)for(let c=0,h=v.length;c<h;c++){let y=v[c];if(y===A.EXPORTS){e[c]=o.exports;continue}if(y===A.MODULE){e[c]={id:o.strId,config:()=>this._config.getConfigForModule(o.strId)};continue}if(y===A.REQUIRE){e[c]=this._createRequire(o.moduleIdResolver);continue}let C=this._modules2[y.id];if(C){e[c]=C.exports;continue}e[c]=null}const f=c=>(this._inverseDependencies2[c]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));o.complete(a,this._config,e,f);let s=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,s)for(let c=0,h=s.length;c<h;c++){let y=s[c],C=this._modules2[y];C.unresolvedDependenciesCount--,C.unresolvedDependenciesCount===0&&this._onModuleComplete(C)}let u=this._inversePluginDependencies2.get(o.id);if(u){this._inversePluginDependencies2.delete(o.id);for(let c=0,h=u.length;c<h;c++)this._loadPluginDependency(o.exports,u[c])}}}O.ModuleManager=m})(ue||(ue={}));var Y,ue;(function(O){const n=new O.Environment;let r=null;const x=function(p,o,a){typeof p!="string"&&(a=o,o=p,p=null),(typeof o!="object"||!Array.isArray(o))&&(a=o,o=null),o||(o=["require","exports","module"]),p?r.defineModule(p,o,a,null,null):r.enqueueDefineAnonymousModule(o,a)};x.amd={jQuery:!0};const A=function(p,o=!1){r.configure(p,o)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){A(arguments[0]);return}if(typeof arguments[0]=="string")return r.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){r.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=A,g.getConfig=function(){return r.getConfig().getOptionsLiteral()},g.reset=function(){r=r.reset()},g.getBuildInfo=function(){return r.getBuildInfo()},g.getStats=function(){return r.getLoaderEvents()},g.define=x;function m(){if(typeof O.global.require<"u"||typeof require<"u"){const p=O.global.require||require;if(typeof p=="function"&&typeof p.resolve=="function"){const o=O.ensureRecordedNodeRequire(r.getRecorder(),p);O.global.nodeRequire=o,g.nodeRequire=o,g.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=g:(n.isElectronRenderer||(O.global.define=x),O.global.require=g)}O.init=m,(typeof O.global.define!="function"||!O.global.define.amd)&&(r=new O.ModuleManager(n,O.createScriptLoader(n),x,g,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&g.config(O.global.require),Y=function(){return x.apply(null,arguments)},Y.amd=x.amd,typeof doNotInitLoader>"u"&&m())})(ue||(ue={})),Y(X[19],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.localize=v,n.localize2=e,n.getConfiguredDefaultLocale=f,n.setPseudoTranslation=s,n.create=u,n.load=c;let r=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const x="i-default";function A(h,y){let C;return y.length===0?C=h:C=h.replace(/\{(\d+)\}/g,(N,R)=>{const w=R[0],i=y[w];let l=N;return typeof i=="string"?l=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(l=String(i)),l}),r&&(C="\uFF3B"+C.replace(/[aouei]/g,"$&$&")+"\uFF3D"),C}function g(h,y){let C=h[y];return C||(C=h["*"],C)?C:null}function m(h){return h.charAt(h.length-1)==="/"?h:h+"/"}async function p(h,y,C){const N=m(h)+m(y)+"vscode/"+m(C),R=await fetch(N);if(R.ok)return await R.json();throw new Error(`${R.status} - ${R.statusText}`)}function o(h){return function(y,C){const N=Array.prototype.slice.call(arguments,2);return A(h[y],N)}}function a(h){return(y,C,...N)=>({value:A(h[y],N),original:A(C,N)})}function v(h,y,...C){return A(y,C)}function e(h,y,...C){const N=A(y,C);return{value:N,original:N}}function f(h){}function s(h){r=h}function u(h,y){var C;return{localize:o(y[h]),localize2:a(y[h]),getConfiguredDefaultLocale:(C=y.getConfiguredDefaultLocale)!==null&&C!==void 0?C:N=>{}}}function c(h,y,C,N){var R;const w=(R=N["vs/nls"])!==null&&R!==void 0?R:{};if(!h||h.length===0)return C({localize:v,localize2:e,getConfiguredDefaultLocale:()=>{var b;return(b=w.availableLanguages)===null||b===void 0?void 0:b["*"]}});const i=w.availableLanguages?g(w.availableLanguages,h):null,l=i===null||i===x;let d=".nls";l||(d=d+"."+i);const L=b=>{Array.isArray(b)?(b.localize=o(b),b.localize2=a(b)):(b.localize=o(b[h]),b.localize2=a(b[h])),b.getConfiguredDefaultLocale=()=>{var _;return(_=w.availableLanguages)===null||_===void 0?void 0:_["*"]},C(b)};typeof w.loadBundle=="function"?w.loadBundle(h,i,(b,_)=>{b?y([h+".nls"],L):L(_)}):w.translationServiceUrl&&!l?(async()=>{var b;try{const _=await p(w.translationServiceUrl,i,h);return L(_)}catch(_){if(!i.includes("-"))return console.error(_),y([h+".nls"],L);try{const E=i.split("-")[0],S=await p(w.translationServiceUrl,E,h);return(b=w.availableLanguages)!==null&&b!==void 0||(w.availableLanguages={}),w.availableLanguages["*"]=E,L(S)}catch(E){return console.error(E),y([h+".nls"],L)}}})():y([h+d],L,b=>{if(d===".nls"){console.error("Failed trying to load default language strings",b);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,b),y([h+".nls"],L)})}}),function(){const O=globalThis.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../";function r(v,e){var f;if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(v,e)}catch(s){console.warn(s);return}try{return(f=self.trustedTypes)===null||f===void 0?void 0:f.createPolicy(v,e)}catch(s){console.warn(s);return}}const x=r("amdLoader",{createScriptURL:v=>v,createScript:(v,...e)=>{const f=e.slice(0,-1).join(","),s=e.pop().toString();return`(function anonymous(${f}) { ${s}
})`}});function A(){try{return(x?globalThis.eval(x.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((v,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return v();const f=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,globalThis.origin.length)!==globalThis.origin)&&A()){fetch(f).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${f}`,(x?globalThis.eval(x.createScript("",u)):new Function(u)).call(globalThis),v()}).then(void 0,e);return}x?importScripts(x.createScriptURL(f)):importScripts(f),v()})}function m(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:x,amdModulesPattern:/^vs\//})}function p(v){g().then(()=>{m(),require([v],function(e){setTimeout(function(){const f=e.create((s,u)=>{globalThis.postMessage(s,u)},null);for(globalThis.onmessage=s=>f.onmessage(s.data,s.ports);a.length>0;){const s=a.shift();f.onmessage(s.data,s.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&m();let o=!0;const a=[];globalThis.onmessage=v=>{if(!o){a.push(v);return}o=!1,p(v.data)}}(),Y(X[7],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Permutation=n.CallbackIterable=n.ArrayQueue=n.booleanComparator=n.numberComparator=n.CompareResult=void 0,n.tail=r,n.tail2=x,n.equals=A,n.removeFastWithoutKeepingOrder=g,n.binarySearch=m,n.binarySearch2=p,n.quickSelect=o,n.groupBy=a,n.groupAdjacentBy=v,n.forEachAdjacent=e,n.forEachWithNeighbors=f,n.coalesce=s,n.coalesceInPlace=u,n.isFalsyOrEmpty=c,n.isNonEmptyArray=h,n.distinct=y,n.firstOrDefault=C,n.range=N,n.arrayInsert=R,n.pushToStart=w,n.pushToEnd=i,n.pushMany=l,n.asArray=d,n.insertInto=L,n.splice=b,n.compareBy=S,n.tieBreakComparators=M,n.reverseOrder=k;function r(F,I=0){return F[F.length-(1+I)]}function x(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}function A(F,I,W=(V,z)=>V===z){if(F===I)return!0;if(!F||!I||F.length!==I.length)return!1;for(let V=0,z=F.length;V<z;V++)if(!W(F[V],I[V]))return!1;return!0}function g(F,I){const W=F.length-1;I<W&&(F[I]=F[W]),F.pop()}function m(F,I,W){return p(F.length,V=>W(F[V],I))}function p(F,I){let W=0,V=F-1;for(;W<=V;){const z=(W+V)/2|0,U=I(z);if(U<0)W=z+1;else if(U>0)V=z-1;else return z}return-(W+1)}function o(F,I,W){if(F=F|0,F>=I.length)throw new TypeError("invalid index");const V=I[Math.floor(I.length*Math.random())],z=[],U=[],se=[];for(const he of I){const de=W(he,V);de<0?z.push(he):de>0?U.push(he):se.push(he)}return F<z.length?o(F,z,W):F<z.length+se.length?se[0]:o(F-(z.length+se.length),U,W)}function a(F,I){const W=[];let V;for(const z of F.slice(0).sort(I))!V||I(V[0],z)!==0?(V=[z],W.push(V)):V.push(z);return W}function*v(F,I){let W,V;for(const z of F)V!==void 0&&I(V,z)?W.push(z):(W&&(yield W),W=[z]),V=z;W&&(yield W)}function e(F,I){for(let W=0;W<=F.length;W++)I(W===0?void 0:F[W-1],W===F.length?void 0:F[W])}function f(F,I){for(let W=0;W<F.length;W++)I(W===0?void 0:F[W-1],F[W],W+1===F.length?void 0:F[W+1])}function s(F){return F.filter(I=>!!I)}function u(F){let I=0;for(let W=0;W<F.length;W++)F[W]&&(F[I]=F[W],I+=1);F.length=I}function c(F){return!Array.isArray(F)||F.length===0}function h(F){return Array.isArray(F)&&F.length>0}function y(F,I=W=>W){const W=new Set;return F.filter(V=>{const z=I(V);return W.has(z)?!1:(W.add(z),!0)})}function C(F,I){return F.length>0?F[0]:I}function N(F,I){let W=typeof I=="number"?F:0;typeof I=="number"?W=F:(W=0,I=F);const V=[];if(W<=I)for(let z=W;z<I;z++)V.push(z);else for(let z=W;z>I;z--)V.push(z);return V}function R(F,I,W){const V=F.slice(0,I),z=F.slice(I);return V.concat(W,z)}function w(F,I){const W=F.indexOf(I);W>-1&&(F.splice(W,1),F.unshift(I))}function i(F,I){const W=F.indexOf(I);W>-1&&(F.splice(W,1),F.push(I))}function l(F,I){for(const W of I)F.push(W)}function d(F){return Array.isArray(F)?F:[F]}function L(F,I,W){const V=_(F,I),z=F.length,U=W.length;F.length=z+U;for(let se=z-1;se>=V;se--)F[se+U]=F[se];for(let se=0;se<U;se++)F[se+V]=W[se]}function b(F,I,W,V){const z=_(F,I);let U=F.splice(z,W);return U===void 0&&(U=[]),L(F,z,V),U}function _(F,I){return I<0?Math.max(I+F.length,0):Math.min(I,F.length)}var E;(function(F){function I(U){return U<0}F.isLessThan=I;function W(U){return U<=0}F.isLessThanOrEqual=W;function V(U){return U>0}F.isGreaterThan=V;function z(U){return U===0}F.isNeitherLessOrGreaterThan=z,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(E||(n.CompareResult=E={}));function S(F,I){return(W,V)=>I(F(W),F(V))}function M(...F){return(I,W)=>{for(const V of F){const z=V(I,W);if(!E.isNeitherLessOrGreaterThan(z))return z}return E.neitherLessOrGreaterThan}}const D=(F,I)=>F-I;n.numberComparator=D;const T=(F,I)=>(0,n.numberComparator)(F?1:0,I?1:0);n.booleanComparator=T;function k(F){return(I,W)=>-F(I,W)}class q{constructor(I){this.items=I,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(I){let W=this.firstIdx;for(;W<this.items.length&&I(this.items[W]);)W++;const V=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,V}takeFromEndWhile(I){let W=this.lastIdx;for(;W>=0&&I(this.items[W]);)W--;const V=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const I=this.items[this.firstIdx];return this.firstIdx++,I}takeCount(I){const W=this.items.slice(this.firstIdx,this.firstIdx+I);return this.firstIdx+=I,W}}n.ArrayQueue=q;class H{constructor(I){this.iterate=I}toArray(){const I=[];return this.iterate(W=>(I.push(W),!0)),I}filter(I){return new H(W=>this.iterate(V=>I(V)?W(V):!0))}map(I){return new H(W=>this.iterate(V=>W(I(V))))}findLast(I){let W;return this.iterate(V=>(I(V)&&(W=V),!0)),W}findLastMaxBy(I){let W,V=!0;return this.iterate(z=>((V||E.isGreaterThan(I(z,W)))&&(V=!1,W=z),!0)),W}}n.CallbackIterable=H,H.empty=new H(F=>{});class Q{constructor(I){this._indexMap=I}static createSortPermutation(I,W){const V=Array.from(I.keys()).sort((z,U)=>W(I[z],I[U]));return new Q(V)}apply(I){return I.map((W,V)=>I[this._indexMap[V]])}inverse(){const I=this._indexMap.slice();for(let W=0;W<this._indexMap.length;W++)I[this._indexMap[W]]=W;return new Q(I)}}n.Permutation=Q}),Y(X[11],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MonotonousArray=void 0,n.findLast=r,n.findLastIdx=x,n.findLastMonotonous=A,n.findLastIdxMonotonous=g,n.findFirstMonotonous=m,n.findFirstIdxMonotonousOrArrLen=p,n.findFirstMax=a,n.findLastMax=v,n.findFirstMin=e,n.findMaxIdx=f,n.mapFindFirst=s;function r(u,c){const h=x(u,c);if(h!==-1)return u[h]}function x(u,c,h=u.length-1){for(let y=h;y>=0;y--){const C=u[y];if(c(C))return y}return-1}function A(u,c){const h=g(u,c);return h===-1?void 0:u[h]}function g(u,c,h=0,y=u.length){let C=h,N=y;for(;C<N;){const R=Math.floor((C+N)/2);c(u[R])?C=R+1:N=R}return C-1}function m(u,c){const h=p(u,c);return h===u.length?void 0:u[h]}function p(u,c,h=0,y=u.length){let C=h,N=y;for(;C<N;){const R=Math.floor((C+N)/2);c(u[R])?N=R:C=R+1}return C}class o{constructor(c){this._array=c,this._findLastMonotonousLastIdx=0}findLastMonotonous(c){if(o.assertInvariants){if(this._prevFindLastPredicate){for(const y of this._array)if(this._prevFindLastPredicate(y)&&!c(y))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=c}const h=g(this._array,c,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=h+1,h===-1?void 0:this._array[h]}}n.MonotonousArray=o,o.assertInvariants=!1;function a(u,c){if(u.length===0)return;let h=u[0];for(let y=1;y<u.length;y++){const C=u[y];c(C,h)>0&&(h=C)}return h}function v(u,c){if(u.length===0)return;let h=u[0];for(let y=1;y<u.length;y++){const C=u[y];c(C,h)>=0&&(h=C)}return h}function e(u,c){return a(u,(h,y)=>-c(h,y))}function f(u,c){if(u.length===0)return-1;let h=0;for(let y=1;y<u.length;y++){const C=u[y];c(C,u[h])>0&&(h=y)}return h}function s(u,c){for(const h of u){const y=c(h);if(y!==void 0)return y}}}),Y(X[34],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0,n.identity=r;function r(g){return g}class x{constructor(m,p){this.lastCache=void 0,this.lastArgKey=void 0,typeof m=="function"?(this._fn=m,this._computeKey=r):(this._fn=p,this._computeKey=m.getCacheKey)}get(m){const p=this._computeKey(m);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this._fn(m)),this.lastCache}}n.LRUCachedFunction=x;class A{get cachedValues(){return this._map}constructor(m,p){this._map=new Map,this._map2=new Map,typeof m=="function"?(this._fn=m,this._computeKey=r):(this._fn=p,this._computeKey=m.getCacheKey)}get(m){const p=this._computeKey(m);if(this._map2.has(p))return this._map2.get(p);const o=this._fn(m);return this._map.set(m,o),this._map2.set(p,o),o}}n.CachedFunction=A}),Y(X[35],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function r(p,o){const a=Math.pow(10,o);return Math.round(p*a)/a}class x{constructor(o,a,v,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,o))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=r(Math.max(Math.min(1,e),0),3)}static equals(o,a){return o.r===a.r&&o.g===a.g&&o.b===a.b&&o.a===a.a}}n.RGBA=x;class A{constructor(o,a,v,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=r(Math.max(Math.min(1,a),0),3),this.l=r(Math.max(Math.min(1,v),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(o,a){return o.h===a.h&&o.s===a.s&&o.l===a.l&&o.a===a.a}static fromRGBA(o){const a=o.r/255,v=o.g/255,e=o.b/255,f=o.a,s=Math.max(a,v,e),u=Math.min(a,v,e);let c=0,h=0;const y=(u+s)/2,C=s-u;if(C>0){switch(h=Math.min(y<=.5?C/(2*y):C/(2-2*y),1),s){case a:c=(v-e)/C+(v<e?6:0);break;case v:c=(e-a)/C+2;break;case e:c=(a-v)/C+4;break}c*=60,c=Math.round(c)}return new A(c,h,y,f)}static _hue2rgb(o,a,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?o+(a-o)*6*v:v<1/2?a:v<2/3?o+(a-o)*(2/3-v)*6:o}static toRGBA(o){const a=o.h/360,{s:v,l:e,a:f}=o;let s,u,c;if(v===0)s=u=c=e;else{const h=e<.5?e*(1+v):e+v-e*v,y=2*e-h;s=A._hue2rgb(y,h,a+1/3),u=A._hue2rgb(y,h,a),c=A._hue2rgb(y,h,a-1/3)}return new x(Math.round(s*255),Math.round(u*255),Math.round(c*255),f)}}n.HSLA=A;class g{constructor(o,a,v,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=r(Math.max(Math.min(1,a),0),3),this.v=r(Math.max(Math.min(1,v),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(o,a){return o.h===a.h&&o.s===a.s&&o.v===a.v&&o.a===a.a}static fromRGBA(o){const a=o.r/255,v=o.g/255,e=o.b/255,f=Math.max(a,v,e),s=Math.min(a,v,e),u=f-s,c=f===0?0:u/f;let h;return u===0?h=0:f===a?h=((v-e)/u%6+6)%6:f===v?h=(e-a)/u+2:h=(a-v)/u+4,new g(Math.round(h*60),c,f,o.a)}static toRGBA(o){const{h:a,s:v,v:e,a:f}=o,s=e*v,u=s*(1-Math.abs(a/60%2-1)),c=e-s;let[h,y,C]=[0,0,0];return a<60?(h=s,y=u):a<120?(h=u,y=s):a<180?(y=s,C=u):a<240?(y=u,C=s):a<300?(h=u,C=s):a<=360&&(h=s,C=u),h=Math.round((h+c)*255),y=Math.round((y+c)*255),C=Math.round((C+c)*255),new x(h,y,C,f)}}n.HSVA=g;class m{static fromHex(o){return m.Format.CSS.parseHex(o)||m.red}static equals(o,a){return!o&&!a?!0:!o||!a?!1:o.equals(a)}get hsla(){return this._hsla?this._hsla:A.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:g.fromRGBA(this.rgba)}constructor(o){if(o)if(o instanceof x)this.rgba=o;else if(o instanceof A)this._hsla=o,this.rgba=A.toRGBA(o);else if(o instanceof g)this._hsva=o,this.rgba=g.toRGBA(o);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(o){return!!o&&x.equals(this.rgba,o.rgba)&&A.equals(this.hsla,o.hsla)&&g.equals(this.hsva,o.hsva)}getRelativeLuminance(){const o=m._relativeLuminanceForComponent(this.rgba.r),a=m._relativeLuminanceForComponent(this.rgba.g),v=m._relativeLuminanceForComponent(this.rgba.b),e=.2126*o+.7152*a+.0722*v;return r(e,4)}static _relativeLuminanceForComponent(o){const a=o/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(o){const a=this.getRelativeLuminance(),v=o.getRelativeLuminance();return a>v}isDarkerThan(o){const a=this.getRelativeLuminance(),v=o.getRelativeLuminance();return a<v}lighten(o){return new m(new A(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*o,this.hsla.a))}darken(o){return new m(new A(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*o,this.hsla.a))}transparent(o){const{r:a,g:v,b:e,a:f}=this.rgba;return new m(new x(a,v,e,f*o))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new m(new x(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(o){if(this.isOpaque()||o.rgba.a!==1)return this;const{r:a,g:v,b:e,a:f}=this.rgba;return new m(new x(o.rgba.r-f*(o.rgba.r-a),o.rgba.g-f*(o.rgba.g-v),o.rgba.b-f*(o.rgba.b-e),1))}toString(){return this._toString||(this._toString=m.Format.CSS.format(this)),this._toString}static getLighterColor(o,a,v){if(o.isLighterThan(a))return o;v=v||.5;const e=o.getRelativeLuminance(),f=a.getRelativeLuminance();return v=v*(f-e)/f,o.lighten(v)}static getDarkerColor(o,a,v){if(o.isDarkerThan(a))return o;v=v||.5;const e=o.getRelativeLuminance(),f=a.getRelativeLuminance();return v=v*(e-f)/e,o.darken(v)}}n.Color=m,m.white=new m(new x(255,255,255,1)),m.black=new m(new x(0,0,0,1)),m.red=new m(new x(255,0,0,1)),m.blue=new m(new x(0,0,255,1)),m.green=new m(new x(0,255,0,1)),m.cyan=new m(new x(0,255,255,1)),m.lightgrey=new m(new x(211,211,211,1)),m.transparent=new m(new x(0,0,0,0)),function(p){let o;(function(a){let v;(function(e){function f(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:p.Format.CSS.formatRGBA(i)}e.formatRGB=f;function s(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}e.formatRGBA=s;function u(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:p.Format.CSS.formatHSLA(i)}e.formatHSL=u;function c(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}e.formatHSLA=c;function h(i){const l=i.toString(16);return l.length!==2?"0"+l:l}function y(i){return`#${h(i.rgba.r)}${h(i.rgba.g)}${h(i.rgba.b)}`}e.formatHex=y;function C(i,l=!1){return l&&i.rgba.a===1?p.Format.CSS.formatHex(i):`#${h(i.rgba.r)}${h(i.rgba.g)}${h(i.rgba.b)}${h(Math.round(i.rgba.a*255))}`}e.formatHexA=C;function N(i){return i.isOpaque()?p.Format.CSS.formatHex(i):p.Format.CSS.formatRGBA(i)}e.format=N;function R(i){const l=i.length;if(l===0||i.charCodeAt(0)!==35)return null;if(l===7){const d=16*w(i.charCodeAt(1))+w(i.charCodeAt(2)),L=16*w(i.charCodeAt(3))+w(i.charCodeAt(4)),b=16*w(i.charCodeAt(5))+w(i.charCodeAt(6));return new p(new x(d,L,b,1))}if(l===9){const d=16*w(i.charCodeAt(1))+w(i.charCodeAt(2)),L=16*w(i.charCodeAt(3))+w(i.charCodeAt(4)),b=16*w(i.charCodeAt(5))+w(i.charCodeAt(6)),_=16*w(i.charCodeAt(7))+w(i.charCodeAt(8));return new p(new x(d,L,b,_/255))}if(l===4){const d=w(i.charCodeAt(1)),L=w(i.charCodeAt(2)),b=w(i.charCodeAt(3));return new p(new x(16*d+d,16*L+L,16*b+b))}if(l===5){const d=w(i.charCodeAt(1)),L=w(i.charCodeAt(2)),b=w(i.charCodeAt(3)),_=w(i.charCodeAt(4));return new p(new x(16*d+d,16*L+L,16*b+b,(16*_+_)/255))}return null}e.parseHex=R;function w(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=a.CSS||(a.CSS={}))})(o=p.Format||(p.Format={}))}(m||(n.Color=m={}))}),Y(X[36],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class r{constructor(A,g,m,p){this.originalStart=A,this.originalLength=g,this.modifiedStart=m,this.modifiedLength=p}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=r}),Y(X[5],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.CancellationError=n.errorHandler=n.ErrorHandler=void 0,n.onUnexpectedError=x,n.onUnexpectedExternalError=A,n.transformErrorForSerialization=g,n.isCancellationError=p,n.canceled=a,n.illegalArgument=v,n.illegalState=e;class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(h){setTimeout(()=>{throw h.stack?s.isErrorNoTelemetry(h)?new s(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}emit(h){this.listeners.forEach(y=>{y(h)})}onUnexpectedError(h){this.unexpectedErrorHandler(h),this.emit(h)}onUnexpectedExternalError(h){this.unexpectedErrorHandler(h)}}n.ErrorHandler=r,n.errorHandler=new r;function x(c){p(c)||n.errorHandler.onUnexpectedError(c)}function A(c){p(c)||n.errorHandler.onUnexpectedExternalError(c)}function g(c){if(c instanceof Error){const{name:h,message:y}=c,C=c.stacktrace||c.stack;return{$isError:!0,name:h,message:y,stack:C,noTelemetry:s.isErrorNoTelemetry(c)}}return c}const m="Canceled";function p(c){return c instanceof o?!0:c instanceof Error&&c.name===m&&c.message===m}class o extends Error{constructor(){super(m),this.name=this.message}}n.CancellationError=o;function a(){const c=new Error(m);return c.name=c.message,c}function v(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}function e(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}class f extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}n.NotSupportedError=f;class s extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof s)return h;const y=new s;return y.message=h.message,y.stack=h.stack,y}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}n.ErrorNoTelemetry=s;class u extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}n.BugIndicatingError=u}),Y(X[12],Z([0,1,5]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ok=x,n.assertNever=A,n.softAssert=g,n.assertFn=m,n.checkAdjacentItems=p;function x(o,a){if(!o)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}function A(o,a="Unreachable"){throw new Error(a)}function g(o){o||(0,r.onUnexpectedError)(new r.BugIndicatingError("Soft Assertion Failed"))}function m(o){if(!o()){debugger;o(),(0,r.onUnexpectedError)(new r.BugIndicatingError("Assertion Failed"))}}function p(o,a){let v=0;for(;v<o.length-1;){const e=o[v],f=o[v+1];if(!a(e,f))return!1;v++}return!0}}),Y(X[20],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createSingleCallFunction=r;function r(x,A){const g=this;let m=!1,p;return function(){if(m)return p;if(m=!0,A)try{p=x.apply(g,arguments)}finally{A()}else p=x.apply(g,arguments);return p}}}),Y(X[21],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var r;(function(x){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}x.is=A;const g=Object.freeze([]);function m(){return g}x.empty=m;function*p(i){yield i}x.single=p;function o(i){return A(i)?i:p(i)}x.wrap=o;function a(i){return i||g}x.from=a;function*v(i){for(let l=i.length-1;l>=0;l--)yield i[l]}x.reverse=v;function e(i){return!i||i[Symbol.iterator]().next().done===!0}x.isEmpty=e;function f(i){return i[Symbol.iterator]().next().value}x.first=f;function s(i,l){for(const d of i)if(l(d))return!0;return!1}x.some=s;function u(i,l){for(const d of i)if(l(d))return d}x.find=u;function*c(i,l){for(const d of i)l(d)&&(yield d)}x.filter=c;function*h(i,l){let d=0;for(const L of i)yield l(L,d++)}x.map=h;function*y(...i){for(const l of i)yield*l}x.concat=y;function C(i,l,d){let L=d;for(const b of i)L=l(L,b);return L}x.reduce=C;function*N(i,l,d=i.length){for(l<0&&(l+=i.length),d<0?d+=i.length:d>i.length&&(d=i.length);l<d;l++)yield i[l]}x.slice=N;function R(i,l=Number.POSITIVE_INFINITY){const d=[];if(l===0)return[d,i];const L=i[Symbol.iterator]();for(let b=0;b<l;b++){const _=L.next();if(_.done)return[d,x.empty()];d.push(_.value)}return[d,{[Symbol.iterator](){return L}}]}x.consume=R;async function w(i){const l=[];for await(const d of i)l.push(d);return Promise.resolve(l)}x.asyncToArray=w})(r||(n.Iterable=r={}))}),Y(X[37],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0,n.KeyChord=v;class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(f,s){this._keyCodeToStr[f]=s,this._strToKeyCode[s.toLowerCase()]=f}keyCodeToStr(f){return this._keyCodeToStr[f]}strToKeyCode(f){return this._strToKeyCode[f.toLowerCase()]||0}}const x=new r,A=new r,g=new r;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],p=Object.create(null),o=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",f=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],s=[],u=[];for(const c of f){const[h,y,C,N,R,w,i,l,d]=c;if(u[y]||(u[y]=!0,m[y]=C,p[C]=y,o[C.toLowerCase()]=y,h&&(n.IMMUTABLE_CODE_TO_KEY_CODE[y]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[N]=y))),!s[N]){if(s[N]=!0,!R)throw new Error(`String representation missing for key code ${N} around scan code ${C}`);x.define(N,R),A.define(N,l||R),g.define(N,d||l||R)}w&&(n.EVENT_KEY_CODE_MAP[w]=N),i&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[i]=N)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var a;(function(e){function f(C){return x.keyCodeToStr(C)}e.toString=f;function s(C){return x.strToKeyCode(C)}e.fromString=s;function u(C){return A.keyCodeToStr(C)}e.toUserSettingsUS=u;function c(C){return g.keyCodeToStr(C)}e.toUserSettingsGeneral=c;function h(C){return A.strToKeyCode(C)||g.strToKeyCode(C)}e.fromUserSettings=h;function y(C){if(C>=98&&C<=113)return null;switch(C){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return x.keyCodeToStr(C)}e.toElectronAccelerator=y})(a||(n.KeyCodeUtils=a={}));function v(e,f){const s=(f&65535)<<16>>>0;return(e|s)>>>0}}),Y(X[38],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class r{constructor(A){this.executor=A,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=r}),Y(X[13],Z([0,1,20,21]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=void 0,n.setDisposableTracker=m,n.trackDisposable=p,n.markAsDisposed=o,n.markAsSingleton=e,n.isDisposable=f,n.dispose=s,n.combinedDisposable=u,n.toDisposable=c;const A=!1;let g=null;function m(i){g=i}if(A){const i="__is_disposable_tracked__";m(new class{trackDisposable(l){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[i]||console.log(d)},3e3)}setParent(l,d){if(l&&l!==y.None)try{l[i]=!0}catch{}}markAsDisposed(l){if(l&&l!==y.None)try{l[i]=!0}catch{}}markAsSingleton(l){}})}function p(i){return g?.trackDisposable(i),i}function o(i){g?.markAsDisposed(i)}function a(i,l){g?.setParent(i,l)}function v(i,l){if(g)for(const d of i)g.setParent(d,l)}function e(i){return g?.markAsSingleton(i),i}function f(i){return typeof i=="object"&&i!==null&&typeof i.dispose=="function"&&i.dispose.length===0}function s(i){if(x.Iterable.is(i)){const l=[];for(const d of i)if(d)try{d.dispose()}catch(L){l.push(L)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}function u(...i){const l=c(()=>s(i));return v(i,l),l}function c(i){const l=p({dispose:(0,r.createSingleCallFunction)(()=>{o(l),i()})});return l}class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,p(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{s(this._toDispose)}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return a(l,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}deleteAndLeak(l){l&&this._toDispose.has(l)&&(this._toDispose.delete(l),a(l,null))}}n.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new h,p(this),a(this._store,this)}dispose(){o(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}n.Disposable=y,y.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var d;this._isDisposed||l===this._value||((d=this._value)===null||d===void 0||d.dispose(),l&&a(l,this),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,o(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}n.MutableDisposable=C;class N{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=N;class R{constructor(l){this.object=l}dispose(){}}n.ImmortalReference=R;class w{constructor(){this._store=new Map,this._isDisposed=!1,p(this)}dispose(){o(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{s(this._store.values())}finally{this._store.clear()}}get(l){return this._store.get(l)}set(l,d,L=!1){var b;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||(b=this._store.get(l))===null||b===void 0||b.dispose(),this._store.set(l,d)}deleteAndDispose(l){var d;(d=this._store.get(l))===null||d===void 0||d.dispose(),this._store.delete(l)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=w}),Y(X[22],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class r{constructor(g){this.element=g,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class x{constructor(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){let g=this._first;for(;g!==r.Undefined;){const m=g.next;g.prev=r.Undefined,g.next=r.Undefined,g=m}this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(g){return this._insert(g,!1)}push(g){return this._insert(g,!0)}_insert(g,m){const p=new r(g);if(this._first===r.Undefined)this._first=p,this._last=p;else if(m){const a=this._last;this._last=p,p.prev=a,a.next=p}else{const a=this._first;this._first=p,p.next=a,a.prev=p}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(p))}}shift(){if(this._first!==r.Undefined){const g=this._first.element;return this._remove(this._first),g}}pop(){if(this._last!==r.Undefined){const g=this._last.element;return this._remove(this._last),g}}_remove(g){if(g.prev!==r.Undefined&&g.next!==r.Undefined){const m=g.prev;m.next=g.next,g.next.prev=m}else g.prev===r.Undefined&&g.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):g.next===r.Undefined?(this._last=this._last.prev,this._last.next=r.Undefined):g.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}*[Symbol.iterator](){let g=this._first;for(;g!==r.Undefined;)yield g.element,g=g.next}}n.LinkedList=x}),Y(X[23],Z([0,1]),function(O,n){"use strict";var r,x;Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=n.BidirectionalMap=n.LRUCache=n.LinkedMap=n.ResourceMap=void 0;class A{constructor(s,u){this.uri=s,this.value=u}}function g(f){return Array.isArray(f)}class m{constructor(s,u){if(this[r]="ResourceMap",s instanceof m)this.map=new Map(s.map),this.toKey=u??m.defaultToKey;else if(g(s)){this.map=new Map,this.toKey=u??m.defaultToKey;for(const[c,h]of s)this.set(c,h)}else this.map=new Map,this.toKey=s??m.defaultToKey}set(s,u){return this.map.set(this.toKey(s),new A(s,u)),this}get(s){var u;return(u=this.map.get(this.toKey(s)))===null||u===void 0?void 0:u.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,u){typeof u<"u"&&(s=s.bind(u));for(const[c,h]of this.map)s(h.value,h.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}n.ResourceMap=m,m.defaultToKey=f=>f.toString();class p{constructor(){this[x]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,u=0){const c=this._map.get(s);if(c)return u!==0&&this.touch(c,u),c.value}set(s,u,c=0){let h=this._map.get(s);if(h)h.value=u,c!==0&&this.touch(h,c);else{switch(h={key:s,value:u,next:void 0,previous:void 0},c){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(s,h),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const u=this._map.get(s);if(u)return this._map.delete(s),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,u){const c=this._state;let h=this._head;for(;h;){if(u?s.bind(u)(h.value,h.key,this):s(h.value,h.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const s=this,u=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:c.key,done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return h}values(){const s=this,u=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:c.value,done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return h}entries(){const s=this,u=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:[c.key,c.value],done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return h}[(x=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let u=this._head,c=this.size;for(;u&&c>s;)this._map.delete(u.key),u=u.next,c--;this._head=u,this._size=c,u&&(u.previous=void 0),this._state++}trimNew(s){if(s>=this.size)return;if(s===0){this.clear();return}let u=this._tail,c=this.size;for(;u&&c>s;)this._map.delete(u.key),u=u.previous,c--;this._tail=u,this._size=c,u&&(u.next=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const u=s.next,c=s.previous;if(!u||!c)throw new Error("Invalid list");u.previous=c,c.next=u}s.next=void 0,s.previous=void 0,this._state++}touch(s,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(s===this._head)return;const c=s.next,h=s.previous;s===this._tail?(h.next=void 0,this._tail=h):(c.previous=h,h.next=c),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(u===2){if(s===this._tail)return;const c=s.next,h=s.previous;s===this._head?(c.previous=void 0,this._head=c):(c.previous=h,h.next=c),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((u,c)=>{s.push([c,u])}),s}fromJSON(s){this.clear();for(const[u,c]of s)this.set(u,c)}}n.LinkedMap=p;class o extends p{constructor(s,u=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get(s,u=2){return super.get(s,u)}peek(s){return super.get(s,0)}set(s,u){return super.set(s,u,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class a extends o{constructor(s,u=1){super(s,u)}trim(s){this.trimOld(s)}set(s,u){return super.set(s,u),this.checkTrim(),this}}n.LRUCache=a;class v{constructor(s){if(this._m1=new Map,this._m2=new Map,s)for(const[u,c]of s)this.set(u,c)}clear(){this._m1.clear(),this._m2.clear()}set(s,u){this._m1.set(s,u),this._m2.set(u,s)}get(s){return this._m1.get(s)}getKey(s){return this._m2.get(s)}delete(s){const u=this._m1.get(s);return u===void 0?!1:(this._m1.delete(s),this._m2.delete(u),!0)}keys(){return this._m1.keys()}values(){return this._m1.values()}}n.BidirectionalMap=v;class e{constructor(){this.map=new Map}add(s,u){let c=this.map.get(s);c||(c=new Set,this.map.set(s,c)),c.add(u)}delete(s,u){const c=this.map.get(s);c&&(c.delete(u),c.size===0&&this.map.delete(s))}forEach(s,u){const c=this.map.get(s);c&&c.forEach(u)}get(s){const u=this.map.get(s);return u||new Set}}n.SetMap=e}),Y(X[24],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class x{static create(g){return new x(g)}constructor(g){this._now=r&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=x}),Y(X[9],Z([0,1,5,20,13,22,24]),function(O,n,r,x,A,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const p=!1,o=!1,a=!1;var v;(function(E){E.None=()=>A.Disposable.None;function S(K){if(a){const{onDidAddListener:$}=K,ee=u.create();let J=0;K.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),$?.()}}}function M(K,$){return V(K,()=>{},0,void 0,!0,void 0,$)}E.defer=M;function D(K){return($,ee=null,J)=>{let re=!1,ne;return ne=K(ie=>{if(!re)return ne?ne.dispose():re=!0,$.call(ee,ie)},null,J),re&&ne.dispose(),ne}}E.once=D;function T(K,$,ee){return I((J,re=null,ne)=>K(ie=>J.call(re,$(ie)),null,ne),ee)}E.map=T;function k(K,$,ee){return I((J,re=null,ne)=>K(ie=>{$(ie),J.call(re,ie)},null,ne),ee)}E.forEach=k;function q(K,$,ee){return I((J,re=null,ne)=>K(ie=>$(ie)&&J.call(re,ie),null,ne),ee)}E.filter=q;function H(K){return K}E.signal=H;function Q(...K){return($,ee=null,J)=>{const re=(0,A.combinedDisposable)(...K.map(ne=>ne(ie=>$.call(ee,ie))));return W(re,J)}}E.any=Q;function F(K,$,ee,J){let re=ee;return T(K,ne=>(re=$(re,ne),re),J)}E.reduce=F;function I(K,$){let ee;const J={onWillAddFirstListener(){ee=K(re.fire,re)},onDidRemoveLastListener(){ee?.dispose()}};$||S(J);const re=new N(J);return $?.add(re),re.event}function W(K,$){return $ instanceof Array?$.push(K):$&&$.add(K),K}function V(K,$,ee=100,J=!1,re=!1,ne,ie){let P,B,j,G=0,te;const ae={leakWarningThreshold:ne,onWillAddFirstListener(){P=K(me=>{G++,B=$(B,me),J&&!j&&(oe.fire(B),B=void 0),te=()=>{const fe=B;B=void 0,j=void 0,(!J||G>1)&&oe.fire(fe),G=0},typeof ee=="number"?(clearTimeout(j),j=setTimeout(te,ee)):j===void 0&&(j=0,queueMicrotask(te))})},onWillRemoveListener(){re&&G>0&&te?.()},onDidRemoveLastListener(){te=void 0,P.dispose()}};ie||S(ae);const oe=new N(ae);return ie?.add(oe),oe.event}E.debounce=V;function z(K,$=0,ee){return E.debounce(K,(J,re)=>J?(J.push(re),J):[re],$,void 0,!0,void 0,ee)}E.accumulate=z;function U(K,$=(J,re)=>J===re,ee){let J=!0,re;return q(K,ne=>{const ie=J||!$(ne,re);return J=!1,re=ne,ie},ee)}E.latch=U;function se(K,$,ee){return[E.filter(K,$,ee),E.filter(K,J=>!$(J),ee)]}E.split=se;function he(K,$=!1,ee=[],J){let re=ee.slice(),ne=K(B=>{re?re.push(B):P.fire(B)});J&&J.add(ne);const ie=()=>{re?.forEach(B=>P.fire(B)),re=null},P=new N({onWillAddFirstListener(){ne||(ne=K(B=>P.fire(B)),J&&J.add(ne))},onDidAddFirstListener(){re&&($?setTimeout(ie):ie())},onDidRemoveLastListener(){ne&&ne.dispose(),ne=null}});return J&&J.add(P),P.event}E.buffer=he;function de(K,$){return(J,re,ne)=>{const ie=$(new Le);return K(function(P){const B=ie.evaluate(P);B!==t&&J.call(re,B)},void 0,ne)}}E.chain=de;const t=Symbol("HaltChainable");class Le{constructor(){this.steps=[]}map($){return this.steps.push($),this}forEach($){return this.steps.push(ee=>($(ee),ee)),this}filter($){return this.steps.push(ee=>$(ee)?ee:t),this}reduce($,ee){let J=ee;return this.steps.push(re=>(J=$(J,re),J)),this}latch($=(ee,J)=>ee===J){let ee=!0,J;return this.steps.push(re=>{const ne=ee||!$(re,J);return ee=!1,J=re,ne?re:t}),this}evaluate($){for(const ee of this.steps)if($=ee($),$===t)break;return $}}function we(K,$,ee=J=>J){const J=(...P)=>ie.fire(ee(...P)),re=()=>K.on($,J),ne=()=>K.removeListener($,J),ie=new N({onWillAddFirstListener:re,onDidRemoveLastListener:ne});return ie.event}E.fromNodeEventEmitter=we;function _e(K,$,ee=J=>J){const J=(...P)=>ie.fire(ee(...P)),re=()=>K.addEventListener($,J),ne=()=>K.removeEventListener($,J),ie=new N({onWillAddFirstListener:re,onDidRemoveLastListener:ne});return ie.event}E.fromDOMEventEmitter=_e;function Ce(K){return new Promise($=>D(K)($))}E.toPromise=Ce;function be(K){const $=new N;return K.then(ee=>{$.fire(ee)},()=>{$.fire(void 0)}).finally(()=>{$.dispose()}),$.event}E.fromPromise=be;function Se(K,$,ee){return $(ee),K(J=>$(J))}E.runAndSubscribe=Se;class ye{constructor($,ee){this._observable=$,this._counter=0,this._hasChanged=!1;const J={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};ee||S(J),this.emitter=new N(J),ee&&ee.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,ee){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Ne(K,$){return new ye(K,$).emitter.event}E.fromObservable=Ne;function ve(K){return($,ee,J)=>{let re=0,ne=!1;const ie={beginUpdate(){re++},endUpdate(){re--,re===0&&(K.reportChanges(),ne&&(ne=!1,$.call(ee)))},handlePossibleChange(){},handleChange(){ne=!0}};K.addObserver(ie),K.reportChanges();const P={dispose(){K.removeObserver(ie)}};return J instanceof A.DisposableStore?J.add(P):Array.isArray(J)&&J.push(P),P}}E.fromObservableLight=ve})(v||(n.Event=v={}));class e{constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${e._idPool++}`,e.all.add(this)}start(S){this._stopWatch=new m.StopWatch,this.listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=e,e.all=new Set,e._idPool=0;let f=-1;class s{constructor(S,M=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=M,this._warnCountdown=0}dispose(){var S;(S=this._stacks)===null||S===void 0||S.clear()}check(S,M){const D=this.threshold;if(D<=0||M<D)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(S.value)||0;if(this._stacks.set(S.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let k,q=0;for(const[H,Q]of this._stacks)(!k||q<Q)&&(k=H,q=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${M} listeners already. MOST frequent listener (${q}):`),console.warn(k)}return()=>{const k=this._stacks.get(S.value)||0;this._stacks.set(S.value,k-1)}}}class u{static create(){var S;return new u((S=new Error().stack)!==null&&S!==void 0?S:"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class c{constructor(S){this.value=S}}const h=2,y=(E,S)=>{if(E instanceof c)S(E);else for(let M=0;M<E.length;M++){const D=E[M];D&&S(D)}},C=p?new FinalizationRegistry(E=>{typeof E=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(E))}):void 0;class N{constructor(S){var M,D,T,k,q;this._size=0,this._options=S,this._leakageMon=f>0||!((M=this._options)===null||M===void 0)&&M.leakWarningThreshold?new s((T=(D=this._options)===null||D===void 0?void 0:D.leakWarningThreshold)!==null&&T!==void 0?T:f):void 0,this._perfMon=!((k=this._options)===null||k===void 0)&&k._profName?new e(this._options._profName):void 0,this._deliveryQueue=(q=this._options)===null||q===void 0?void 0:q.deliveryQueue}dispose(){var S,M,D,T;if(!this._disposed){if(this._disposed=!0,((S=this._deliveryQueue)===null||S===void 0?void 0:S.current)===this&&this._deliveryQueue.reset(),this._listeners){if(o){const k=this._listeners;queueMicrotask(()=>{y(k,q=>{var H;return(H=q.stack)===null||H===void 0?void 0:H.print()})})}this._listeners=void 0,this._size=0}(D=(M=this._options)===null||M===void 0?void 0:M.onDidRemoveLastListener)===null||D===void 0||D.call(M),(T=this._leakageMon)===null||T===void 0||T.dispose()}}get event(){var S;return(S=this._event)!==null&&S!==void 0||(this._event=(M,D,T)=>{var k,q,H,Q,F;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;if(this._disposed)return A.Disposable.None;D&&(M=M.bind(D));const I=new c(M);let W,V;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(I.stack=u.create(),W=this._leakageMon.check(I.stack,this._size+1)),o&&(I.stack=V??u.create()),this._listeners?this._listeners instanceof c?((F=this._deliveryQueue)!==null&&F!==void 0||(this._deliveryQueue=new w),this._listeners=[this._listeners,I]):this._listeners.push(I):((q=(k=this._options)===null||k===void 0?void 0:k.onWillAddFirstListener)===null||q===void 0||q.call(k,this),this._listeners=I,(Q=(H=this._options)===null||H===void 0?void 0:H.onDidAddFirstListener)===null||Q===void 0||Q.call(H,this)),this._size++;const z=(0,A.toDisposable)(()=>{C?.unregister(z),W?.(),this._removeListener(I)});if(T instanceof A.DisposableStore?T.add(z):Array.isArray(T)&&T.push(z),C){const U=new Error().stack.split(`
`).slice(2).join(`
`).trim();C.register(z,U,z)}return z}),this._event}_removeListener(S){var M,D,T,k;if((D=(M=this._options)===null||M===void 0?void 0:M.onWillRemoveListener)===null||D===void 0||D.call(M,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(k=(T=this._options)===null||T===void 0?void 0:T.onDidRemoveLastListener)===null||k===void 0||k.call(T,this),this._size=0;return}const q=this._listeners,H=q.indexOf(S);if(H===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,q[H]=void 0;const Q=this._deliveryQueue.current===this;if(this._size*h<=q.length){let F=0;for(let I=0;I<q.length;I++)q[I]?q[F++]=q[I]:Q&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);q.length=F}}_deliver(S,M){var D;if(!S)return;const T=((D=this._options)===null||D===void 0?void 0:D.onListenerError)||r.onUnexpectedError;if(!T){S.value(M);return}try{S.value(M)}catch(k){T(k)}}_deliverQueue(S){const M=S.current._listeners;for(;S.i<S.end;)this._deliver(M[S.i++],S.value);S.reset()}fire(S){var M,D,T,k;if(!((M=this._deliveryQueue)===null||M===void 0)&&M.current&&(this._deliverQueue(this._deliveryQueue),(D=this._perfMon)===null||D===void 0||D.stop()),(T=this._perfMon)===null||T===void 0||T.start(this._size),this._listeners)if(this._listeners instanceof c)this._deliver(this._listeners,S);else{const q=this._deliveryQueue;q.enqueue(this,S,this._listeners.length),this._deliverQueue(q)}(k=this._perfMon)===null||k===void 0||k.stop()}hasListeners(){return this._size>0}}n.Emitter=N;const R=()=>new w;n.createEventDeliveryQueue=R;class w{constructor(){this.i=-1,this.end=0}enqueue(S,M,D){this.i=0,this.end=D,this.current=S,this.value=M}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends N{constructor(S){super(S),this._isPaused=0,this._eventQueue=new g.LinkedList,this._mergeFn=S?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._size&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}n.PauseableEmitter=i;class l extends i{constructor(S){var M;super(S),this._delay=(M=S.delay)!==null&&M!==void 0?M:100}fire(S){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(S)}}n.DebounceEmitter=l;class d extends N{constructor(S){super(S),this._queuedEvents=[],this._mergeFn=S?.merge}fire(S){this.hasListeners()&&(this._queuedEvents.push(S),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(M=>super.fire(M)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=d;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new N({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const M={event:S,listener:null};this.events.push(M),this.hasListeners&&this.hook(M);const D=()=>{this.hasListeners&&this.unhook(M);const T=this.events.indexOf(M);this.events.splice(T,1)};return(0,A.toDisposable)((0,x.createSingleCallFunction)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(M=>this.emitter.fire(M))}unhook(S){var M;(M=S.listener)===null||M===void 0||M.dispose(),S.listener=null}dispose(){var S;this.emitter.dispose();for(const M of this.events)(S=M.listener)===null||S===void 0||S.dispose();this.events=[]}}n.EventMultiplexer=L;class b{constructor(){this.buffers=[]}wrapEvent(S){return(M,D,T)=>S(k=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>M.call(D,k)):M.call(D,k)},void 0,T)}bufferEvents(S){const M=[];this.buffers.push(M);const D=S();return this.buffers.pop(),M.forEach(T=>T()),D}}n.EventBufferer=b;class _{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=A.Disposable.None,this.emitter=new N({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=_}),Y(X[39],Z([0,1,9]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const x=Object.freeze(function(p,o){const a=setTimeout(p.bind(o),0);return{dispose(){clearTimeout(a)}}});var A;(function(p){function o(a){return a===p.None||a===p.Cancelled||a instanceof g?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}p.isCancellationToken=o,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:x})})(A||(n.CancellationToken=A={}));class g{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?x:(this._emitter||(this._emitter=new r.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class m{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new g),this._token}cancel(){this._token?this._token instanceof g&&this._token.cancel():this._token=A.Cancelled}dispose(o=!1){var a;o&&this.cancel(),(a=this._parentListener)===null||a===void 0||a.dispose(),this._token?this._token instanceof g&&this._token.dispose():this._token=A.None}}n.CancellationTokenSource=m}),Y(X[6],Z([0,1,34,38]),function(O,n,r,x){"use strict";var A;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.UTF8_BOM_CHARACTER=n.UNUSUAL_LINE_TERMINATORS=n.GraphemeIterator=n.CodePointIterator=void 0,n.isFalsyOrWhitespace=g,n.format=p,n.htmlAttributeEncodeValue=o,n.escape=a,n.escapeRegExpCharacters=v,n.trim=e,n.ltrim=f,n.rtrim=s,n.convertSimple2RegExpPattern=u,n.stripWildcards=c,n.createRegExp=h,n.regExpLeadsToEndlessLoop=y,n.splitLines=C,n.splitLinesIncludeSeparators=N,n.firstNonWhitespaceIndex=R,n.getLeadingWhitespace=w,n.lastNonWhitespaceIndex=i,n.compare=l,n.compareSubstring=d,n.compareIgnoreCase=L,n.compareSubstringIgnoreCase=b,n.isAsciiDigit=_,n.isLowerAsciiLetter=E,n.isUpperAsciiLetter=S,n.equalsIgnoreCase=M,n.startsWithIgnoreCase=D,n.commonPrefixLength=T,n.commonSuffixLength=k,n.isHighSurrogate=q,n.isLowSurrogate=H,n.computeCodePoint=Q,n.getNextCodePoint=F,n.nextCharLength=z,n.prevCharLength=U,n.getCharContainingOffset=se,n.containsRTL=t,n.isBasicASCII=we,n.containsUnusualLineTerminators=_e,n.isFullWidthCharacter=Ce,n.isEmojiImprecise=be,n.startsWithUTF8BOM=Se,n.containsUppercaseCharacter=ye,n.singleLetterHash=Ne,n.getLeftDeleteOffset=ee;function g(P){return!P||typeof P!="string"?!0:P.trim().length===0}const m=/{(\d+)}/g;function p(P,...B){return B.length===0?P:P.replace(m,function(j,G){const te=parseInt(G,10);return isNaN(te)||te<0||te>=B.length?j:B[te]})}function o(P){return P.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}function a(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}function v(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(P,B=" "){const j=f(P,B);return s(j,B)}function f(P,B){if(!P||!B)return P;const j=B.length;if(j===0||P.length===0)return P;let G=0;for(;P.indexOf(B,G)===G;)G=G+j;return P.substring(G)}function s(P,B){if(!P||!B)return P;const j=B.length,G=P.length;if(j===0||G===0)return P;let te=G,ae=-1;for(;ae=P.lastIndexOf(B,te-1),!(ae===-1||ae+j!==te);){if(ae===0)return"";te=ae}return P.substring(0,te)}function u(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(P){return P.replace(/\*/g,"")}function h(P,B,j={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=v(P)),j.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let G="";return j.global&&(G+="g"),j.matchCase||(G+="i"),j.multiline&&(G+="m"),j.unicode&&(G+="u"),new RegExp(P,G)}function y(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}function C(P){return P.split(/\r\n|\r|\n/)}function N(P){var B;const j=[],G=P.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(G.length/2);te++)j.push(G[2*te]+((B=G[2*te+1])!==null&&B!==void 0?B:""));return j}function R(P){for(let B=0,j=P.length;B<j;B++){const G=P.charCodeAt(B);if(G!==32&&G!==9)return B}return-1}function w(P,B=0,j=P.length){for(let G=B;G<j;G++){const te=P.charCodeAt(G);if(te!==32&&te!==9)return P.substring(B,G)}return P.substring(B,j)}function i(P,B=P.length-1){for(let j=B;j>=0;j--){const G=P.charCodeAt(j);if(G!==32&&G!==9)return j}return-1}function l(P,B){return P<B?-1:P>B?1:0}function d(P,B,j=0,G=P.length,te=0,ae=B.length){for(;j<G&&te<ae;j++,te++){const fe=P.charCodeAt(j),le=B.charCodeAt(te);if(fe<le)return-1;if(fe>le)return 1}const oe=G-j,me=ae-te;return oe<me?-1:oe>me?1:0}function L(P,B){return b(P,B,0,P.length,0,B.length)}function b(P,B,j=0,G=P.length,te=0,ae=B.length){for(;j<G&&te<ae;j++,te++){let fe=P.charCodeAt(j),le=B.charCodeAt(te);if(fe===le)continue;if(fe>=128||le>=128)return d(P.toLowerCase(),B.toLowerCase(),j,G,te,ae);E(fe)&&(fe-=32),E(le)&&(le-=32);const ce=fe-le;if(ce!==0)return ce}const oe=G-j,me=ae-te;return oe<me?-1:oe>me?1:0}function _(P){return P>=48&&P<=57}function E(P){return P>=97&&P<=122}function S(P){return P>=65&&P<=90}function M(P,B){return P.length===B.length&&b(P,B)===0}function D(P,B){const j=B.length;return B.length>P.length?!1:b(P,B,0,j)===0}function T(P,B){const j=Math.min(P.length,B.length);let G;for(G=0;G<j;G++)if(P.charCodeAt(G)!==B.charCodeAt(G))return G;return j}function k(P,B){const j=Math.min(P.length,B.length);let G;const te=P.length-1,ae=B.length-1;for(G=0;G<j;G++)if(P.charCodeAt(te-G)!==B.charCodeAt(ae-G))return G;return j}function q(P){return 55296<=P&&P<=56319}function H(P){return 56320<=P&&P<=57343}function Q(P,B){return(P-55296<<10)+(B-56320)+65536}function F(P,B,j){const G=P.charCodeAt(j);if(q(G)&&j+1<B){const te=P.charCodeAt(j+1);if(H(te))return Q(G,te)}return G}function I(P,B){const j=P.charCodeAt(B-1);if(H(j)&&B>1){const G=P.charCodeAt(B-2);if(q(G))return Q(G,j)}return j}class W{get offset(){return this._offset}constructor(B,j=0){this._str=B,this._len=B.length,this._offset=j}setOffset(B){this._offset=B}prevCodePoint(){const B=I(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=F(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}n.CodePointIterator=W;class V{get offset(){return this._iterator.offset}constructor(B,j=0){this._iterator=new W(B,j)}nextGraphemeLength(){const B=K.getInstance(),j=this._iterator,G=j.offset;let te=B.getGraphemeBreakType(j.nextCodePoint());for(;!j.eol();){const ae=j.offset,oe=B.getGraphemeBreakType(j.nextCodePoint());if(ve(te,oe)){j.setOffset(ae);break}te=oe}return j.offset-G}prevGraphemeLength(){const B=K.getInstance(),j=this._iterator,G=j.offset;let te=B.getGraphemeBreakType(j.prevCodePoint());for(;j.offset>0;){const ae=j.offset,oe=B.getGraphemeBreakType(j.prevCodePoint());if(ve(oe,te)){j.setOffset(ae);break}te=oe}return G-j.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=V;function z(P,B){return new V(P,B).nextGraphemeLength()}function U(P,B){return new V(P,B).prevGraphemeLength()}function se(P,B){B>0&&H(P.charCodeAt(B))&&B--;const j=B+z(P,B);return[j-U(P,j),j]}let he;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function t(P){return he||(he=de()),he.test(P)}const Le=/^[\t\n\r\x20-\x7E]*$/;function we(P){return Le.test(P)}n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}function Ce(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}function be(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.UTF8_BOM_CHARACTER="\uFEFF";function Se(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}function ye(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}function Ne(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}function ve(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}class K{static getInstance(){return K._INSTANCE||(K._INSTANCE=new K),K._INSTANCE}constructor(){this._data=$()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const j=this._data,G=j.length/3;let te=1;for(;te<=G;)if(B<j[3*te])te=2*te;else if(B>j[3*te+1])te=2*te+1;else return j[3*te+2];return 0}}K._INSTANCE=null;function $(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ee(P,B){if(P===0)return 0;const j=J(P,B);if(j!==void 0)return j;const G=new W(B,P);return G.prevCodePoint(),G.offset}function J(P,B){const j=new W(B,P);let G=j.prevCodePoint();for(;re(G)||G===65039||G===8419;){if(j.offset===0)return;G=j.prevCodePoint()}if(!be(G))return;let te=j.offset;return te>0&&j.prevCodePoint()===8205&&(te=j.offset),te}function re(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class ne{static getInstance(B){return A.cache.get(Array.from(B))}static getLocales(){return A._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ne,A=ne,ne.ambiguousCharacterData=new x.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new r.LRUCachedFunction({getCacheKey:JSON.stringify},P=>{function B(le){const ce=new Map;for(let ge=0;ge<le.length;ge+=2)ce.set(le[ge],le[ge+1]);return ce}function j(le,ce){const ge=new Map(le);for(const[pe,Ee]of ce)ge.set(pe,Ee);return ge}function G(le,ce){if(!le)return ce;const ge=new Map;for(const[pe,Ee]of le)ce.has(pe)&&ge.set(pe,Ee);return ge}const te=A.ambiguousCharacterData.value;let ae=P.filter(le=>!le.startsWith("_")&&le in te);ae.length===0&&(ae=["_default"]);let oe;for(const le of ae){const ce=B(te[le]);oe=G(oe,ce)}const me=B(te._common),fe=j(me,oe);return new A(fe)}),ne._locales=new x.Lazy(()=>Object.keys(A.ambiguousCharacterData.value).filter(P=>!P.startsWith("_")));class ie{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ie.getRawData())),this._data}static isInvisibleCharacter(B){return ie.getData().has(B)}static get codePoints(){return ie.getData()}}n.InvisibleCharacters=ie,ie._data=void 0}),Y(X[40],Z([0,1,6]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=void 0,n.hash=x,n.doHash=A,n.numberHash=g,n.stringHash=p,n.toHexString=s;function x(c){return A(c,0)}function A(c,h){switch(typeof c){case"object":return c===null?g(349,h):Array.isArray(c)?o(c,h):a(c,h);case"string":return p(c,h);case"boolean":return m(c,h);case"number":return g(c,h);case"undefined":return g(937,h);default:return g(617,h)}}function g(c,h){return(h<<5)-h+c|0}function m(c,h){return g(c?433:863,h)}function p(c,h){h=g(149417,h);for(let y=0,C=c.length;y<C;y++)h=g(c.charCodeAt(y),h);return h}function o(c,h){return h=g(104579,h),c.reduce((y,C)=>A(C,y),h)}function a(c,h){return h=g(181387,h),Object.keys(c).sort().reduce((y,C)=>(y=p(C,y),A(c[C],y)),h)}function v(c,h,y=32){const C=y-h,N=~((1<<C)-1);return(c<<h|(N&c)>>>C)>>>0}function e(c,h=0,y=c.byteLength,C=0){for(let N=0;N<y;N++)c[h+N]=C}function f(c,h,y="0"){for(;c.length<h;)c=y+c;return c}function s(c,h=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(y=>y.toString(16).padStart(2,"0")).join(""):f((c>>>0).toString(16),h/4)}class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const y=h.length;if(y===0)return;const C=this._buff;let N=this._buffLen,R=this._leftoverHighSurrogate,w,i;for(R!==0?(w=R,i=-1,R=0):(w=h.charCodeAt(0),i=0);;){let l=w;if(r.isHighSurrogate(w))if(i+1<y){const d=h.charCodeAt(i+1);r.isLowSurrogate(d)?(i++,l=r.computeCodePoint(w,d)):l=65533}else{R=w;break}else r.isLowSurrogate(w)&&(l=65533);if(N=this._push(C,N,l),i++,i<y)w=h.charCodeAt(i);else break}this._buffLen=N,this._leftoverHighSurrogate=R}_push(h,y,C){return C<128?h[y++]=C:C<2048?(h[y++]=192|(C&1984)>>>6,h[y++]=128|(C&63)>>>0):C<65536?(h[y++]=224|(C&61440)>>>12,h[y++]=128|(C&4032)>>>6,h[y++]=128|(C&63)>>>0):(h[y++]=240|(C&1835008)>>>18,h[y++]=128|(C&258048)>>>12,h[y++]=128|(C&4032)>>>6,h[y++]=128|(C&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,h[0]=h[64],h[1]=h[65],h[2]=h[66]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=u._bigBlock32,y=this._buffDV;for(let b=0;b<64;b+=4)h.setUint32(b,y.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)h.setUint32(b,v(h.getUint32(b-12,!1)^h.getUint32(b-32,!1)^h.getUint32(b-56,!1)^h.getUint32(b-64,!1),1),!1);let C=this._h0,N=this._h1,R=this._h2,w=this._h3,i=this._h4,l,d,L;for(let b=0;b<80;b++)b<20?(l=N&R|~N&w,d=1518500249):b<40?(l=N^R^w,d=1859775393):b<60?(l=N&R|N&w|R&w,d=2400959708):(l=N^R^w,d=3395469782),L=v(C,5)+l+i+d+h.getUint32(b*4,!1)&4294967295,i=w,w=R,R=v(N,30),N=C,C=L;this._h0=this._h0+C&4294967295,this._h1=this._h1+N&4294967295,this._h2=this._h2+R&4294967295,this._h3=this._h3+w&4294967295,this._h4=this._h4+i&4294967295}}n.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(X[25],Z([0,1,36,40]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.StringDiffSequence=void 0,n.stringDiff=g;class A{constructor(e){this.source=e}getElements(){const e=this.source,f=new Int32Array(e.length);for(let s=0,u=e.length;s<u;s++)f[s]=e.charCodeAt(s);return f}}n.StringDiffSequence=A;function g(v,e,f){return new a(new A(v),new A(e)).ComputeDiff(f).changes}class m{static Assert(e,f){if(!e)throw new Error(f)}}class p{static Copy(e,f,s,u,c){for(let h=0;h<c;h++)s[u+h]=e[f+h]}static Copy2(e,f,s,u,c){for(let h=0;h<c;h++)s[u+h]=e[f+h]}}class o{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,f){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_originalCount++}AddModifiedElement(e,f){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class a{constructor(e,f,s=null){this.ContinueProcessingPredicate=s,this._originalSequence=e,this._modifiedSequence=f;const[u,c,h]=a._getElements(e),[y,C,N]=a._getElements(f);this._hasStrings=h&&N,this._originalStringElements=u,this._originalElementsOrHash=c,this._modifiedStringElements=y,this._modifiedElementsOrHash=C,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const f=e.getElements();if(a._isStringArray(f)){const s=new Int32Array(f.length);for(let u=0,c=f.length;u<c;u++)s[u]=(0,x.stringHash)(f[u],0);return[f,s,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}ElementsAreEqual(e,f){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[f]:!0}ElementsAreStrictEqual(e,f){if(!this.ElementsAreEqual(e,f))return!1;const s=a._getStrictElement(this._originalSequence,e),u=a._getStrictElement(this._modifiedSequence,f);return s===u}static _getStrictElement(e,f){return typeof e.getStrictElement=="function"?e.getStrictElement(f):null}OriginalElementsAreEqual(e,f){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[f]:!0}ModifiedElementsAreEqual(e,f){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[f]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,f,s,u,c){const h=[!1];let y=this.ComputeDiffRecursive(e,f,s,u,h);return c&&(y=this.PrettifyChanges(y)),{quitEarly:h[0],changes:y}}ComputeDiffRecursive(e,f,s,u,c){for(c[0]=!1;e<=f&&s<=u&&this.ElementsAreEqual(e,s);)e++,s++;for(;f>=e&&u>=s&&this.ElementsAreEqual(f,u);)f--,u--;if(e>f||s>u){let w;return s<=u?(m.Assert(e===f+1,"originalStart should only be one more than originalEnd"),w=[new r.DiffChange(e,0,s,u-s+1)]):e<=f?(m.Assert(s===u+1,"modifiedStart should only be one more than modifiedEnd"),w=[new r.DiffChange(e,f-e+1,s,0)]):(m.Assert(e===f+1,"originalStart should only be one more than originalEnd"),m.Assert(s===u+1,"modifiedStart should only be one more than modifiedEnd"),w=[]),w}const h=[0],y=[0],C=this.ComputeRecursionPoint(e,f,s,u,h,y,c),N=h[0],R=y[0];if(C!==null)return C;if(!c[0]){const w=this.ComputeDiffRecursive(e,N,s,R,c);let i=[];return c[0]?i=[new r.DiffChange(N+1,f-(N+1)+1,R+1,u-(R+1)+1)]:i=this.ComputeDiffRecursive(N+1,f,R+1,u,c),this.ConcatenateChanges(w,i)}return[new r.DiffChange(e,f-e+1,s,u-s+1)]}WALKTRACE(e,f,s,u,c,h,y,C,N,R,w,i,l,d,L,b,_,E){let S=null,M=null,D=new o,T=f,k=s,q=l[0]-b[0]-u,H=-1073741824,Q=this.m_forwardHistory.length-1;do{const F=q+e;F===T||F<k&&N[F-1]<N[F+1]?(w=N[F+1],d=w-q-u,w<H&&D.MarkNextChange(),H=w,D.AddModifiedElement(w+1,d),q=F+1-e):(w=N[F-1]+1,d=w-q-u,w<H&&D.MarkNextChange(),H=w-1,D.AddOriginalElement(w,d+1),q=F-1-e),Q>=0&&(N=this.m_forwardHistory[Q],e=N[0],T=1,k=N.length-1)}while(--Q>=-1);if(S=D.getReverseChanges(),E[0]){let F=l[0]+1,I=b[0]+1;if(S!==null&&S.length>0){const W=S[S.length-1];F=Math.max(F,W.getOriginalEnd()),I=Math.max(I,W.getModifiedEnd())}M=[new r.DiffChange(F,i-F+1,I,L-I+1)]}else{D=new o,T=h,k=y,q=l[0]-b[0]-C,H=1073741824,Q=_?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const F=q+c;F===T||F<k&&R[F-1]>=R[F+1]?(w=R[F+1]-1,d=w-q-C,w>H&&D.MarkNextChange(),H=w+1,D.AddOriginalElement(w+1,d+1),q=F+1-c):(w=R[F-1],d=w-q-C,w>H&&D.MarkNextChange(),H=w,D.AddModifiedElement(w+1,d+1),q=F-1-c),Q>=0&&(R=this.m_reverseHistory[Q],c=R[0],T=1,k=R.length-1)}while(--Q>=-1);M=D.getChanges()}return this.ConcatenateChanges(S,M)}ComputeRecursionPoint(e,f,s,u,c,h,y){let C=0,N=0,R=0,w=0,i=0,l=0;e--,s--,c[0]=0,h[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=f-e+(u-s),L=d+1,b=new Int32Array(L),_=new Int32Array(L),E=u-s,S=f-e,M=e-s,D=f-u,k=(S-E)%2===0;b[E]=e,_[S]=f,y[0]=!1;for(let q=1;q<=d/2+1;q++){let H=0,Q=0;R=this.ClipDiagonalBound(E-q,q,E,L),w=this.ClipDiagonalBound(E+q,q,E,L);for(let I=R;I<=w;I+=2){I===R||I<w&&b[I-1]<b[I+1]?C=b[I+1]:C=b[I-1]+1,N=C-(I-E)-M;const W=C;for(;C<f&&N<u&&this.ElementsAreEqual(C+1,N+1);)C++,N++;if(b[I]=C,C+N>H+Q&&(H=C,Q=N),!k&&Math.abs(I-S)<=q-1&&C>=_[I])return c[0]=C,h[0]=N,W<=_[I]&&1447>0&&q<=1448?this.WALKTRACE(E,R,w,M,S,i,l,D,b,_,C,f,c,N,u,h,k,y):null}const F=(H-e+(Q-s)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,F))return y[0]=!0,c[0]=H,h[0]=Q,F>0&&1447>0&&q<=1448?this.WALKTRACE(E,R,w,M,S,i,l,D,b,_,C,f,c,N,u,h,k,y):(e++,s++,[new r.DiffChange(e,f-e+1,s,u-s+1)]);i=this.ClipDiagonalBound(S-q,q,S,L),l=this.ClipDiagonalBound(S+q,q,S,L);for(let I=i;I<=l;I+=2){I===i||I<l&&_[I-1]>=_[I+1]?C=_[I+1]-1:C=_[I-1],N=C-(I-S)-D;const W=C;for(;C>e&&N>s&&this.ElementsAreEqual(C,N);)C--,N--;if(_[I]=C,k&&Math.abs(I-E)<=q&&C<=b[I])return c[0]=C,h[0]=N,W>=b[I]&&1447>0&&q<=1448?this.WALKTRACE(E,R,w,M,S,i,l,D,b,_,C,f,c,N,u,h,k,y):null}if(q<=1447){let I=new Int32Array(w-R+2);I[0]=E-R+1,p.Copy2(b,R,I,1,w-R+1),this.m_forwardHistory.push(I),I=new Int32Array(l-i+2),I[0]=S-i+1,p.Copy2(_,i,I,1,l-i+1),this.m_reverseHistory.push(I)}}return this.WALKTRACE(E,R,w,M,S,i,l,D,b,_,C,f,c,N,u,h,k,y)}PrettifyChanges(e){for(let f=0;f<e.length;f++){const s=e[f],u=f<e.length-1?e[f+1].originalStart:this._originalElementsOrHash.length,c=f<e.length-1?e[f+1].modifiedStart:this._modifiedElementsOrHash.length,h=s.originalLength>0,y=s.modifiedLength>0;for(;s.originalStart+s.originalLength<u&&s.modifiedStart+s.modifiedLength<c&&(!h||this.OriginalElementsAreEqual(s.originalStart,s.originalStart+s.originalLength))&&(!y||this.ModifiedElementsAreEqual(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const N=this.ElementsAreStrictEqual(s.originalStart,s.modifiedStart);if(this.ElementsAreStrictEqual(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!N)break;s.originalStart++,s.modifiedStart++}const C=[null];if(f<e.length-1&&this.ChangesOverlap(e[f],e[f+1],C)){e[f]=C[0],e.splice(f+1,1),f--;continue}}for(let f=e.length-1;f>=0;f--){const s=e[f];let u=0,c=0;if(f>0){const w=e[f-1];u=w.originalStart+w.originalLength,c=w.modifiedStart+w.modifiedLength}const h=s.originalLength>0,y=s.modifiedLength>0;let C=0,N=this._boundaryScore(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let w=1;;w++){const i=s.originalStart-w,l=s.modifiedStart-w;if(i<u||l<c||h&&!this.OriginalElementsAreEqual(i,i+s.originalLength)||y&&!this.ModifiedElementsAreEqual(l,l+s.modifiedLength))break;const L=(i===u&&l===c?5:0)+this._boundaryScore(i,s.originalLength,l,s.modifiedLength);L>N&&(N=L,C=w)}s.originalStart-=C,s.modifiedStart-=C;const R=[null];if(f>0&&this.ChangesOverlap(e[f-1],e[f],R)){e[f-1]=R[0],e.splice(f,1),f++;continue}}if(this._hasStrings)for(let f=1,s=e.length;f<s;f++){const u=e[f-1],c=e[f],h=c.originalStart-u.originalStart-u.originalLength,y=u.originalStart,C=c.originalStart+c.originalLength,N=C-y,R=u.modifiedStart,w=c.modifiedStart+c.modifiedLength,i=w-R;if(h<5&&N<20&&i<20){const l=this._findBetterContiguousSequence(y,N,R,i,h);if(l){const[d,L]=l;(d!==u.originalStart+u.originalLength||L!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=d-u.originalStart,u.modifiedLength=L-u.modifiedStart,c.originalStart=d+h,c.modifiedStart=L+h,c.originalLength=C-c.originalStart,c.modifiedLength=w-c.modifiedStart)}}}return e}_findBetterContiguousSequence(e,f,s,u,c){if(f<c||u<c)return null;const h=e+f-c+1,y=s+u-c+1;let C=0,N=0,R=0;for(let w=e;w<h;w++)for(let i=s;i<y;i++){const l=this._contiguousSequenceScore(w,i,c);l>0&&l>C&&(C=l,N=w,R=i)}return C>0?[N,R]:null}_contiguousSequenceScore(e,f,s){let u=0;for(let c=0;c<s;c++){if(!this.ElementsAreEqual(e+c,f+c))return 0;u+=this._originalStringElements[e+c].length}return u}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,f){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(f>0){const s=e+f;if(this._OriginalIsBoundary(s-1)||this._OriginalIsBoundary(s))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,f){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(f>0){const s=e+f;if(this._ModifiedIsBoundary(s-1)||this._ModifiedIsBoundary(s))return!0}return!1}_boundaryScore(e,f,s,u){const c=this._OriginalRegionIsBoundary(e,f)?1:0,h=this._ModifiedRegionIsBoundary(s,u)?1:0;return c+h}ConcatenateChanges(e,f){const s=[];if(e.length===0||f.length===0)return f.length>0?f:e;if(this.ChangesOverlap(e[e.length-1],f[0],s)){const u=new Array(e.length+f.length-1);return p.Copy(e,0,u,0,e.length-1),u[e.length-1]=s[0],p.Copy(f,1,u,e.length,f.length-1),u}else{const u=new Array(e.length+f.length);return p.Copy(e,0,u,0,e.length),p.Copy(f,0,u,e.length,f.length),u}}ChangesOverlap(e,f,s){if(m.Assert(e.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),m.Assert(e.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=f.originalStart||e.modifiedStart+e.modifiedLength>=f.modifiedStart){const u=e.originalStart;let c=e.originalLength;const h=e.modifiedStart;let y=e.modifiedLength;return e.originalStart+e.originalLength>=f.originalStart&&(c=f.originalStart+f.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=f.modifiedStart&&(y=f.modifiedStart+f.modifiedLength-e.modifiedStart),s[0]=new r.DiffChange(u,c,h,y),!0}else return s[0]=null,!1}ClipDiagonalBound(e,f,s,u){if(e>=0&&e<u)return e;const c=s,h=u-s-1,y=f%2===0;if(e<0){const C=c%2===0;return y===C?0:1}else{const C=h%2===0;return y===C?u-1:u-2}}}n.LcsDiff=a}),Y(X[26],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isString=r,n.isObject=x,n.isTypedArray=A,n.isNumber=g,n.isIterable=m,n.isBoolean=p,n.isUndefined=o,n.isDefined=a,n.isUndefinedOrNull=v,n.assertType=e,n.assertIsDefined=f,n.isFunction=s,n.validateConstraints=u,n.validateConstraint=c;function r(h){return typeof h=="string"}function x(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function A(h){const y=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof y}function g(h){return typeof h=="number"&&!isNaN(h)}function m(h){return!!h&&typeof h[Symbol.iterator]=="function"}function p(h){return h===!0||h===!1}function o(h){return typeof h>"u"}function a(h){return!v(h)}function v(h){return o(h)||h===null}function e(h,y){if(!h)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}function f(h){if(v(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function s(h){return typeof h=="function"}function u(h,y){const C=Math.min(h.length,y.length);for(let N=0;N<C;N++)c(h[N],y[N])}function c(h,y){if(r(y)){if(typeof h!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(s(y)){try{if(h instanceof y)return}catch{}if(!v(h)&&h.constructor===y||y.length===1&&y.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),Y(X[27],Z([0,1,26]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.register=A,n.getCodiconFontCharacters=g;const x=Object.create(null);function A(m,p){if((0,r.isString)(p)){const o=x[p];if(o===void 0)throw new Error(`${m} references an unknown codicon: ${p}`);p=o}return x[m]=p,{id:m}}function g(){return x}}),Y(X[41],Z([0,1,27]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.codiconsLibrary=void 0,n.codiconsLibrary={add:(0,r.register)("add",6e4),plus:(0,r.register)("plus",6e4),gistNew:(0,r.register)("gist-new",6e4),repoCreate:(0,r.register)("repo-create",6e4),lightbulb:(0,r.register)("lightbulb",60001),lightBulb:(0,r.register)("light-bulb",60001),repo:(0,r.register)("repo",60002),repoDelete:(0,r.register)("repo-delete",60002),gistFork:(0,r.register)("gist-fork",60003),repoForked:(0,r.register)("repo-forked",60003),gitPullRequest:(0,r.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.register)("git-pull-request-abandoned",60004),recordKeys:(0,r.register)("record-keys",60005),keyboard:(0,r.register)("keyboard",60005),tag:(0,r.register)("tag",60006),gitPullRequestLabel:(0,r.register)("git-pull-request-label",60006),tagAdd:(0,r.register)("tag-add",60006),tagRemove:(0,r.register)("tag-remove",60006),person:(0,r.register)("person",60007),personFollow:(0,r.register)("person-follow",60007),personOutline:(0,r.register)("person-outline",60007),personFilled:(0,r.register)("person-filled",60007),gitBranch:(0,r.register)("git-branch",60008),gitBranchCreate:(0,r.register)("git-branch-create",60008),gitBranchDelete:(0,r.register)("git-branch-delete",60008),sourceControl:(0,r.register)("source-control",60008),mirror:(0,r.register)("mirror",60009),mirrorPublic:(0,r.register)("mirror-public",60009),star:(0,r.register)("star",60010),starAdd:(0,r.register)("star-add",60010),starDelete:(0,r.register)("star-delete",60010),starEmpty:(0,r.register)("star-empty",60010),comment:(0,r.register)("comment",60011),commentAdd:(0,r.register)("comment-add",60011),alert:(0,r.register)("alert",60012),warning:(0,r.register)("warning",60012),search:(0,r.register)("search",60013),searchSave:(0,r.register)("search-save",60013),logOut:(0,r.register)("log-out",60014),signOut:(0,r.register)("sign-out",60014),logIn:(0,r.register)("log-in",60015),signIn:(0,r.register)("sign-in",60015),eye:(0,r.register)("eye",60016),eyeUnwatch:(0,r.register)("eye-unwatch",60016),eyeWatch:(0,r.register)("eye-watch",60016),circleFilled:(0,r.register)("circle-filled",60017),primitiveDot:(0,r.register)("primitive-dot",60017),closeDirty:(0,r.register)("close-dirty",60017),debugBreakpoint:(0,r.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.register)("debug-breakpoint-disabled",60017),debugHint:(0,r.register)("debug-hint",60017),terminalDecorationSuccess:(0,r.register)("terminal-decoration-success",60017),primitiveSquare:(0,r.register)("primitive-square",60018),edit:(0,r.register)("edit",60019),pencil:(0,r.register)("pencil",60019),info:(0,r.register)("info",60020),issueOpened:(0,r.register)("issue-opened",60020),gistPrivate:(0,r.register)("gist-private",60021),gitForkPrivate:(0,r.register)("git-fork-private",60021),lock:(0,r.register)("lock",60021),mirrorPrivate:(0,r.register)("mirror-private",60021),close:(0,r.register)("close",60022),removeClose:(0,r.register)("remove-close",60022),x:(0,r.register)("x",60022),repoSync:(0,r.register)("repo-sync",60023),sync:(0,r.register)("sync",60023),clone:(0,r.register)("clone",60024),desktopDownload:(0,r.register)("desktop-download",60024),beaker:(0,r.register)("beaker",60025),microscope:(0,r.register)("microscope",60025),vm:(0,r.register)("vm",60026),deviceDesktop:(0,r.register)("device-desktop",60026),file:(0,r.register)("file",60027),fileText:(0,r.register)("file-text",60027),more:(0,r.register)("more",60028),ellipsis:(0,r.register)("ellipsis",60028),kebabHorizontal:(0,r.register)("kebab-horizontal",60028),mailReply:(0,r.register)("mail-reply",60029),reply:(0,r.register)("reply",60029),organization:(0,r.register)("organization",60030),organizationFilled:(0,r.register)("organization-filled",60030),organizationOutline:(0,r.register)("organization-outline",60030),newFile:(0,r.register)("new-file",60031),fileAdd:(0,r.register)("file-add",60031),newFolder:(0,r.register)("new-folder",60032),fileDirectoryCreate:(0,r.register)("file-directory-create",60032),trash:(0,r.register)("trash",60033),trashcan:(0,r.register)("trashcan",60033),history:(0,r.register)("history",60034),clock:(0,r.register)("clock",60034),folder:(0,r.register)("folder",60035),fileDirectory:(0,r.register)("file-directory",60035),symbolFolder:(0,r.register)("symbol-folder",60035),logoGithub:(0,r.register)("logo-github",60036),markGithub:(0,r.register)("mark-github",60036),github:(0,r.register)("github",60036),terminal:(0,r.register)("terminal",60037),console:(0,r.register)("console",60037),repl:(0,r.register)("repl",60037),zap:(0,r.register)("zap",60038),symbolEvent:(0,r.register)("symbol-event",60038),error:(0,r.register)("error",60039),stop:(0,r.register)("stop",60039),variable:(0,r.register)("variable",60040),symbolVariable:(0,r.register)("symbol-variable",60040),array:(0,r.register)("array",60042),symbolArray:(0,r.register)("symbol-array",60042),symbolModule:(0,r.register)("symbol-module",60043),symbolPackage:(0,r.register)("symbol-package",60043),symbolNamespace:(0,r.register)("symbol-namespace",60043),symbolObject:(0,r.register)("symbol-object",60043),symbolMethod:(0,r.register)("symbol-method",60044),symbolFunction:(0,r.register)("symbol-function",60044),symbolConstructor:(0,r.register)("symbol-constructor",60044),symbolBoolean:(0,r.register)("symbol-boolean",60047),symbolNull:(0,r.register)("symbol-null",60047),symbolNumeric:(0,r.register)("symbol-numeric",60048),symbolNumber:(0,r.register)("symbol-number",60048),symbolStructure:(0,r.register)("symbol-structure",60049),symbolStruct:(0,r.register)("symbol-struct",60049),symbolParameter:(0,r.register)("symbol-parameter",60050),symbolTypeParameter:(0,r.register)("symbol-type-parameter",60050),symbolKey:(0,r.register)("symbol-key",60051),symbolText:(0,r.register)("symbol-text",60051),symbolReference:(0,r.register)("symbol-reference",60052),goToFile:(0,r.register)("go-to-file",60052),symbolEnum:(0,r.register)("symbol-enum",60053),symbolValue:(0,r.register)("symbol-value",60053),symbolRuler:(0,r.register)("symbol-ruler",60054),symbolUnit:(0,r.register)("symbol-unit",60054),activateBreakpoints:(0,r.register)("activate-breakpoints",60055),archive:(0,r.register)("archive",60056),arrowBoth:(0,r.register)("arrow-both",60057),arrowDown:(0,r.register)("arrow-down",60058),arrowLeft:(0,r.register)("arrow-left",60059),arrowRight:(0,r.register)("arrow-right",60060),arrowSmallDown:(0,r.register)("arrow-small-down",60061),arrowSmallLeft:(0,r.register)("arrow-small-left",60062),arrowSmallRight:(0,r.register)("arrow-small-right",60063),arrowSmallUp:(0,r.register)("arrow-small-up",60064),arrowUp:(0,r.register)("arrow-up",60065),bell:(0,r.register)("bell",60066),bold:(0,r.register)("bold",60067),book:(0,r.register)("book",60068),bookmark:(0,r.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.register)("briefcase",60076),broadcast:(0,r.register)("broadcast",60077),browser:(0,r.register)("browser",60078),bug:(0,r.register)("bug",60079),calendar:(0,r.register)("calendar",60080),caseSensitive:(0,r.register)("case-sensitive",60081),check:(0,r.register)("check",60082),checklist:(0,r.register)("checklist",60083),chevronDown:(0,r.register)("chevron-down",60084),chevronLeft:(0,r.register)("chevron-left",60085),chevronRight:(0,r.register)("chevron-right",60086),chevronUp:(0,r.register)("chevron-up",60087),chromeClose:(0,r.register)("chrome-close",60088),chromeMaximize:(0,r.register)("chrome-maximize",60089),chromeMinimize:(0,r.register)("chrome-minimize",60090),chromeRestore:(0,r.register)("chrome-restore",60091),circleOutline:(0,r.register)("circle-outline",60092),circle:(0,r.register)("circle",60092),debugBreakpointUnverified:(0,r.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.register)("terminal-decoration-incomplete",60092),circleSlash:(0,r.register)("circle-slash",60093),circuitBoard:(0,r.register)("circuit-board",60094),clearAll:(0,r.register)("clear-all",60095),clippy:(0,r.register)("clippy",60096),closeAll:(0,r.register)("close-all",60097),cloudDownload:(0,r.register)("cloud-download",60098),cloudUpload:(0,r.register)("cloud-upload",60099),code:(0,r.register)("code",60100),collapseAll:(0,r.register)("collapse-all",60101),colorMode:(0,r.register)("color-mode",60102),commentDiscussion:(0,r.register)("comment-discussion",60103),creditCard:(0,r.register)("credit-card",60105),dash:(0,r.register)("dash",60108),dashboard:(0,r.register)("dashboard",60109),database:(0,r.register)("database",60110),debugContinue:(0,r.register)("debug-continue",60111),debugDisconnect:(0,r.register)("debug-disconnect",60112),debugPause:(0,r.register)("debug-pause",60113),debugRestart:(0,r.register)("debug-restart",60114),debugStart:(0,r.register)("debug-start",60115),debugStepInto:(0,r.register)("debug-step-into",60116),debugStepOut:(0,r.register)("debug-step-out",60117),debugStepOver:(0,r.register)("debug-step-over",60118),debugStop:(0,r.register)("debug-stop",60119),debug:(0,r.register)("debug",60120),deviceCameraVideo:(0,r.register)("device-camera-video",60121),deviceCamera:(0,r.register)("device-camera",60122),deviceMobile:(0,r.register)("device-mobile",60123),diffAdded:(0,r.register)("diff-added",60124),diffIgnored:(0,r.register)("diff-ignored",60125),diffModified:(0,r.register)("diff-modified",60126),diffRemoved:(0,r.register)("diff-removed",60127),diffRenamed:(0,r.register)("diff-renamed",60128),diff:(0,r.register)("diff",60129),diffSidebyside:(0,r.register)("diff-sidebyside",60129),discard:(0,r.register)("discard",60130),editorLayout:(0,r.register)("editor-layout",60131),emptyWindow:(0,r.register)("empty-window",60132),exclude:(0,r.register)("exclude",60133),extensions:(0,r.register)("extensions",60134),eyeClosed:(0,r.register)("eye-closed",60135),fileBinary:(0,r.register)("file-binary",60136),fileCode:(0,r.register)("file-code",60137),fileMedia:(0,r.register)("file-media",60138),filePdf:(0,r.register)("file-pdf",60139),fileSubmodule:(0,r.register)("file-submodule",60140),fileSymlinkDirectory:(0,r.register)("file-symlink-directory",60141),fileSymlinkFile:(0,r.register)("file-symlink-file",60142),fileZip:(0,r.register)("file-zip",60143),files:(0,r.register)("files",60144),filter:(0,r.register)("filter",60145),flame:(0,r.register)("flame",60146),foldDown:(0,r.register)("fold-down",60147),foldUp:(0,r.register)("fold-up",60148),fold:(0,r.register)("fold",60149),folderActive:(0,r.register)("folder-active",60150),folderOpened:(0,r.register)("folder-opened",60151),gear:(0,r.register)("gear",60152),gift:(0,r.register)("gift",60153),gistSecret:(0,r.register)("gist-secret",60154),gist:(0,r.register)("gist",60155),gitCommit:(0,r.register)("git-commit",60156),gitCompare:(0,r.register)("git-compare",60157),compareChanges:(0,r.register)("compare-changes",60157),gitMerge:(0,r.register)("git-merge",60158),githubAction:(0,r.register)("github-action",60159),githubAlt:(0,r.register)("github-alt",60160),globe:(0,r.register)("globe",60161),grabber:(0,r.register)("grabber",60162),graph:(0,r.register)("graph",60163),gripper:(0,r.register)("gripper",60164),heart:(0,r.register)("heart",60165),home:(0,r.register)("home",60166),horizontalRule:(0,r.register)("horizontal-rule",60167),hubot:(0,r.register)("hubot",60168),inbox:(0,r.register)("inbox",60169),issueReopened:(0,r.register)("issue-reopened",60171),issues:(0,r.register)("issues",60172),italic:(0,r.register)("italic",60173),jersey:(0,r.register)("jersey",60174),json:(0,r.register)("json",60175),kebabVertical:(0,r.register)("kebab-vertical",60176),key:(0,r.register)("key",60177),law:(0,r.register)("law",60178),lightbulbAutofix:(0,r.register)("lightbulb-autofix",60179),linkExternal:(0,r.register)("link-external",60180),link:(0,r.register)("link",60181),listOrdered:(0,r.register)("list-ordered",60182),listUnordered:(0,r.register)("list-unordered",60183),liveShare:(0,r.register)("live-share",60184),loading:(0,r.register)("loading",60185),location:(0,r.register)("location",60186),mailRead:(0,r.register)("mail-read",60187),mail:(0,r.register)("mail",60188),markdown:(0,r.register)("markdown",60189),megaphone:(0,r.register)("megaphone",60190),mention:(0,r.register)("mention",60191),milestone:(0,r.register)("milestone",60192),gitPullRequestMilestone:(0,r.register)("git-pull-request-milestone",60192),mortarBoard:(0,r.register)("mortar-board",60193),move:(0,r.register)("move",60194),multipleWindows:(0,r.register)("multiple-windows",60195),mute:(0,r.register)("mute",60196),noNewline:(0,r.register)("no-newline",60197),note:(0,r.register)("note",60198),octoface:(0,r.register)("octoface",60199),openPreview:(0,r.register)("open-preview",60200),package:(0,r.register)("package",60201),paintcan:(0,r.register)("paintcan",60202),pin:(0,r.register)("pin",60203),play:(0,r.register)("play",60204),run:(0,r.register)("run",60204),plug:(0,r.register)("plug",60205),preserveCase:(0,r.register)("preserve-case",60206),preview:(0,r.register)("preview",60207),project:(0,r.register)("project",60208),pulse:(0,r.register)("pulse",60209),question:(0,r.register)("question",60210),quote:(0,r.register)("quote",60211),radioTower:(0,r.register)("radio-tower",60212),reactions:(0,r.register)("reactions",60213),references:(0,r.register)("references",60214),refresh:(0,r.register)("refresh",60215),regex:(0,r.register)("regex",60216),remoteExplorer:(0,r.register)("remote-explorer",60217),remote:(0,r.register)("remote",60218),remove:(0,r.register)("remove",60219),replaceAll:(0,r.register)("replace-all",60220),replace:(0,r.register)("replace",60221),repoClone:(0,r.register)("repo-clone",60222),repoForcePush:(0,r.register)("repo-force-push",60223),repoPull:(0,r.register)("repo-pull",60224),repoPush:(0,r.register)("repo-push",60225),report:(0,r.register)("report",60226),requestChanges:(0,r.register)("request-changes",60227),rocket:(0,r.register)("rocket",60228),rootFolderOpened:(0,r.register)("root-folder-opened",60229),rootFolder:(0,r.register)("root-folder",60230),rss:(0,r.register)("rss",60231),ruby:(0,r.register)("ruby",60232),saveAll:(0,r.register)("save-all",60233),saveAs:(0,r.register)("save-as",60234),save:(0,r.register)("save",60235),screenFull:(0,r.register)("screen-full",60236),screenNormal:(0,r.register)("screen-normal",60237),searchStop:(0,r.register)("search-stop",60238),server:(0,r.register)("server",60240),settingsGear:(0,r.register)("settings-gear",60241),settings:(0,r.register)("settings",60242),shield:(0,r.register)("shield",60243),smiley:(0,r.register)("smiley",60244),sortPrecedence:(0,r.register)("sort-precedence",60245),splitHorizontal:(0,r.register)("split-horizontal",60246),splitVertical:(0,r.register)("split-vertical",60247),squirrel:(0,r.register)("squirrel",60248),starFull:(0,r.register)("star-full",60249),starHalf:(0,r.register)("star-half",60250),symbolClass:(0,r.register)("symbol-class",60251),symbolColor:(0,r.register)("symbol-color",60252),symbolConstant:(0,r.register)("symbol-constant",60253),symbolEnumMember:(0,r.register)("symbol-enum-member",60254),symbolField:(0,r.register)("symbol-field",60255),symbolFile:(0,r.register)("symbol-file",60256),symbolInterface:(0,r.register)("symbol-interface",60257),symbolKeyword:(0,r.register)("symbol-keyword",60258),symbolMisc:(0,r.register)("symbol-misc",60259),symbolOperator:(0,r.register)("symbol-operator",60260),symbolProperty:(0,r.register)("symbol-property",60261),wrench:(0,r.register)("wrench",60261),wrenchSubaction:(0,r.register)("wrench-subaction",60261),symbolSnippet:(0,r.register)("symbol-snippet",60262),tasklist:(0,r.register)("tasklist",60263),telescope:(0,r.register)("telescope",60264),textSize:(0,r.register)("text-size",60265),threeBars:(0,r.register)("three-bars",60266),thumbsdown:(0,r.register)("thumbsdown",60267),thumbsup:(0,r.register)("thumbsup",60268),tools:(0,r.register)("tools",60269),triangleDown:(0,r.register)("triangle-down",60270),triangleLeft:(0,r.register)("triangle-left",60271),triangleRight:(0,r.register)("triangle-right",60272),triangleUp:(0,r.register)("triangle-up",60273),twitter:(0,r.register)("twitter",60274),unfold:(0,r.register)("unfold",60275),unlock:(0,r.register)("unlock",60276),unmute:(0,r.register)("unmute",60277),unverified:(0,r.register)("unverified",60278),verified:(0,r.register)("verified",60279),versions:(0,r.register)("versions",60280),vmActive:(0,r.register)("vm-active",60281),vmOutline:(0,r.register)("vm-outline",60282),vmRunning:(0,r.register)("vm-running",60283),watch:(0,r.register)("watch",60284),whitespace:(0,r.register)("whitespace",60285),wholeWord:(0,r.register)("whole-word",60286),window:(0,r.register)("window",60287),wordWrap:(0,r.register)("word-wrap",60288),zoomIn:(0,r.register)("zoom-in",60289),zoomOut:(0,r.register)("zoom-out",60290),listFilter:(0,r.register)("list-filter",60291),listFlat:(0,r.register)("list-flat",60292),listSelection:(0,r.register)("list-selection",60293),selection:(0,r.register)("selection",60293),listTree:(0,r.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.register)("debug-stackframe-active",60297),circleSmallFilled:(0,r.register)("circle-small-filled",60298),debugStackframeDot:(0,r.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.register)("terminal-decoration-mark",60298),debugStackframe:(0,r.register)("debug-stackframe",60299),debugStackframeFocused:(0,r.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.register)("debug-breakpoint-unsupported",60300),symbolString:(0,r.register)("symbol-string",60301),debugReverseContinue:(0,r.register)("debug-reverse-continue",60302),debugStepBack:(0,r.register)("debug-step-back",60303),debugRestartFrame:(0,r.register)("debug-restart-frame",60304),debugAlt:(0,r.register)("debug-alt",60305),callIncoming:(0,r.register)("call-incoming",60306),callOutgoing:(0,r.register)("call-outgoing",60307),menu:(0,r.register)("menu",60308),expandAll:(0,r.register)("expand-all",60309),feedback:(0,r.register)("feedback",60310),gitPullRequestReviewer:(0,r.register)("git-pull-request-reviewer",60310),groupByRefType:(0,r.register)("group-by-ref-type",60311),ungroupByRefType:(0,r.register)("ungroup-by-ref-type",60312),account:(0,r.register)("account",60313),gitPullRequestAssignee:(0,r.register)("git-pull-request-assignee",60313),bellDot:(0,r.register)("bell-dot",60314),debugConsole:(0,r.register)("debug-console",60315),library:(0,r.register)("library",60316),output:(0,r.register)("output",60317),runAll:(0,r.register)("run-all",60318),syncIgnored:(0,r.register)("sync-ignored",60319),pinned:(0,r.register)("pinned",60320),githubInverted:(0,r.register)("github-inverted",60321),serverProcess:(0,r.register)("server-process",60322),serverEnvironment:(0,r.register)("server-environment",60323),pass:(0,r.register)("pass",60324),issueClosed:(0,r.register)("issue-closed",60324),stopCircle:(0,r.register)("stop-circle",60325),playCircle:(0,r.register)("play-circle",60326),record:(0,r.register)("record",60327),debugAltSmall:(0,r.register)("debug-alt-small",60328),vmConnect:(0,r.register)("vm-connect",60329),cloud:(0,r.register)("cloud",60330),merge:(0,r.register)("merge",60331),export:(0,r.register)("export",60332),graphLeft:(0,r.register)("graph-left",60333),magnet:(0,r.register)("magnet",60334),notebook:(0,r.register)("notebook",60335),redo:(0,r.register)("redo",60336),checkAll:(0,r.register)("check-all",60337),pinnedDirty:(0,r.register)("pinned-dirty",60338),passFilled:(0,r.register)("pass-filled",60339),circleLargeFilled:(0,r.register)("circle-large-filled",60340),circleLarge:(0,r.register)("circle-large",60341),circleLargeOutline:(0,r.register)("circle-large-outline",60341),combine:(0,r.register)("combine",60342),gather:(0,r.register)("gather",60342),table:(0,r.register)("table",60343),variableGroup:(0,r.register)("variable-group",60344),typeHierarchy:(0,r.register)("type-hierarchy",60345),typeHierarchySub:(0,r.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.register)("git-pull-request-create",60348),runAbove:(0,r.register)("run-above",60349),runBelow:(0,r.register)("run-below",60350),notebookTemplate:(0,r.register)("notebook-template",60351),debugRerun:(0,r.register)("debug-rerun",60352),workspaceTrusted:(0,r.register)("workspace-trusted",60353),workspaceUntrusted:(0,r.register)("workspace-untrusted",60354),workspaceUnknown:(0,r.register)("workspace-unknown",60355),terminalCmd:(0,r.register)("terminal-cmd",60356),terminalDebian:(0,r.register)("terminal-debian",60357),terminalLinux:(0,r.register)("terminal-linux",60358),terminalPowershell:(0,r.register)("terminal-powershell",60359),terminalTmux:(0,r.register)("terminal-tmux",60360),terminalUbuntu:(0,r.register)("terminal-ubuntu",60361),terminalBash:(0,r.register)("terminal-bash",60362),arrowSwap:(0,r.register)("arrow-swap",60363),copy:(0,r.register)("copy",60364),personAdd:(0,r.register)("person-add",60365),filterFilled:(0,r.register)("filter-filled",60366),wand:(0,r.register)("wand",60367),debugLineByLine:(0,r.register)("debug-line-by-line",60368),inspect:(0,r.register)("inspect",60369),layers:(0,r.register)("layers",60370),layersDot:(0,r.register)("layers-dot",60371),layersActive:(0,r.register)("layers-active",60372),compass:(0,r.register)("compass",60373),compassDot:(0,r.register)("compass-dot",60374),compassActive:(0,r.register)("compass-active",60375),azure:(0,r.register)("azure",60376),issueDraft:(0,r.register)("issue-draft",60377),gitPullRequestClosed:(0,r.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.register)("git-pull-request-draft",60379),debugAll:(0,r.register)("debug-all",60380),debugCoverage:(0,r.register)("debug-coverage",60381),runErrors:(0,r.register)("run-errors",60382),folderLibrary:(0,r.register)("folder-library",60383),debugContinueSmall:(0,r.register)("debug-continue-small",60384),beakerStop:(0,r.register)("beaker-stop",60385),graphLine:(0,r.register)("graph-line",60386),graphScatter:(0,r.register)("graph-scatter",60387),pieChart:(0,r.register)("pie-chart",60388),bracket:(0,r.register)("bracket",60175),bracketDot:(0,r.register)("bracket-dot",60389),bracketError:(0,r.register)("bracket-error",60390),lockSmall:(0,r.register)("lock-small",60391),azureDevops:(0,r.register)("azure-devops",60392),verifiedFilled:(0,r.register)("verified-filled",60393),newline:(0,r.register)("newline",60394),layout:(0,r.register)("layout",60395),layoutActivitybarLeft:(0,r.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.register)("layout-panel-left",60398),layoutPanelCenter:(0,r.register)("layout-panel-center",60399),layoutPanelJustify:(0,r.register)("layout-panel-justify",60400),layoutPanelRight:(0,r.register)("layout-panel-right",60401),layoutPanel:(0,r.register)("layout-panel",60402),layoutSidebarLeft:(0,r.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.register)("layout-sidebar-right",60404),layoutStatusbar:(0,r.register)("layout-statusbar",60405),layoutMenubar:(0,r.register)("layout-menubar",60406),layoutCentered:(0,r.register)("layout-centered",60407),target:(0,r.register)("target",60408),indent:(0,r.register)("indent",60409),recordSmall:(0,r.register)("record-small",60410),errorSmall:(0,r.register)("error-small",60411),terminalDecorationError:(0,r.register)("terminal-decoration-error",60411),arrowCircleDown:(0,r.register)("arrow-circle-down",60412),arrowCircleLeft:(0,r.register)("arrow-circle-left",60413),arrowCircleRight:(0,r.register)("arrow-circle-right",60414),arrowCircleUp:(0,r.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.register)("layout-sidebar-left-off",60418),blank:(0,r.register)("blank",60419),heartFilled:(0,r.register)("heart-filled",60420),map:(0,r.register)("map",60421),mapHorizontal:(0,r.register)("map-horizontal",60421),foldHorizontal:(0,r.register)("fold-horizontal",60421),mapFilled:(0,r.register)("map-filled",60422),mapHorizontalFilled:(0,r.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.register)("fold-horizontal-filled",60422),circleSmall:(0,r.register)("circle-small",60423),bellSlash:(0,r.register)("bell-slash",60424),bellSlashDot:(0,r.register)("bell-slash-dot",60425),commentUnresolved:(0,r.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.register)("search-fuzzy",60429),commentDraft:(0,r.register)("comment-draft",60430),send:(0,r.register)("send",60431),sparkle:(0,r.register)("sparkle",60432),insert:(0,r.register)("insert",60433),mic:(0,r.register)("mic",60434),thumbsdownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsupFilled:(0,r.register)("thumbsup-filled",60436),coffee:(0,r.register)("coffee",60437),snake:(0,r.register)("snake",60438),game:(0,r.register)("game",60439),vr:(0,r.register)("vr",60440),chip:(0,r.register)("chip",60441),piano:(0,r.register)("piano",60442),music:(0,r.register)("music",60443),micFilled:(0,r.register)("mic-filled",60444),repoFetch:(0,r.register)("repo-fetch",60445),copilot:(0,r.register)("copilot",60446),lightbulbSparkle:(0,r.register)("lightbulb-sparkle",60447),robot:(0,r.register)("robot",60448),sparkleFilled:(0,r.register)("sparkle-filled",60449),diffSingle:(0,r.register)("diff-single",60450),diffMultiple:(0,r.register)("diff-multiple",60451),surroundWith:(0,r.register)("surround-with",60452),share:(0,r.register)("share",60453),gitStash:(0,r.register)("git-stash",60454),gitStashApply:(0,r.register)("git-stash-apply",60455),gitStashPop:(0,r.register)("git-stash-pop",60456),vscode:(0,r.register)("vscode",60457),vscodeInsiders:(0,r.register)("vscode-insiders",60458),codeOss:(0,r.register)("code-oss",60459),runCoverage:(0,r.register)("run-coverage",60460),runAllCoverage:(0,r.register)("run-all-coverage",60461),coverage:(0,r.register)("coverage",60462),githubProject:(0,r.register)("github-project",60463),mapVertical:(0,r.register)("map-vertical",60464),foldVertical:(0,r.register)("fold-vertical",60464),mapVerticalFilled:(0,r.register)("map-vertical-filled",60465),foldVerticalFilled:(0,r.register)("fold-vertical-filled",60465),goToSearch:(0,r.register)("go-to-search",60466),percentage:(0,r.register)("percentage",60467),sortPercentage:(0,r.register)("sort-percentage",60467)}}),Y(X[42],Z([0,1,27,41]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.codiconsDerived=void 0,n.codiconsDerived={dialogError:(0,r.register)("dialog-error","error"),dialogWarning:(0,r.register)("dialog-warning","warning"),dialogInfo:(0,r.register)("dialog-info","info"),dialogClose:(0,r.register)("dialog-close","close"),treeItemExpanded:(0,r.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.register)("tree-filter-clear","close"),treeItemLoading:(0,r.register)("tree-item-loading","loading"),menuSelection:(0,r.register)("menu-selection","check"),menuSubmenu:(0,r.register)("menu-submenu","chevron-right"),menuBarMore:(0,r.register)("menubar-more","more"),scrollbarButtonLeft:(0,r.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.register)("toolbar-more","more"),quickInputBack:(0,r.register)("quick-input-back","arrow-left"),dropDownButton:(0,r.register)("drop-down-button",60084),symbolCustomColor:(0,r.register)("symbol-customcolor",60252),exportIcon:(0,r.register)("export",60332),workspaceUnspecified:(0,r.register)("workspace-unspecified",60355),newLine:(0,r.register)("newline",60394),thumbsDownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.register)("thumbsup-filled",60436),gitFetch:(0,r.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.register)("debug-breakpoint-pending",60377)},n.Codicon={...x.codiconsLibrary,...n.codiconsDerived}}),Y(X[14],Z([0,1,26]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.deepClone=x,n.deepFreeze=A,n.cloneAndChange=m,n.mixin=o,n.equals=a,n.getAllPropertyNames=v,n.getAllMethodNames=e,n.createProxyObject=f;function x(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const u=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([c,h])=>{u[c]=h&&typeof h=="object"?x(h):h}),u}function A(s){if(!s||typeof s!="object")return s;const u=[s];for(;u.length>0;){const c=u.shift();Object.freeze(c);for(const h in c)if(g.call(c,h)){const y=c[h];typeof y=="object"&&!Object.isFrozen(y)&&!(0,r.isTypedArray)(y)&&u.push(y)}}return s}const g=Object.prototype.hasOwnProperty;function m(s,u){return p(s,u,new Set)}function p(s,u,c){if((0,r.isUndefinedOrNull)(s))return s;const h=u(s);if(typeof h<"u")return h;if(Array.isArray(s)){const y=[];for(const C of s)y.push(p(C,u,c));return y}if((0,r.isObject)(s)){if(c.has(s))throw new Error("Cannot clone recursive data-structure");c.add(s);const y={};for(const C in s)g.call(s,C)&&(y[C]=p(s[C],u,c));return c.delete(s),y}return s}function o(s,u,c=!0){return(0,r.isObject)(s)?((0,r.isObject)(u)&&Object.keys(u).forEach(h=>{h in s?c&&((0,r.isObject)(s[h])&&(0,r.isObject)(u[h])?o(s[h],u[h],c):s[h]=u[h]):s[h]=u[h]}),s):u}function a(s,u){if(s===u)return!0;if(s==null||u===null||u===void 0||typeof s!=typeof u||typeof s!="object"||Array.isArray(s)!==Array.isArray(u))return!1;let c,h;if(Array.isArray(s)){if(s.length!==u.length)return!1;for(c=0;c<s.length;c++)if(!a(s[c],u[c]))return!1}else{const y=[];for(h in s)y.push(h);y.sort();const C=[];for(h in u)C.push(h);if(C.sort(),!a(y,C))return!1;for(c=0;c<y.length;c++)if(!a(s[y[c]],u[y[c]]))return!1}return!0}function v(s){let u=[];for(;Object.prototype!==s;)u=u.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return u}function e(s){const u=[];for(const c of v(s))typeof s[c]=="function"&&u.push(c);return u}function f(s,u){const c=y=>function(){const C=Array.prototype.slice.call(arguments,0);return u(y,C)},h={};for(const y of s)h[y]=c(y);return h}}),Y(X[28],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint8=r,n.toUint32=x;function r(A){return A<0?0:A>255?255:A|0}function x(A){return A<0?0:A>4294967295?4294967295:A|0}}),Y(X[29],Z([0,1,28]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class x{constructor(m){const p=(0,r.toUint8)(m);this._defaultValue=p,this._asciiMap=x._createAsciiMap(p),this._map=new Map}static _createAsciiMap(m){const p=new Uint8Array(256);return p.fill(m),p}set(m,p){const o=(0,r.toUint8)(p);m>=0&&m<256?this._asciiMap[m]=o:this._map.set(m,o)}get(m){return m>=0&&m<256?this._asciiMap[m]:this._map.get(m)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=x;class A{constructor(){this._actual=new x(0)}add(m){this._actual.set(m,1)}has(m){return this._actual.get(m)===1}clear(){return this._actual.clear()}}n.CharacterSet=A}),Y(X[3],Z([0,1,5]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class x{static addRange(m,p){let o=0;for(;o<p.length&&p[o].endExclusive<m.start;)o++;let a=o;for(;a<p.length&&p[a].start<=m.endExclusive;)a++;if(o===a)p.splice(o,0,m);else{const v=Math.min(m.start,p[o].start),e=Math.max(m.endExclusive,p[a-1].endExclusive);p.splice(o,a-o,new x(v,e))}}static tryCreate(m,p){if(!(m>p))return new x(m,p)}static ofLength(m){return new x(0,m)}static ofStartAndLength(m,p){return new x(m,m+p)}constructor(m,p){if(this.start=m,this.endExclusive=p,m>p)throw new r.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(m){return new x(this.start+m,this.endExclusive+m)}deltaStart(m){return new x(this.start+m,this.endExclusive)}deltaEnd(m){return new x(this.start,this.endExclusive+m)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}contains(m){return this.start<=m&&m<this.endExclusive}join(m){return new x(Math.min(this.start,m.start),Math.max(this.endExclusive,m.endExclusive))}intersect(m){const p=Math.max(this.start,m.start),o=Math.min(this.endExclusive,m.endExclusive);if(p<=o)return new x(p,o)}intersects(m){const p=Math.max(this.start,m.start),o=Math.min(this.endExclusive,m.endExclusive);return p<o}isBefore(m){return this.endExclusive<=m.start}isAfter(m){return this.start>=m.endExclusive}slice(m){return m.slice(this.start,this.endExclusive)}substring(m){return m.substring(this.start,this.endExclusive)}clip(m){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,m))}clipCyclic(m){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return m<this.start?this.endExclusive-(this.start-m)%this.length:m>=this.endExclusive?this.start+(m-this.start)%this.length:m}forEach(m){for(let p=this.start;p<this.endExclusive;p++)m(p)}}n.OffsetRange=x;class A{constructor(){this._sortedRanges=[]}addRange(m){let p=0;for(;p<this._sortedRanges.length&&this._sortedRanges[p].endExclusive<m.start;)p++;let o=p;for(;o<this._sortedRanges.length&&this._sortedRanges[o].start<=m.endExclusive;)o++;if(p===o)this._sortedRanges.splice(p,0,m);else{const a=Math.min(m.start,this._sortedRanges[p].start),v=Math.max(m.endExclusive,this._sortedRanges[o-1].endExclusive);this._sortedRanges.splice(p,o-p,new x(a,v))}}toString(){return this._sortedRanges.map(m=>m.toString()).join(", ")}intersectsStrict(m){let p=0;for(;p<this._sortedRanges.length&&this._sortedRanges[p].endExclusive<=m.start;)p++;return p<this._sortedRanges.length&&this._sortedRanges[p].start<m.endExclusive}intersectWithRange(m){const p=new A;for(const o of this._sortedRanges){const a=o.intersect(m);a&&p.addRange(a)}return p}intersectWithRangeLength(m){return this.intersectWithRange(m).length}get length(){return this._sortedRanges.reduce((m,p)=>m+p.length,0)}}n.OffsetRangeSet=A}),Y(X[4],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class r{constructor(A,g){this.lineNumber=A,this.column=g}with(A=this.lineNumber,g=this.column){return A===this.lineNumber&&g===this.column?this:new r(A,g)}delta(A=0,g=0){return this.with(this.lineNumber+A,this.column+g)}equals(A){return r.equals(this,A)}static equals(A,g){return!A&&!g?!0:!!A&&!!g&&A.lineNumber===g.lineNumber&&A.column===g.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,g){return A.lineNumber<g.lineNumber?!0:g.lineNumber<A.lineNumber?!1:A.column<g.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,g){return A.lineNumber<g.lineNumber?!0:g.lineNumber<A.lineNumber?!1:A.column<=g.column}static compare(A,g){const m=A.lineNumber|0,p=g.lineNumber|0;if(m===p){const o=A.column|0,a=g.column|0;return o-a}return m-p}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}n.Position=r}),Y(X[2],Z([0,1,4]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class x{constructor(g,m,p,o){g>p||g===p&&m>o?(this.startLineNumber=p,this.startColumn=o,this.endLineNumber=g,this.endColumn=m):(this.startLineNumber=g,this.startColumn=m,this.endLineNumber=p,this.endColumn=o)}isEmpty(){return x.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return x.containsPosition(this,g)}static containsPosition(g,m){return!(m.lineNumber<g.startLineNumber||m.lineNumber>g.endLineNumber||m.lineNumber===g.startLineNumber&&m.column<g.startColumn||m.lineNumber===g.endLineNumber&&m.column>g.endColumn)}static strictContainsPosition(g,m){return!(m.lineNumber<g.startLineNumber||m.lineNumber>g.endLineNumber||m.lineNumber===g.startLineNumber&&m.column<=g.startColumn||m.lineNumber===g.endLineNumber&&m.column>=g.endColumn)}containsRange(g){return x.containsRange(this,g)}static containsRange(g,m){return!(m.startLineNumber<g.startLineNumber||m.endLineNumber<g.startLineNumber||m.startLineNumber>g.endLineNumber||m.endLineNumber>g.endLineNumber||m.startLineNumber===g.startLineNumber&&m.startColumn<g.startColumn||m.endLineNumber===g.endLineNumber&&m.endColumn>g.endColumn)}strictContainsRange(g){return x.strictContainsRange(this,g)}static strictContainsRange(g,m){return!(m.startLineNumber<g.startLineNumber||m.endLineNumber<g.startLineNumber||m.startLineNumber>g.endLineNumber||m.endLineNumber>g.endLineNumber||m.startLineNumber===g.startLineNumber&&m.startColumn<=g.startColumn||m.endLineNumber===g.endLineNumber&&m.endColumn>=g.endColumn)}plusRange(g){return x.plusRange(this,g)}static plusRange(g,m){let p,o,a,v;return m.startLineNumber<g.startLineNumber?(p=m.startLineNumber,o=m.startColumn):m.startLineNumber===g.startLineNumber?(p=m.startLineNumber,o=Math.min(m.startColumn,g.startColumn)):(p=g.startLineNumber,o=g.startColumn),m.endLineNumber>g.endLineNumber?(a=m.endLineNumber,v=m.endColumn):m.endLineNumber===g.endLineNumber?(a=m.endLineNumber,v=Math.max(m.endColumn,g.endColumn)):(a=g.endLineNumber,v=g.endColumn),new x(p,o,a,v)}intersectRanges(g){return x.intersectRanges(this,g)}static intersectRanges(g,m){let p=g.startLineNumber,o=g.startColumn,a=g.endLineNumber,v=g.endColumn;const e=m.startLineNumber,f=m.startColumn,s=m.endLineNumber,u=m.endColumn;return p<e?(p=e,o=f):p===e&&(o=Math.max(o,f)),a>s?(a=s,v=u):a===s&&(v=Math.min(v,u)),p>a||p===a&&o>v?null:new x(p,o,a,v)}equalsRange(g){return x.equalsRange(this,g)}static equalsRange(g,m){return!g&&!m?!0:!!g&&!!m&&g.startLineNumber===m.startLineNumber&&g.startColumn===m.startColumn&&g.endLineNumber===m.endLineNumber&&g.endColumn===m.endColumn}getEndPosition(){return x.getEndPosition(this)}static getEndPosition(g){return new r.Position(g.endLineNumber,g.endColumn)}getStartPosition(){return x.getStartPosition(this)}static getStartPosition(g){return new r.Position(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,m){return new x(this.startLineNumber,this.startColumn,g,m)}setStartPosition(g,m){return new x(g,m,this.endLineNumber,this.endColumn)}collapseToStart(){return x.collapseToStart(this)}static collapseToStart(g){return new x(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return x.collapseToEnd(this)}static collapseToEnd(g){return new x(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new x(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,m=g){return new x(g.lineNumber,g.column,m.lineNumber,m.column)}static lift(g){return g?new x(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,m){return!(g.endLineNumber<m.startLineNumber||g.endLineNumber===m.startLineNumber&&g.endColumn<m.startColumn||m.endLineNumber<g.startLineNumber||m.endLineNumber===g.startLineNumber&&m.endColumn<g.startColumn)}static areIntersecting(g,m){return!(g.endLineNumber<m.startLineNumber||g.endLineNumber===m.startLineNumber&&g.endColumn<=m.startColumn||m.endLineNumber<g.startLineNumber||m.endLineNumber===g.startLineNumber&&m.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,m){if(g&&m){const a=g.startLineNumber|0,v=m.startLineNumber|0;if(a===v){const e=g.startColumn|0,f=m.startColumn|0;if(e===f){const s=g.endLineNumber|0,u=m.endLineNumber|0;if(s===u){const c=g.endColumn|0,h=m.endColumn|0;return c-h}return s-u}return e-f}return a-v}return(g?1:0)-(m?1:0)}static compareRangesUsingEnds(g,m){return g.endLineNumber===m.endLineNumber?g.endColumn===m.endColumn?g.startLineNumber===m.startLineNumber?g.startColumn-m.startColumn:g.startLineNumber-m.startLineNumber:g.endColumn-m.endColumn:g.endLineNumber-m.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}n.Range=x}),Y(X[10],Z([0,1,5,3,2,11]),function(O,n,r,x,A,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class m{static fromRangeInclusive(a){return new m(a.startLineNumber,a.endLineNumber+1)}static joinMany(a){if(a.length===0)return[];let v=new p(a[0].slice());for(let e=1;e<a.length;e++)v=v.getUnion(new p(a[e].slice()));return v.ranges}static join(a){if(a.length===0)throw new r.BugIndicatingError("lineRanges cannot be empty");let v=a[0].startLineNumber,e=a[0].endLineNumberExclusive;for(let f=1;f<a.length;f++)v=Math.min(v,a[f].startLineNumber),e=Math.max(e,a[f].endLineNumberExclusive);return new m(v,e)}static ofLength(a,v){return new m(a,a+v)}static deserialize(a){return new m(a[0],a[1])}constructor(a,v){if(a>v)throw new r.BugIndicatingError(`startLineNumber ${a} cannot be after endLineNumberExclusive ${v}`);this.startLineNumber=a,this.endLineNumberExclusive=v}contains(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(a){return new m(this.startLineNumber+a,this.endLineNumberExclusive+a)}deltaLength(a){return new m(this.startLineNumber,this.endLineNumberExclusive+a)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(a){return new m(Math.min(this.startLineNumber,a.startLineNumber),Math.max(this.endLineNumberExclusive,a.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(a){const v=Math.max(this.startLineNumber,a.startLineNumber),e=Math.min(this.endLineNumberExclusive,a.endLineNumberExclusive);if(v<=e)return new m(v,e)}intersectsStrict(a){return this.startLineNumber<a.endLineNumberExclusive&&a.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(a){return this.startLineNumber<=a.endLineNumberExclusive&&a.startLineNumber<=this.endLineNumberExclusive}equals(a){return this.startLineNumber===a.startLineNumber&&this.endLineNumberExclusive===a.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new A.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new A.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(a){const v=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)v.push(a(e));return v}forEach(a){for(let v=this.startLineNumber;v<this.endLineNumberExclusive;v++)a(v)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}toOffsetRange(){return new x.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=m;class p{constructor(a=[]){this._normalizedRanges=a}get ranges(){return this._normalizedRanges}addRange(a){if(a.length===0)return;const v=(0,g.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,f=>f.endLineNumberExclusive>=a.startLineNumber),e=(0,g.findLastIdxMonotonous)(this._normalizedRanges,f=>f.startLineNumber<=a.endLineNumberExclusive)+1;if(v===e)this._normalizedRanges.splice(v,0,a);else if(v===e-1){const f=this._normalizedRanges[v];this._normalizedRanges[v]=f.join(a)}else{const f=this._normalizedRanges[v].join(this._normalizedRanges[e-1]).join(a);this._normalizedRanges.splice(v,e-v,f)}}contains(a){const v=(0,g.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=a);return!!v&&v.endLineNumberExclusive>a}intersects(a){const v=(0,g.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<a.endLineNumberExclusive);return!!v&&v.endLineNumberExclusive>a.startLineNumber}getUnion(a){if(this._normalizedRanges.length===0)return a;if(a._normalizedRanges.length===0)return this;const v=[];let e=0,f=0,s=null;for(;e<this._normalizedRanges.length||f<a._normalizedRanges.length;){let u=null;if(e<this._normalizedRanges.length&&f<a._normalizedRanges.length){const c=this._normalizedRanges[e],h=a._normalizedRanges[f];c.startLineNumber<h.startLineNumber?(u=c,e++):(u=h,f++)}else e<this._normalizedRanges.length?(u=this._normalizedRanges[e],e++):(u=a._normalizedRanges[f],f++);s===null?s=u:s.endLineNumberExclusive>=u.startLineNumber?s=new m(s.startLineNumber,Math.max(s.endLineNumberExclusive,u.endLineNumberExclusive)):(v.push(s),s=u)}return s!==null&&v.push(s),new p(v)}subtractFrom(a){const v=(0,g.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,u=>u.endLineNumberExclusive>=a.startLineNumber),e=(0,g.findLastIdxMonotonous)(this._normalizedRanges,u=>u.startLineNumber<=a.endLineNumberExclusive)+1;if(v===e)return new p([a]);const f=[];let s=a.startLineNumber;for(let u=v;u<e;u++){const c=this._normalizedRanges[u];c.startLineNumber>s&&f.push(new m(s,c.startLineNumber)),s=c.endLineNumberExclusive}return s<a.endLineNumberExclusive&&f.push(new m(s,a.endLineNumberExclusive)),new p(f)}toString(){return this._normalizedRanges.map(a=>a.toString()).join(", ")}getIntersection(a){const v=[];let e=0,f=0;for(;e<this._normalizedRanges.length&&f<a._normalizedRanges.length;){const s=this._normalizedRanges[e],u=a._normalizedRanges[f],c=s.intersect(u);c&&!c.isEmpty&&v.push(c),s.endLineNumberExclusive<u.endLineNumberExclusive?e++:f++}return new p(v)}getWithDelta(a){return new p(this._normalizedRanges.map(v=>v.delta(a)))}}n.LineRangeSet=p}),Y(X[43],Z([0,1,4,2]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class A extends x.Range{constructor(m,p,o,a){super(m,p,o,a),this.selectionStartLineNumber=m,this.selectionStartColumn=p,this.positionLineNumber=o,this.positionColumn=a}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return A.selectionsEqual(this,m)}static selectionsEqual(m,p){return m.selectionStartLineNumber===p.selectionStartLineNumber&&m.selectionStartColumn===p.selectionStartColumn&&m.positionLineNumber===p.positionLineNumber&&m.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,p){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,m,p):new A(m,p,this.startLineNumber,this.startColumn)}getPosition(){return new r.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,p){return this.getDirection()===0?new A(m,p,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,m,p)}static fromPositions(m,p=m){return new A(m.lineNumber,m.column,p.lineNumber,p.column)}static fromRange(m,p){return p===0?new A(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new A(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new A(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,p){if(m&&!p||!m&&p)return!1;if(!m&&!p)return!0;if(m.length!==p.length)return!1;for(let o=0,a=m.length;o<a;o++)if(!this.selectionsEqual(m[o],p[o]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,p,o,a,v){return v===0?new A(m,p,o,a):new A(o,a,m,p)}}n.Selection=A}),Y(X[44],Z([0,1,23,29]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WordCharacterClassifier=void 0,n.getMapForWordSeparators=m;class A extends x.CharacterClassifier{constructor(o,a){super(0),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=a,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let v=0,e=o.length;v<e;v++)this.set(o.charCodeAt(v),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(o,a){let v=null;for(const e of this._getIntlSegmenterWordsOnLine(o)){if(e.index>a)break;v=e}return v}findNextIntlWordAtOrAfterOffset(o,a){for(const v of this._getIntlSegmenterWordsOnLine(o))if(!(v.index<a))return v;return null}_getIntlSegmenterWordsOnLine(o){return this._segmenter?this._cachedLine===o?this._cachedSegments:(this._cachedLine=o,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(o)),this._cachedSegments):[]}_filterWordSegments(o){const a=[];for(const v of o)this._isWordLike(v)&&a.push(v);return a}_isWordLike(o){return!!o.isWordLike}}n.WordCharacterClassifier=A;const g=new r.LRUCache(10);function m(p,o){const a=`${p}/${o.join(",")}`;let v=g.get(a);return v||(v=new A(p,o),g.set(a,v)),v}}),Y(X[30],Z([0,1,21,22]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.ensureValidWordDefinition=g,n.getWordAtText=p,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(a=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)a.indexOf(e)>=0||(v+="\\"+e);return v+="\\s]+)",new RegExp(v,"g")}n.DEFAULT_WORD_REGEXP=A();function g(a){let v=n.DEFAULT_WORD_REGEXP;if(a&&a instanceof RegExp)if(a.global)v=a;else{let e="g";a.ignoreCase&&(e+="i"),a.multiline&&(e+="m"),a.unicode&&(e+="u"),v=new RegExp(a.source,e)}return v.lastIndex=0,v}const m=new x.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(a,v,e,f,s){if(v=g(v),s||(s=r.Iterable.first(m)),e.length>s.maxLen){let C=a-s.maxLen/2;return C<0?C=0:f+=C,e=e.substring(C,a+s.maxLen/2),p(a,v,e,f,s)}const u=Date.now(),c=a-1-f;let h=-1,y=null;for(let C=1;!(Date.now()-u>=s.timeBudget);C++){const N=c-s.windowSize*C;v.lastIndex=Math.max(0,N);const R=o(v,e,c,h);if(!R&&y||(y=R,N<=0))break;h=N}if(y){const C={word:y[0],startColumn:f+1+y.index,endColumn:f+1+y.index+y[0].length};return v.lastIndex=0,C}return null}function o(a,v,e,f){let s;for(;s=a.exec(v);){const u=s.index||0;if(u<=e&&a.lastIndex>=e)return s;if(f>0&&u>f)return null}return null}}),Y(X[8],Z([0,1,7,5,3]),function(O,n,r,x,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.OffsetPair=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class g{static trivial(e,f){return new g([new m(A.OffsetRange.ofLength(e.length),A.OffsetRange.ofLength(f.length))],!1)}static trivialTimedOut(e,f){return new g([new m(A.OffsetRange.ofLength(e.length),A.OffsetRange.ofLength(f.length))],!0)}constructor(e,f){this.diffs=e,this.hitTimeout=f}}n.DiffAlgorithmResult=g;class m{static invert(e,f){const s=[];return(0,r.forEachAdjacent)(e,(u,c)=>{s.push(m.fromOffsetPairs(u?u.getEndExclusives():p.zero,c?c.getStarts():new p(f,(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+f)))}),s}static fromOffsetPairs(e,f){return new m(new A.OffsetRange(e.offset1,f.offset1),new A.OffsetRange(e.offset2,f.offset2))}constructor(e,f){this.seq1Range=e,this.seq2Range=f}swap(){return new m(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(e){return new m(this.seq1Range.join(e.seq1Range),this.seq2Range.join(e.seq2Range))}delta(e){return e===0?this:new m(this.seq1Range.delta(e),this.seq2Range.delta(e))}deltaStart(e){return e===0?this:new m(this.seq1Range.deltaStart(e),this.seq2Range.deltaStart(e))}deltaEnd(e){return e===0?this:new m(this.seq1Range.deltaEnd(e),this.seq2Range.deltaEnd(e))}intersect(e){const f=this.seq1Range.intersect(e.seq1Range),s=this.seq2Range.intersect(e.seq2Range);if(!(!f||!s))return new m(f,s)}getStarts(){return new p(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new p(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}n.SequenceDiff=m;class p{constructor(e,f){this.offset1=e,this.offset2=f}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(e){return e===0?this:new p(this.offset1+e,this.offset2+e)}equals(e){return this.offset1===e.offset1&&this.offset2===e.offset2}}n.OffsetPair=p,p.zero=new p(0,0),p.max=new p(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class o{isValid(){return!0}}n.InfiniteTimeout=o,o.instance=new o;class a{constructor(e){if(this.timeout=e,this.startTime=Date.now(),this.valid=!0,e<=0)throw new x.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=a}),Y(X[31],Z([0,1,3,8]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class A{compute(a,v,e=x.InfiniteTimeout.instance){if(a.length===0||v.length===0)return x.DiffAlgorithmResult.trivial(a,v);const f=a,s=v;function u(l,d){for(;l<f.length&&d<s.length&&f.getElement(l)===s.getElement(d);)l++,d++;return l}let c=0;const h=new m;h.set(0,u(0,0));const y=new p;y.set(0,h.get(0)===0?null:new g(null,0,0,h.get(0)));let C=0;e:for(;;){if(c++,!e.isValid())return x.DiffAlgorithmResult.trivialTimedOut(f,s);const l=-Math.min(c,s.length+c%2),d=Math.min(c,f.length+c%2);for(C=l;C<=d;C+=2){let L=0;const b=C===d?-1:h.get(C+1),_=C===l?-1:h.get(C-1)+1;L++;const E=Math.min(Math.max(b,_),f.length),S=E-C;if(L++,E>f.length||S>s.length)continue;const M=u(E,S);h.set(C,M);const D=E===b?y.get(C+1):y.get(C-1);if(y.set(C,M!==E?new g(D,E,S,M-E):D),h.get(C)===f.length&&h.get(C)-C===s.length)break e}}let N=y.get(C);const R=[];let w=f.length,i=s.length;for(;;){const l=N?N.x+N.length:0,d=N?N.y+N.length:0;if((l!==w||d!==i)&&R.push(new x.SequenceDiff(new r.OffsetRange(l,w),new r.OffsetRange(d,i))),!N)break;w=N.x,i=N.y,N=N.prev}return R.reverse(),new x.DiffAlgorithmResult(R,!1)}}n.MyersDiffAlgorithm=A;class g{constructor(a,v,e,f){this.prev=a,this.x=v,this.y=e,this.length=f}}class m{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,v){if(a<0){if(a=-a-1,a>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[a]=v}else{if(a>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[a]=v}}}class p{constructor(){this.positiveArr=[],this.negativeArr=[]}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,v){a<0?(a=-a-1,this.negativeArr[a]=v):this.positiveArr[a]=v}}}),Y(X[45],Z([0,1,7,3,8]),function(O,n,r,x,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.optimizeSequenceDiffs=g,n.removeShortMatches=a,n.extendDiffsToEntireWordIfAppropriate=v,n.removeVeryShortMatchingLinesBetweenDiffs=f,n.removeVeryShortMatchingTextBetweenLongDiffs=s;function g(u,c,h){let y=h;return y=m(u,c,y),y=m(u,c,y),y=p(u,c,y),y}function m(u,c,h){if(h.length===0)return h;const y=[];y.push(h[0]);for(let N=1;N<h.length;N++){const R=y[y.length-1];let w=h[N];if(w.seq1Range.isEmpty||w.seq2Range.isEmpty){const i=w.seq1Range.start-R.seq1Range.endExclusive;let l;for(l=1;l<=i&&!(u.getElement(w.seq1Range.start-l)!==u.getElement(w.seq1Range.endExclusive-l)||c.getElement(w.seq2Range.start-l)!==c.getElement(w.seq2Range.endExclusive-l));l++);if(l--,l===i){y[y.length-1]=new A.SequenceDiff(new x.OffsetRange(R.seq1Range.start,w.seq1Range.endExclusive-i),new x.OffsetRange(R.seq2Range.start,w.seq2Range.endExclusive-i));continue}w=w.delta(-l)}y.push(w)}const C=[];for(let N=0;N<y.length-1;N++){const R=y[N+1];let w=y[N];if(w.seq1Range.isEmpty||w.seq2Range.isEmpty){const i=R.seq1Range.start-w.seq1Range.endExclusive;let l;for(l=0;l<i&&!(!u.isStronglyEqual(w.seq1Range.start+l,w.seq1Range.endExclusive+l)||!c.isStronglyEqual(w.seq2Range.start+l,w.seq2Range.endExclusive+l));l++);if(l===i){y[N+1]=new A.SequenceDiff(new x.OffsetRange(w.seq1Range.start+i,R.seq1Range.endExclusive),new x.OffsetRange(w.seq2Range.start+i,R.seq2Range.endExclusive));continue}l>0&&(w=w.delta(l))}C.push(w)}return y.length>0&&C.push(y[y.length-1]),C}function p(u,c,h){if(!u.getBoundaryScore||!c.getBoundaryScore)return h;for(let y=0;y<h.length;y++){const C=y>0?h[y-1]:void 0,N=h[y],R=y+1<h.length?h[y+1]:void 0,w=new x.OffsetRange(C?C.seq1Range.endExclusive+1:0,R?R.seq1Range.start-1:u.length),i=new x.OffsetRange(C?C.seq2Range.endExclusive+1:0,R?R.seq2Range.start-1:c.length);N.seq1Range.isEmpty?h[y]=o(N,u,c,w,i):N.seq2Range.isEmpty&&(h[y]=o(N.swap(),c,u,i,w).swap())}return h}function o(u,c,h,y,C){let R=1;for(;u.seq1Range.start-R>=y.start&&u.seq2Range.start-R>=C.start&&h.isStronglyEqual(u.seq2Range.start-R,u.seq2Range.endExclusive-R)&&R<100;)R++;R--;let w=0;for(;u.seq1Range.start+w<y.endExclusive&&u.seq2Range.endExclusive+w<C.endExclusive&&h.isStronglyEqual(u.seq2Range.start+w,u.seq2Range.endExclusive+w)&&w<100;)w++;if(R===0&&w===0)return u;let i=0,l=-1;for(let d=-R;d<=w;d++){const L=u.seq2Range.start+d,b=u.seq2Range.endExclusive+d,_=u.seq1Range.start+d,E=c.getBoundaryScore(_)+h.getBoundaryScore(L)+h.getBoundaryScore(b);E>l&&(l=E,i=d)}return u.delta(i)}function a(u,c,h){const y=[];for(const C of h){const N=y[y.length-1];if(!N){y.push(C);continue}C.seq1Range.start-N.seq1Range.endExclusive<=2||C.seq2Range.start-N.seq2Range.endExclusive<=2?y[y.length-1]=new A.SequenceDiff(N.seq1Range.join(C.seq1Range),N.seq2Range.join(C.seq2Range)):y.push(C)}return y}function v(u,c,h){const y=A.SequenceDiff.invert(h,u.length),C=[];let N=new A.OffsetPair(0,0);function R(i,l){if(i.offset1<N.offset1||i.offset2<N.offset2)return;const d=u.findWordContaining(i.offset1),L=c.findWordContaining(i.offset2);if(!d||!L)return;let b=new A.SequenceDiff(d,L);const _=b.intersect(l);let E=_.seq1Range.length,S=_.seq2Range.length;for(;y.length>0;){const M=y[0];if(!(M.seq1Range.intersects(b.seq1Range)||M.seq2Range.intersects(b.seq2Range)))break;const T=u.findWordContaining(M.seq1Range.start),k=c.findWordContaining(M.seq2Range.start),q=new A.SequenceDiff(T,k),H=q.intersect(M);if(E+=H.seq1Range.length,S+=H.seq2Range.length,b=b.join(q),b.seq1Range.endExclusive>=M.seq1Range.endExclusive)y.shift();else break}E+S<(b.seq1Range.length+b.seq2Range.length)*2/3&&C.push(b),N=b.getEndExclusives()}for(;y.length>0;){const i=y.shift();i.seq1Range.isEmpty||(R(i.getStarts(),i),R(i.getEndExclusives().delta(-1),i))}return e(h,C)}function e(u,c){const h=[];for(;u.length>0||c.length>0;){const y=u[0],C=c[0];let N;y&&(!C||y.seq1Range.start<C.seq1Range.start)?N=u.shift():N=c.shift(),h.length>0&&h[h.length-1].seq1Range.endExclusive>=N.seq1Range.start?h[h.length-1]=h[h.length-1].join(N):h.push(N)}return h}function f(u,c,h){let y=h;if(y.length===0)return y;let C=0,N;do{N=!1;const R=[y[0]];for(let w=1;w<y.length;w++){let d=function(b,_){const E=new x.OffsetRange(l.seq1Range.endExclusive,i.seq1Range.start);return u.getText(E).replace(/\s/g,"").length<=4&&(b.seq1Range.length+b.seq2Range.length>5||_.seq1Range.length+_.seq2Range.length>5)};const i=y[w],l=R[R.length-1];d(l,i)?(N=!0,R[R.length-1]=R[R.length-1].join(i)):R.push(i)}y=R}while(C++<10&&N);return y}function s(u,c,h){let y=h;if(y.length===0)return y;let C=0,N;do{N=!1;const w=[y[0]];for(let i=1;i<y.length;i++){let L=function(_,E){const S=new x.OffsetRange(d.seq1Range.endExclusive,l.seq1Range.start);if(u.countLinesIn(S)>5||S.length>500)return!1;const D=u.getText(S).trim();if(D.length>20||D.split(/\r\n|\r|\n/).length>1)return!1;const T=u.countLinesIn(_.seq1Range),k=_.seq1Range.length,q=c.countLinesIn(_.seq2Range),H=_.seq2Range.length,Q=u.countLinesIn(E.seq1Range),F=E.seq1Range.length,I=c.countLinesIn(E.seq2Range),W=E.seq2Range.length,V=2*40+50;function z(U){return Math.min(U,V)}return Math.pow(Math.pow(z(T*40+k),1.5)+Math.pow(z(q*40+H),1.5),1.5)+Math.pow(Math.pow(z(Q*40+F),1.5)+Math.pow(z(I*40+W),1.5),1.5)>(V**1.5)**1.5*1.3};const l=y[i],d=w[w.length-1];L(d,l)?(N=!0,w[w.length-1]=w[w.length-1].join(l)):w.push(l)}y=w}while(C++<10&&N);const R=[];return(0,r.forEachWithNeighbors)(y,(w,i,l)=>{let d=i;function L(D){return D.length>0&&D.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const b=u.extendToFullLines(i.seq1Range),_=u.getText(new x.OffsetRange(b.start,i.seq1Range.start));L(_)&&(d=d.deltaStart(-_.length));const E=u.getText(new x.OffsetRange(i.seq1Range.endExclusive,b.endExclusive));L(E)&&(d=d.deltaEnd(E.length));const S=A.SequenceDiff.fromOffsetPairs(w?w.getEndExclusives():A.OffsetPair.zero,l?l.getStarts():A.OffsetPair.max),M=d.intersect(S);R.length>0&&M.getStarts().equals(R[R.length-1].getEndExclusives())?R[R.length-1]=R[R.length-1].join(M):R.push(M)}),R}}),Y(X[46],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=void 0;class r{constructor(g,m){this.trimmedHash=g,this.lines=m}getElement(g){return this.trimmedHash[g]}get length(){return this.trimmedHash.length}getBoundaryScore(g){const m=g===0?0:x(this.lines[g-1]),p=g===this.lines.length?0:x(this.lines[g]);return 1e3-(m+p)}getText(g){return this.lines.slice(g.start,g.endExclusive).join(`
`)}isStronglyEqual(g,m){return this.lines[g]===this.lines[m]}}n.LineSequence=r;function x(A){let g=0;for(;g<A.length&&(A.charCodeAt(g)===32||A.charCodeAt(g)===9);)g++;return g}}),Y(X[15],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeFragment=n.Array2D=void 0,n.isSpace=x;class r{constructor(m,p){this.width=m,this.height=p,this.array=[],this.array=new Array(m*p)}get(m,p){return this.array[m+p*this.width]}set(m,p,o){this.array[m+p*this.width]=o}}n.Array2D=r;function x(g){return g===32||g===9}class A{static getKey(m){let p=this.chrKeys.get(m);return p===void 0&&(p=this.chrKeys.size,this.chrKeys.set(m,p)),p}constructor(m,p,o){this.range=m,this.lines=p,this.source=o,this.histogram=[];let a=0;for(let v=m.startLineNumber-1;v<m.endLineNumberExclusive-1;v++){const e=p[v];for(let s=0;s<e.length;s++){a++;const u=e[s],c=A.getKey(u);this.histogram[c]=(this.histogram[c]||0)+1}a++;const f=A.getKey(`
`);this.histogram[f]=(this.histogram[f]||0)+1}this.totalCount=a}computeSimilarity(m){var p,o;let a=0;const v=Math.max(this.histogram.length,m.histogram.length);for(let e=0;e<v;e++)a+=Math.abs(((p=this.histogram[e])!==null&&p!==void 0?p:0)-((o=m.histogram[e])!==null&&o!==void 0?o:0));return 1-a/(this.totalCount+m.totalCount)}}n.LineRangeFragment=A,A.chrKeys=new Map}),Y(X[47],Z([0,1,3,8,15]),function(O,n,r,x,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class g{compute(p,o,a=x.InfiniteTimeout.instance,v){if(p.length===0||o.length===0)return x.DiffAlgorithmResult.trivial(p,o);const e=new A.Array2D(p.length,o.length),f=new A.Array2D(p.length,o.length),s=new A.Array2D(p.length,o.length);for(let R=0;R<p.length;R++)for(let w=0;w<o.length;w++){if(!a.isValid())return x.DiffAlgorithmResult.trivialTimedOut(p,o);const i=R===0?0:e.get(R-1,w),l=w===0?0:e.get(R,w-1);let d;p.getElement(R)===o.getElement(w)?(R===0||w===0?d=0:d=e.get(R-1,w-1),R>0&&w>0&&f.get(R-1,w-1)===3&&(d+=s.get(R-1,w-1)),d+=v?v(R,w):1):d=-1;const L=Math.max(i,l,d);if(L===d){const b=R>0&&w>0?s.get(R-1,w-1):0;s.set(R,w,b+1),f.set(R,w,3)}else L===i?(s.set(R,w,0),f.set(R,w,1)):L===l&&(s.set(R,w,0),f.set(R,w,2));e.set(R,w,L)}const u=[];let c=p.length,h=o.length;function y(R,w){(R+1!==c||w+1!==h)&&u.push(new x.SequenceDiff(new r.OffsetRange(R+1,c),new r.OffsetRange(w+1,h))),c=R,h=w}let C=p.length-1,N=o.length-1;for(;C>=0&&N>=0;)f.get(C,N)===3?(y(C,N),C--,N--):f.get(C,N)===1?C--:N--;return y(-1,-1),u.reverse(),new x.DiffAlgorithmResult(u,!1)}}n.DynamicProgrammingDiffing=g}),Y(X[32],Z([0,1,11,3,4,2,15]),function(O,n,r,x,A,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=void 0;class p{constructor(s,u,c){this.lines=s,this.considerWhitespaceChanges=c,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let h=!1;u.start>0&&u.endExclusive>=s.length&&(u=new x.OffsetRange(u.start-1,u.endExclusive),h=!0),this.lineRange=u,this.firstCharOffsetByLine[0]=0;for(let y=this.lineRange.start;y<this.lineRange.endExclusive;y++){let C=s[y],N=0;if(h)N=C.length,C="",h=!1;else if(!c){const R=C.trimStart();N=C.length-R.length,C=R.trimEnd()}this.additionalOffsetByLine.push(N);for(let R=0;R<C.length;R++)this.elements.push(C.charCodeAt(R));y<s.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[y-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new x.OffsetRange(0,this.length))}getText(s){return this.elements.slice(s.start,s.endExclusive).map(u=>String.fromCharCode(u)).join("")}getElement(s){return this.elements[s]}get length(){return this.elements.length}getBoundaryScore(s){const u=e(s>0?this.elements[s-1]:-1),c=e(s<this.elements.length?this.elements[s]:-1);if(u===7&&c===8)return 0;if(u===8)return 150;let h=0;return u!==c&&(h+=10,u===0&&c===1&&(h+=1)),h+=v(u),h+=v(c),h}translateOffset(s){if(this.lineRange.isEmpty)return new A.Position(this.lineRange.start+1,1);const u=(0,r.findLastIdxMonotonous)(this.firstCharOffsetByLine,c=>c<=s);return new A.Position(this.lineRange.start+u+1,s-this.firstCharOffsetByLine[u]+this.additionalOffsetByLine[u]+1)}translateRange(s){return g.Range.fromPositions(this.translateOffset(s.start),this.translateOffset(s.endExclusive))}findWordContaining(s){if(s<0||s>=this.elements.length||!o(this.elements[s]))return;let u=s;for(;u>0&&o(this.elements[u-1]);)u--;let c=s;for(;c<this.elements.length&&o(this.elements[c]);)c++;return new x.OffsetRange(u,c)}countLinesIn(s){return this.translateOffset(s.endExclusive).lineNumber-this.translateOffset(s.start).lineNumber}isStronglyEqual(s,u){return this.elements[s]===this.elements[u]}extendToFullLines(s){var u,c;const h=(u=(0,r.findLastMonotonous)(this.firstCharOffsetByLine,C=>C<=s.start))!==null&&u!==void 0?u:0,y=(c=(0,r.findFirstMonotonous)(this.firstCharOffsetByLine,C=>s.endExclusive<=C))!==null&&c!==void 0?c:this.elements.length;return new x.OffsetRange(h,y)}}n.LinesSliceCharSequence=p;function o(f){return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57}const a={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function v(f){return a[f]}function e(f){return f===10?8:f===13?7:(0,m.isSpace)(f)?6:f>=97&&f<=122?0:f>=65&&f<=90?1:f>=48&&f<=57?2:f===-1?3:f===44||f===59?5:4}}),Y(X[33],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class r{constructor(g,m,p){this.changes=g,this.moves=m,this.hitTimeout=p}}n.LinesDiff=r;class x{constructor(g,m){this.lineRangeMapping=g,this.changes=m}}n.MovedText=x}),Y(X[16],Z([0,1,10]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class x{static inverse(p,o,a){const v=[];let e=1,f=1;for(const u of p){const c=new x(new r.LineRange(e,u.original.startLineNumber),new r.LineRange(f,u.modified.startLineNumber));c.modified.isEmpty||v.push(c),e=u.original.endLineNumberExclusive,f=u.modified.endLineNumberExclusive}const s=new x(new r.LineRange(e,o+1),new r.LineRange(f,a+1));return s.modified.isEmpty||v.push(s),v}static clip(p,o,a){const v=[];for(const e of p){const f=e.original.intersect(o),s=e.modified.intersect(a);f&&!f.isEmpty&&s&&!s.isEmpty&&v.push(new x(f,s))}return v}constructor(p,o){this.original=p,this.modified=o}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new x(this.modified,this.original)}join(p){return new x(this.original.join(p.original),this.modified.join(p.modified))}}n.LineRangeMapping=x;class A extends x{static fromRangeMappings(p){const o=r.LineRange.join(p.map(v=>r.LineRange.fromRangeInclusive(v.originalRange))),a=r.LineRange.join(p.map(v=>r.LineRange.fromRangeInclusive(v.modifiedRange)));return new A(o,a,p)}constructor(p,o,a){super(p,o),this.innerChanges=a}flip(){var p;return new A(this.modified,this.original,(p=this.innerChanges)===null||p===void 0?void 0:p.map(o=>o.flip()))}withInnerChangesFromLineRanges(){return new A(this.original,this.modified,[new g(this.original.toExclusiveRange(),this.modified.toExclusiveRange())])}}n.DetailedLineRangeMapping=A;class g{constructor(p,o){this.originalRange=p,this.modifiedRange=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new g(this.modifiedRange,this.originalRange)}}n.RangeMapping=g}),Y(X[48],Z([0,1,8,16,7,11,23,10,3,32,15,31]),function(O,n,r,x,A,g,m,p,o,a,v,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeMovedLines=f;function f(N,R,w,i,l,d){let{moves:L,excludedChanges:b}=u(N,R,w,d);if(!d.isValid())return[];const _=N.filter(S=>!b.has(S)),E=c(_,i,l,R,w,d);return(0,A.pushMany)(L,E),L=y(L),L=L.filter(S=>{const M=S.original.toOffsetRange().slice(R).map(T=>T.trim());return M.join(`
`).length>=15&&s(M,T=>T.length>=2)>=2}),L=C(N,L),L}function s(N,R){let w=0;for(const i of N)R(i)&&w++;return w}function u(N,R,w,i){const l=[],d=N.filter(_=>_.modified.isEmpty&&_.original.length>=3).map(_=>new v.LineRangeFragment(_.original,R,_)),L=new Set(N.filter(_=>_.original.isEmpty&&_.modified.length>=3).map(_=>new v.LineRangeFragment(_.modified,w,_))),b=new Set;for(const _ of d){let E=-1,S;for(const M of L){const D=_.computeSimilarity(M);D>E&&(E=D,S=M)}if(E>.9&&S&&(L.delete(S),l.push(new x.LineRangeMapping(_.range,S.range)),b.add(_.source),b.add(S.source)),!i.isValid())return{moves:l,excludedChanges:b}}return{moves:l,excludedChanges:b}}function c(N,R,w,i,l,d){const L=[],b=new m.SetMap;for(const D of N)for(let T=D.original.startLineNumber;T<D.original.endLineNumberExclusive-2;T++){const k=`${R[T-1]}:${R[T+1-1]}:${R[T+2-1]}`;b.add(k,{range:new p.LineRange(T,T+3)})}const _=[];N.sort((0,A.compareBy)(D=>D.modified.startLineNumber,A.numberComparator));for(const D of N){let T=[];for(let k=D.modified.startLineNumber;k<D.modified.endLineNumberExclusive-2;k++){const q=`${w[k-1]}:${w[k+1-1]}:${w[k+2-1]}`,H=new p.LineRange(k,k+3),Q=[];b.forEach(q,({range:F})=>{for(const W of T)if(W.originalLineRange.endLineNumberExclusive+1===F.endLineNumberExclusive&&W.modifiedLineRange.endLineNumberExclusive+1===H.endLineNumberExclusive){W.originalLineRange=new p.LineRange(W.originalLineRange.startLineNumber,F.endLineNumberExclusive),W.modifiedLineRange=new p.LineRange(W.modifiedLineRange.startLineNumber,H.endLineNumberExclusive),Q.push(W);return}const I={modifiedLineRange:H,originalLineRange:F};_.push(I),Q.push(I)}),T=Q}if(!d.isValid())return[]}_.sort((0,A.reverseOrder)((0,A.compareBy)(D=>D.modifiedLineRange.length,A.numberComparator)));const E=new p.LineRangeSet,S=new p.LineRangeSet;for(const D of _){const T=D.modifiedLineRange.startLineNumber-D.originalLineRange.startLineNumber,k=E.subtractFrom(D.modifiedLineRange),q=S.subtractFrom(D.originalLineRange).getWithDelta(T),H=k.getIntersection(q);for(const Q of H.ranges){if(Q.length<3)continue;const F=Q,I=Q.delta(-T);L.push(new x.LineRangeMapping(I,F)),E.addRange(F),S.addRange(I)}}L.sort((0,A.compareBy)(D=>D.original.startLineNumber,A.numberComparator));const M=new g.MonotonousArray(N);for(let D=0;D<L.length;D++){const T=L[D],k=M.findLastMonotonous(z=>z.original.startLineNumber<=T.original.startLineNumber),q=(0,g.findLastMonotonous)(N,z=>z.modified.startLineNumber<=T.modified.startLineNumber),H=Math.max(T.original.startLineNumber-k.original.startLineNumber,T.modified.startLineNumber-q.modified.startLineNumber),Q=M.findLastMonotonous(z=>z.original.startLineNumber<T.original.endLineNumberExclusive),F=(0,g.findLastMonotonous)(N,z=>z.modified.startLineNumber<T.modified.endLineNumberExclusive),I=Math.max(Q.original.endLineNumberExclusive-T.original.endLineNumberExclusive,F.modified.endLineNumberExclusive-T.modified.endLineNumberExclusive);let W;for(W=0;W<H;W++){const z=T.original.startLineNumber-W-1,U=T.modified.startLineNumber-W-1;if(z>i.length||U>l.length||E.contains(U)||S.contains(z)||!h(i[z-1],l[U-1],d))break}W>0&&(S.addRange(new p.LineRange(T.original.startLineNumber-W,T.original.startLineNumber)),E.addRange(new p.LineRange(T.modified.startLineNumber-W,T.modified.startLineNumber)));let V;for(V=0;V<I;V++){const z=T.original.endLineNumberExclusive+V,U=T.modified.endLineNumberExclusive+V;if(z>i.length||U>l.length||E.contains(U)||S.contains(z)||!h(i[z-1],l[U-1],d))break}V>0&&(S.addRange(new p.LineRange(T.original.endLineNumberExclusive,T.original.endLineNumberExclusive+V)),E.addRange(new p.LineRange(T.modified.endLineNumberExclusive,T.modified.endLineNumberExclusive+V))),(W>0||V>0)&&(L[D]=new x.LineRangeMapping(new p.LineRange(T.original.startLineNumber-W,T.original.endLineNumberExclusive+V),new p.LineRange(T.modified.startLineNumber-W,T.modified.endLineNumberExclusive+V)))}return L}function h(N,R,w){if(N.trim()===R.trim())return!0;if(N.length>300&&R.length>300)return!1;const l=new e.MyersDiffAlgorithm().compute(new a.LinesSliceCharSequence([N],new o.OffsetRange(0,1),!1),new a.LinesSliceCharSequence([R],new o.OffsetRange(0,1),!1),w);let d=0;const L=r.SequenceDiff.invert(l.diffs,N.length);for(const S of L)S.seq1Range.forEach(M=>{(0,v.isSpace)(N.charCodeAt(M))||d++});function b(S){let M=0;for(let D=0;D<N.length;D++)(0,v.isSpace)(S.charCodeAt(D))||M++;return M}const _=b(N.length>R.length?N:R);return d/_>.6&&_>10}function y(N){if(N.length===0)return N;N.sort((0,A.compareBy)(w=>w.original.startLineNumber,A.numberComparator));const R=[N[0]];for(let w=1;w<N.length;w++){const i=R[R.length-1],l=N[w],d=l.original.startLineNumber-i.original.endLineNumberExclusive,L=l.modified.startLineNumber-i.modified.endLineNumberExclusive;if(d>=0&&L>=0&&d+L<=2){R[R.length-1]=i.join(l);continue}R.push(l)}return R}function C(N,R){const w=new g.MonotonousArray(N);return R=R.filter(i=>{const l=w.findLastMonotonous(b=>b.original.startLineNumber<i.original.endLineNumberExclusive)||new x.LineRangeMapping(new p.LineRange(1,1),new p.LineRange(1,1)),d=(0,g.findLastMonotonous)(N,b=>b.modified.startLineNumber<i.modified.endLineNumberExclusive);return l!==d}),R}}),Y(X[49],Z([0,1,7,12,10,3,2,8,47,31,48,45,46,32,33,16]),function(O,n,r,x,A,g,m,p,o,a,v,e,f,s,u,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DefaultLinesDiffComputer=void 0,n.lineRangeMappingFromRangeMappings=y,n.getLineRangeMapping=C;class h{constructor(){this.dynamicProgrammingDiffing=new o.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new a.MyersDiffAlgorithm}computeDiff(R,w,i){if(R.length<=1&&(0,r.equals)(R,w,(V,z)=>V===z))return new u.LinesDiff([],[],!1);if(R.length===1&&R[0].length===0||w.length===1&&w[0].length===0)return new u.LinesDiff([new c.DetailedLineRangeMapping(new A.LineRange(1,R.length+1),new A.LineRange(1,w.length+1),[new c.RangeMapping(new m.Range(1,1,R.length,R[0].length+1),new m.Range(1,1,w.length,w[0].length+1))])],[],!1);const l=i.maxComputationTimeMs===0?p.InfiniteTimeout.instance:new p.DateTimeout(i.maxComputationTimeMs),d=!i.ignoreTrimWhitespace,L=new Map;function b(V){let z=L.get(V);return z===void 0&&(z=L.size,L.set(V,z)),z}const _=R.map(V=>b(V.trim())),E=w.map(V=>b(V.trim())),S=new f.LineSequence(_,R),M=new f.LineSequence(E,w),D=S.length+M.length<1700?this.dynamicProgrammingDiffing.compute(S,M,l,(V,z)=>R[V]===w[z]?w[z].length===0?.1:1+Math.log(1+w[z].length):.99):this.myersDiffingAlgorithm.compute(S,M);let T=D.diffs,k=D.hitTimeout;T=(0,e.optimizeSequenceDiffs)(S,M,T),T=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(S,M,T);const q=[],H=V=>{if(d)for(let z=0;z<V;z++){const U=Q+z,se=F+z;if(R[U]!==w[se]){const he=this.refineDiff(R,w,new p.SequenceDiff(new g.OffsetRange(U,U+1),new g.OffsetRange(se,se+1)),l,d);for(const de of he.mappings)q.push(de);he.hitTimeout&&(k=!0)}}};let Q=0,F=0;for(const V of T){(0,x.assertFn)(()=>V.seq1Range.start-Q===V.seq2Range.start-F);const z=V.seq1Range.start-Q;H(z),Q=V.seq1Range.endExclusive,F=V.seq2Range.endExclusive;const U=this.refineDiff(R,w,V,l,d);U.hitTimeout&&(k=!0);for(const se of U.mappings)q.push(se)}H(R.length-Q);const I=y(q,R,w);let W=[];return i.computeMoves&&(W=this.computeMoves(I,R,w,_,E,l,d)),(0,x.assertFn)(()=>{function V(U,se){if(U.lineNumber<1||U.lineNumber>se.length)return!1;const he=se[U.lineNumber-1];return!(U.column<1||U.column>he.length+1)}function z(U,se){return!(U.startLineNumber<1||U.startLineNumber>se.length+1||U.endLineNumberExclusive<1||U.endLineNumberExclusive>se.length+1)}for(const U of I){if(!U.innerChanges)return!1;for(const se of U.innerChanges)if(!(V(se.modifiedRange.getStartPosition(),w)&&V(se.modifiedRange.getEndPosition(),w)&&V(se.originalRange.getStartPosition(),R)&&V(se.originalRange.getEndPosition(),R)))return!1;if(!z(U.modified,w)||!z(U.original,R))return!1}return!0}),new u.LinesDiff(I,W,k)}computeMoves(R,w,i,l,d,L,b){return(0,v.computeMovedLines)(R,w,i,l,d,L).map(S=>{const M=this.refineDiff(w,i,new p.SequenceDiff(S.original.toOffsetRange(),S.modified.toOffsetRange()),L,b),D=y(M.mappings,w,i,!0);return new u.MovedText(S,D)})}refineDiff(R,w,i,l,d){const L=new s.LinesSliceCharSequence(R,i.seq1Range,d),b=new s.LinesSliceCharSequence(w,i.seq2Range,d),_=L.length+b.length<500?this.dynamicProgrammingDiffing.compute(L,b,l):this.myersDiffingAlgorithm.compute(L,b,l);let E=_.diffs;return E=(0,e.optimizeSequenceDiffs)(L,b,E),E=(0,e.extendDiffsToEntireWordIfAppropriate)(L,b,E),E=(0,e.removeShortMatches)(L,b,E),E=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(L,b,E),{mappings:E.map(M=>new c.RangeMapping(L.translateRange(M.seq1Range),b.translateRange(M.seq2Range))),hitTimeout:_.hitTimeout}}}n.DefaultLinesDiffComputer=h;function y(N,R,w,i=!1){const l=[];for(const d of(0,r.groupAdjacentBy)(N.map(L=>C(L,R,w)),(L,b)=>L.original.overlapOrTouch(b.original)||L.modified.overlapOrTouch(b.modified))){const L=d[0],b=d[d.length-1];l.push(new c.DetailedLineRangeMapping(L.original.join(b.original),L.modified.join(b.modified),d.map(_=>_.innerChanges[0])))}return(0,x.assertFn)(()=>!i&&l.length>0&&(l[0].modified.startLineNumber!==l[0].original.startLineNumber||w.length-l[l.length-1].modified.endLineNumberExclusive!==R.length-l[l.length-1].original.endLineNumberExclusive)?!1:(0,x.checkAdjacentItems)(l,(d,L)=>L.original.startLineNumber-d.original.endLineNumberExclusive===L.modified.startLineNumber-d.modified.endLineNumberExclusive&&d.original.endLineNumberExclusive<L.original.startLineNumber&&d.modified.endLineNumberExclusive<L.modified.startLineNumber)),l}function C(N,R,w){let i=0,l=0;N.modifiedRange.endColumn===1&&N.originalRange.endColumn===1&&N.originalRange.startLineNumber+i<=N.originalRange.endLineNumber&&N.modifiedRange.startLineNumber+i<=N.modifiedRange.endLineNumber&&(l=-1),N.modifiedRange.startColumn-1>=w[N.modifiedRange.startLineNumber-1].length&&N.originalRange.startColumn-1>=R[N.originalRange.startLineNumber-1].length&&N.originalRange.startLineNumber<=N.originalRange.endLineNumber+l&&N.modifiedRange.startLineNumber<=N.modifiedRange.endLineNumber+l&&(i=1);const d=new A.LineRange(N.originalRange.startLineNumber+i,N.originalRange.endLineNumber+1+l),L=new A.LineRange(N.modifiedRange.startLineNumber+i,N.modifiedRange.endLineNumber+1+l);return new c.DetailedLineRangeMapping(d,L,[N])}}),Y(X[50],Z([0,1,25,33,16,6,2,12,10]),function(O,n,r,x,A,g,m,p,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const a=3;class v{computeDiff(i,l,d){var L;const _=new y(i,l,{maxComputationTime:d.maxComputationTimeMs,shouldIgnoreTrimWhitespace:d.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),E=[];let S=null;for(const M of _.changes){let D;M.originalEndLineNumber===0?D=new o.LineRange(M.originalStartLineNumber+1,M.originalStartLineNumber+1):D=new o.LineRange(M.originalStartLineNumber,M.originalEndLineNumber+1);let T;M.modifiedEndLineNumber===0?T=new o.LineRange(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):T=new o.LineRange(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let k=new A.DetailedLineRangeMapping(D,T,(L=M.charChanges)===null||L===void 0?void 0:L.map(q=>new A.RangeMapping(new m.Range(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new m.Range(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));S&&(S.modified.endLineNumberExclusive===k.modified.startLineNumber||S.original.endLineNumberExclusive===k.original.startLineNumber)&&(k=new A.DetailedLineRangeMapping(S.original.join(k.original),S.modified.join(k.modified),S.innerChanges&&k.innerChanges?S.innerChanges.concat(k.innerChanges):void 0),E.pop()),E.push(k),S=k}return(0,p.assertFn)(()=>(0,p.checkAdjacentItems)(E,(M,D)=>D.original.startLineNumber-M.original.endLineNumberExclusive===D.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<D.original.startLineNumber&&M.modified.endLineNumberExclusive<D.modified.startLineNumber)),new x.LinesDiff(E,[],_.quitEarly)}}n.LegacyLinesDiffComputer=v;function e(w,i,l,d){return new r.LcsDiff(w,i,l).ComputeDiff(d)}class f{constructor(i){const l=[],d=[];for(let L=0,b=i.length;L<b;L++)l[L]=C(i[L],1),d[L]=N(i[L],1);this.lines=i,this._startColumns=l,this._endColumns=d}getElements(){const i=[];for(let l=0,d=this.lines.length;l<d;l++)i[l]=this.lines[l].substring(this._startColumns[l]-1,this._endColumns[l]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,l,d){const L=[],b=[],_=[];let E=0;for(let S=l;S<=d;S++){const M=this.lines[S],D=i?this._startColumns[S]:1,T=i?this._endColumns[S]:M.length+1;for(let k=D;k<T;k++)L[E]=M.charCodeAt(k-1),b[E]=S+1,_[E]=k,E++;!i&&S<d&&(L[E]=10,b[E]=S+1,_[E]=M.length+1,E++)}return new s(L,b,_)}}class s{constructor(i,l,d){this._charCodes=i,this._lineNumbers=l,this._columns=d}toString(){return"["+this._charCodes.map((i,l)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[l]},${this._columns[l]})`).join(", ")+"]"}_assertIndex(i,l){if(i<0||i>=l.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class u{constructor(i,l,d,L,b,_,E,S){this.originalStartLineNumber=i,this.originalStartColumn=l,this.originalEndLineNumber=d,this.originalEndColumn=L,this.modifiedStartLineNumber=b,this.modifiedStartColumn=_,this.modifiedEndLineNumber=E,this.modifiedEndColumn=S}static createFromDiffChange(i,l,d){const L=l.getStartLineNumber(i.originalStart),b=l.getStartColumn(i.originalStart),_=l.getEndLineNumber(i.originalStart+i.originalLength-1),E=l.getEndColumn(i.originalStart+i.originalLength-1),S=d.getStartLineNumber(i.modifiedStart),M=d.getStartColumn(i.modifiedStart),D=d.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),T=d.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new u(L,b,_,E,S,M,D,T)}}function c(w){if(w.length<=1)return w;const i=[w[0]];let l=i[0];for(let d=1,L=w.length;d<L;d++){const b=w[d],_=b.originalStart-(l.originalStart+l.originalLength),E=b.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(_,E)<a?(l.originalLength=b.originalStart+b.originalLength-l.originalStart,l.modifiedLength=b.modifiedStart+b.modifiedLength-l.modifiedStart):(i.push(b),l=b)}return i}class h{constructor(i,l,d,L,b){this.originalStartLineNumber=i,this.originalEndLineNumber=l,this.modifiedStartLineNumber=d,this.modifiedEndLineNumber=L,this.charChanges=b}static createFromDiffResult(i,l,d,L,b,_,E){let S,M,D,T,k;if(l.originalLength===0?(S=d.getStartLineNumber(l.originalStart)-1,M=0):(S=d.getStartLineNumber(l.originalStart),M=d.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(D=L.getStartLineNumber(l.modifiedStart)-1,T=0):(D=L.getStartLineNumber(l.modifiedStart),T=L.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),_&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&b()){const q=d.createCharSequence(i,l.originalStart,l.originalStart+l.originalLength-1),H=L.createCharSequence(i,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(q.getElements().length>0&&H.getElements().length>0){let Q=e(q,H,b,!0).changes;E&&(Q=c(Q)),k=[];for(let F=0,I=Q.length;F<I;F++)k.push(u.createFromDiffChange(Q[F],q,H))}}return new h(S,M,D,T,k)}}class y{constructor(i,l,d){this.shouldComputeCharChanges=d.shouldComputeCharChanges,this.shouldPostProcessCharChanges=d.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=d.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=d.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=l,this.original=new f(i),this.modified=new f(l),this.continueLineDiff=R(d.maxComputationTime),this.continueCharDiff=R(d.maxComputationTime===0?0:Math.min(d.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),l=i.changes,d=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const E=[];for(let S=0,M=l.length;S<M;S++)E.push(h.createFromDiffResult(this.shouldIgnoreTrimWhitespace,l[S],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:d,changes:E}}const L=[];let b=0,_=0;for(let E=-1,S=l.length;E<S;E++){const M=E+1<S?l[E+1]:null,D=M?M.originalStart:this.originalLines.length,T=M?M.modifiedStart:this.modifiedLines.length;for(;b<D&&_<T;){const k=this.originalLines[b],q=this.modifiedLines[_];if(k!==q){{let H=C(k,1),Q=C(q,1);for(;H>1&&Q>1;){const F=k.charCodeAt(H-2),I=q.charCodeAt(Q-2);if(F!==I)break;H--,Q--}(H>1||Q>1)&&this._pushTrimWhitespaceCharChange(L,b+1,1,H,_+1,1,Q)}{let H=N(k,1),Q=N(q,1);const F=k.length+1,I=q.length+1;for(;H<F&&Q<I;){const W=k.charCodeAt(H-1),V=k.charCodeAt(Q-1);if(W!==V)break;H++,Q++}(H<F||Q<I)&&this._pushTrimWhitespaceCharChange(L,b+1,H,F,_+1,Q,I)}}b++,_++}M&&(L.push(h.createFromDiffResult(this.shouldIgnoreTrimWhitespace,M,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),b+=M.originalLength,_+=M.modifiedLength)}return{quitEarly:d,changes:L}}_pushTrimWhitespaceCharChange(i,l,d,L,b,_,E){if(this._mergeTrimWhitespaceCharChange(i,l,d,L,b,_,E))return;let S;this.shouldComputeCharChanges&&(S=[new u(l,d,l,L,b,_,b,E)]),i.push(new h(l,l,b,b,S))}_mergeTrimWhitespaceCharChange(i,l,d,L,b,_,E){const S=i.length;if(S===0)return!1;const M=i[S-1];return M.originalEndLineNumber===0||M.modifiedEndLineNumber===0?!1:M.originalEndLineNumber===l&&M.modifiedEndLineNumber===b?(this.shouldComputeCharChanges&&M.charChanges&&M.charChanges.push(new u(l,d,l,L,b,_,b,E)),!0):M.originalEndLineNumber+1===l&&M.modifiedEndLineNumber+1===b?(M.originalEndLineNumber=l,M.modifiedEndLineNumber=b,this.shouldComputeCharChanges&&M.charChanges&&M.charChanges.push(new u(l,d,l,L,b,_,b,E)),!0):!1}}n.DiffComputer=y;function C(w,i){const l=g.firstNonWhitespaceIndex(w);return l===-1?i:l+1}function N(w,i){const l=g.lastNonWhitespaceIndex(w);return l===-1?i:l+2}function R(w){if(w===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<w}}),Y(X[51],Z([0,1,50,49]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new r.LegacyLinesDiffComputer,getDefault:()=>new x.DefaultLinesDiffComputer}}),Y(X[52],Z([0,1,35]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=e;function x(f){const s=[];for(const u of f){const c=Number(u);(c||c===0&&u.replace(/\s/g,"")!=="")&&s.push(c)}return s}function A(f,s,u,c){return{red:f/255,blue:u/255,green:s/255,alpha:c}}function g(f,s){const u=s.index,c=s[0].length;if(!u)return;const h=f.positionAt(u);return{startLineNumber:h.lineNumber,startColumn:h.column,endLineNumber:h.lineNumber,endColumn:h.column+c}}function m(f,s){if(!f)return;const u=r.Color.Format.CSS.parseHex(s);if(u)return{range:f,color:A(u.rgba.r,u.rgba.g,u.rgba.b,u.rgba.a)}}function p(f,s,u){if(!f||s.length!==1)return;const h=s[0].values(),y=x(h);return{range:f,color:A(y[0],y[1],y[2],u?y[3]:1)}}function o(f,s,u){if(!f||s.length!==1)return;const h=s[0].values(),y=x(h),C=new r.Color(new r.HSLA(y[0],y[1]/100,y[2]/100,u?y[3]:1));return{range:f,color:A(C.rgba.r,C.rgba.g,C.rgba.b,C.rgba.a)}}function a(f,s){return typeof f=="string"?[...f.matchAll(s)]:f.findMatches(s)}function v(f){const s=[],c=a(f,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(c.length>0)for(const h of c){const y=h.filter(w=>w!==void 0),C=y[1],N=y[2];if(!N)continue;let R;if(C==="rgb"){const w=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;R=p(g(f,h),a(N,w),!1)}else if(C==="rgba"){const w=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;R=p(g(f,h),a(N,w),!0)}else if(C==="hsl"){const w=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;R=o(g(f,h),a(N,w),!1)}else if(C==="hsla"){const w=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;R=o(g(f,h),a(N,w),!0)}else C==="#"&&(R=m(g(f,h),C+N));R&&s.push(R)}return s}function e(f){return!f||typeof f.getValue!="function"||typeof f.positionAt!="function"?[]:v(f)}}),Y(X[53],Z([0,1,29]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkComputer=n.StateMachine=void 0,n.computeLinks=v;class x{constructor(f,s,u){const c=new Uint8Array(f*s);for(let h=0,y=f*s;h<y;h++)c[h]=u;this._data=c,this.rows=f,this.cols=s}get(f,s){return this._data[f*this.cols+s]}set(f,s,u){this._data[f*this.cols+s]=u}}class A{constructor(f){let s=0,u=0;for(let h=0,y=f.length;h<y;h++){const[C,N,R]=f[h];N>s&&(s=N),C>u&&(u=C),R>u&&(u=R)}s++,u++;const c=new x(u,s,0);for(let h=0,y=f.length;h<y;h++){const[C,N,R]=f[h];c.set(C,N,R)}this._states=c,this._maxCharCode=s}nextState(f,s){return s<0||s>=this._maxCharCode?0:this._states.get(f,s)}}n.StateMachine=A;let g=null;function m(){return g===null&&(g=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),g}let p=null;function o(){if(p===null){p=new r.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let s=0;s<e.length;s++)p.set(e.charCodeAt(s),1);const f=".,;:";for(let s=0;s<f.length;s++)p.set(f.charCodeAt(s),2)}return p}class a{static _createLink(f,s,u,c,h){let y=h-1;do{const C=s.charCodeAt(y);if(f.get(C)!==2)break;y--}while(y>c);if(c>0){const C=s.charCodeAt(c-1),N=s.charCodeAt(y);(C===40&&N===41||C===91&&N===93||C===123&&N===125)&&y--}return{range:{startLineNumber:u,startColumn:c+1,endLineNumber:u,endColumn:y+2},url:s.substring(c,y+1)}}static computeLinks(f,s=m()){const u=o(),c=[];for(let h=1,y=f.getLineCount();h<=y;h++){const C=f.getLineContent(h),N=C.length;let R=0,w=0,i=0,l=1,d=!1,L=!1,b=!1,_=!1;for(;R<N;){let E=!1;const S=C.charCodeAt(R);if(l===13){let M;switch(S){case 40:d=!0,M=0;break;case 41:M=d?0:1;break;case 91:b=!0,L=!0,M=0;break;case 93:b=!1,M=L?0:1;break;case 123:_=!0,M=0;break;case 125:M=_?0:1;break;case 39:case 34:case 96:i===S?M=1:i===39||i===34||i===96?M=0:M=1;break;case 42:M=i===42?1:0;break;case 124:M=i===124?1:0;break;case 32:M=b?0:1;break;default:M=u.get(S)}M===1&&(c.push(a._createLink(u,C,h,w,R)),E=!0)}else if(l===12){let M;S===91?(L=!0,M=0):M=u.get(S),M===1?E=!0:l=13}else l=s.nextState(l,S),l===0&&(E=!0);E&&(l=1,d=!1,L=!1,_=!1,w=R+1,i=S),R++}l===13&&c.push(a._createLink(u,C,h,w,N))}return c}}n.LinkComputer=a;function v(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:a.computeLinks(e)}}),Y(X[54],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class r{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(A,g,m,p,o){if(A&&g){const a=this.doNavigateValueSet(g,o);if(a)return{range:A,value:a}}if(m&&p){const a=this.doNavigateValueSet(p,o);if(a)return{range:m,value:a}}return null}doNavigateValueSet(A,g){const m=this.numberReplace(A,g);return m!==null?m:this.textReplace(A,g)}numberReplace(A,g){const m=Math.pow(10,A.length-(A.lastIndexOf(".")+1));let p=Number(A);const o=parseFloat(A);return!isNaN(p)&&!isNaN(o)&&p===o?p===0&&!g?null:(p=Math.floor(p*m),p+=g?m:-m,String(p/m)):null}textReplace(A,g){return this.valueSetsReplace(this._defaultValueSet,A,g)}valueSetsReplace(A,g,m){let p=null;for(let o=0,a=A.length;p===null&&o<a;o++)p=this.valueSetReplace(A[o],g,m);return p}valueSetReplace(A,g,m){let p=A.indexOf(g);return p>=0?(p+=m?1:-1,p<0?p=A.length-1:p%=A.length,A[p]):null}}n.BasicInplaceReplace=r,r.INSTANCE=new r}),Y(X[55],Z([0,1,14]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.GlyphMarginLane=n.OverviewRulerLane=void 0,n.isITextSnapshot=o,n.shouldSynchronizeModel=f;var x;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(x||(n.OverviewRulerLane=x={}));var A;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(A||(n.GlyphMarginLane=A={}));var g;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(g||(n.InjectedTextCursorStops=g={}));class m{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,u.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this._indentSizeIsTabSize===u._indentSizeIsTabSize&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,r.equals)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}n.TextModelResolvedOptions=m;class p{constructor(u,c){this._findMatchBrand=void 0,this.range=u,this.matches=c}}n.FindMatch=p;function o(s){return s&&typeof s.read=="function"}class a{constructor(u,c,h,y,C,N){this.identifier=u,this.range=c,this.text=h,this.forceMoveMarkers=y,this.isAutoWhitespaceEdit=C,this._isTracked=N}}n.ValidAnnotatedEditOperation=a;class v{constructor(u,c,h){this.regex=u,this.wordSeparators=c,this.simpleSearch=h}}n.SearchData=v;class e{constructor(u,c,h){this.reverseEdits=u,this.changes=c,this.trimAutoWhitespaceLineNumbers=h}}n.ApplyEditsResult=e;function f(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),Y(X[56],Z([0,1,7,28]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class A{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(o,a){o=(0,x.toUint32)(o);const v=this.values,e=this.prefixSum,f=a.length;return f===0?!1:(this.values=new Uint32Array(v.length+f),this.values.set(v.subarray(0,o),0),this.values.set(v.subarray(o),o+f),this.values.set(a,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,a){return o=(0,x.toUint32)(o),a=(0,x.toUint32)(a),this.values[o]===a?!1:(this.values[o]=a,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,a){o=(0,x.toUint32)(o),a=(0,x.toUint32)(a);const v=this.values,e=this.prefixSum;if(o>=v.length)return!1;const f=v.length-o;return a>=f&&(a=f),a===0?!1:(this.values=new Uint32Array(v.length-a),this.values.set(v.subarray(0,o),0),this.values.set(v.subarray(o+a),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,x.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),o>=this.values.length&&(o=this.values.length-1);for(let v=a;v<=o;v++)this.prefixSum[v]=this.prefixSum[v-1]+this.values[v];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let a=0,v=this.values.length-1,e=0,f=0,s=0;for(;a<=v;)if(e=a+(v-a)/2|0,f=this.prefixSum[e],s=f-this.values[e],o<s)v=e-1;else if(o>=f)a=e+1;else break;return new m(e,o-s)}}n.PrefixSumComputer=A;class g{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const a=this._indexBySum[o],v=a>0?this._prefixSum[a-1]:0;return new m(a,o-v)}removeValues(o,a){this._values.splice(o,a),this._invalidate(o)}insertValues(o,a){this._values=(0,r.arrayInsert)(this._values,o,a),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,a=this._values.length;o<a;o++){const v=this._values[o],e=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=e+v;for(let f=0;f<v;f++)this._indexBySum[e+f]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,a){this._values[o]!==a&&(this._values[o]=a,this._invalidate(o))}}n.ConstantTimePrefixSumComputer=g;class m{constructor(o,a){this.index=o,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=a}}n.PrefixSumIndexOfResult=m}),Y(X[57],Z([0,1,6,4,56]),function(O,n,r,x,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class g{constructor(p,o,a,v){this._uri=p,this._lines=o,this._eol=a,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(p){p.eol&&p.eol!==this._eol&&(this._eol=p.eol,this._lineStarts=null);const o=p.changes;for(const a of o)this._acceptDeleteRange(a.range),this._acceptInsertText(new x.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=p.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const p=this._eol.length,o=this._lines.length,a=new Uint32Array(o);for(let v=0;v<o;v++)a[v]=this._lines[v].length+p;this._lineStarts=new A.PrefixSumComputer(a)}}_setLineText(p,o){this._lines[p]=o,this._lineStarts&&this._lineStarts.setValue(p,this._lines[p].length+this._eol.length)}_acceptDeleteRange(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this._setLineText(p.startLineNumber-1,this._lines[p.startLineNumber-1].substring(0,p.startColumn-1)+this._lines[p.startLineNumber-1].substring(p.endColumn-1));return}this._setLineText(p.startLineNumber-1,this._lines[p.startLineNumber-1].substring(0,p.startColumn-1)+this._lines[p.endLineNumber-1].substring(p.endColumn-1)),this._lines.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}_acceptInsertText(p,o){if(o.length===0)return;const a=(0,r.splitLines)(o);if(a.length===1){this._setLineText(p.lineNumber-1,this._lines[p.lineNumber-1].substring(0,p.column-1)+a[0]+this._lines[p.lineNumber-1].substring(p.column-1));return}a[a.length-1]+=this._lines[p.lineNumber-1].substring(p.column-1),this._setLineText(p.lineNumber-1,this._lines[p.lineNumber-1].substring(0,p.column-1)+a[0]);const v=new Uint32Array(a.length-1);for(let e=1;e<a.length;e++)this._lines.splice(p.lineNumber+e-1,0,a[e]),v[e-1]=a[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(p.lineNumber,v)}}n.MirrorTextModel=g}),Y(X[58],Z([0,1,6,44,4,2,55]),function(O,n,r,x,A,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.TextModelSearch=n.SearchParams=void 0,n.isMultilineRegexSource=a,n.createFindMatch=v,n.isValidMatch=c;const p=999;class o{constructor(C,N,R,w){this.searchString=C,this.isRegex=N,this.matchCase=R,this.wordSeparators=w}parseSearchRequest(){if(this.searchString==="")return null;let C;this.isRegex?C=a(this.searchString):C=this.searchString.indexOf(`
`)>=0;let N=null;try{N=r.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:C,global:!0,unicode:!0})}catch{return null}if(!N)return null;let R=!this.isRegex&&!C;return R&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(R=this.matchCase),new m.SearchData(N,this.wordSeparators?(0,x.getMapForWordSeparators)(this.wordSeparators,[]):null,R?this.searchString:null)}}n.SearchParams=o;function a(y){if(!y||y.length===0)return!1;for(let C=0,N=y.length;C<N;C++){const R=y.charCodeAt(C);if(R===10)return!0;if(R===92){if(C++,C>=N)break;const w=y.charCodeAt(C);if(w===110||w===114||w===87)return!0}}return!1}function v(y,C,N){if(!N)return new m.FindMatch(y,null);const R=[];for(let w=0,i=C.length;w<i;w++)R[w]=C[w];return new m.FindMatch(y,R)}class e{constructor(C){const N=[];let R=0;for(let w=0,i=C.length;w<i;w++)C.charCodeAt(w)===10&&(N[R++]=w);this._lineFeedsOffsets=N}findLineFeedCountBeforeOffset(C){const N=this._lineFeedsOffsets;let R=0,w=N.length-1;if(w===-1||C<=N[0])return 0;for(;R<w;){const i=R+((w-R)/2>>0);N[i]>=C?w=i-1:N[i+1]>=C?(R=i,w=i):R=i+1}return R+1}}class f{static findMatches(C,N,R,w,i){const l=N.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(C,R,new h(l.wordSeparators,l.regex),w,i):this._doFindMatchesLineByLine(C,R,l,w,i):[]}static _getMultilineMatchRange(C,N,R,w,i,l){let d,L=0;w?(L=w.findLineFeedCountBeforeOffset(i),d=N+i+L):d=N+i;let b;if(w){const M=w.findLineFeedCountBeforeOffset(i+l.length)-L;b=d+l.length+M}else b=d+l.length;const _=C.getPositionAt(d),E=C.getPositionAt(b);return new g.Range(_.lineNumber,_.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(C,N,R,w,i){const l=C.getOffsetAt(N.getStartPosition()),d=C.getValueInRange(N,1),L=C.getEOL()===`\r
`?new e(d):null,b=[];let _=0,E;for(R.reset(0);E=R.next(d);)if(b[_++]=v(this._getMultilineMatchRange(C,l,d,L,E.index,E[0]),E,w),_>=i)return b;return b}static _doFindMatchesLineByLine(C,N,R,w,i){const l=[];let d=0;if(N.startLineNumber===N.endLineNumber){const b=C.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return d=this._findMatchesInLine(R,b,N.startLineNumber,N.startColumn-1,d,l,w,i),l}const L=C.getLineContent(N.startLineNumber).substring(N.startColumn-1);d=this._findMatchesInLine(R,L,N.startLineNumber,N.startColumn-1,d,l,w,i);for(let b=N.startLineNumber+1;b<N.endLineNumber&&d<i;b++)d=this._findMatchesInLine(R,C.getLineContent(b),b,0,d,l,w,i);if(d<i){const b=C.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);d=this._findMatchesInLine(R,b,N.endLineNumber,0,d,l,w,i)}return l}static _findMatchesInLine(C,N,R,w,i,l,d,L){const b=C.wordSeparators;if(!d&&C.simpleSearch){const S=C.simpleSearch,M=S.length,D=N.length;let T=-M;for(;(T=N.indexOf(S,T+M))!==-1;)if((!b||c(b,N,D,T,M))&&(l[i++]=new m.FindMatch(new g.Range(R,T+1+w,R,T+1+M+w),null),i>=L))return i;return i}const _=new h(C.wordSeparators,C.regex);let E;_.reset(0);do if(E=_.next(N),E&&(l[i++]=v(new g.Range(R,E.index+1+w,R,E.index+1+E[0].length+w),E,d),i>=L))return i;while(E);return i}static findNextMatch(C,N,R,w){const i=N.parseSearchRequest();if(!i)return null;const l=new h(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(C,R,l,w):this._doFindNextMatchLineByLine(C,R,l,w)}static _doFindNextMatchMultiline(C,N,R,w){const i=new A.Position(N.lineNumber,1),l=C.getOffsetAt(i),d=C.getLineCount(),L=C.getValueInRange(new g.Range(i.lineNumber,i.column,d,C.getLineMaxColumn(d)),1),b=C.getEOL()===`\r
`?new e(L):null;R.reset(N.column-1);const _=R.next(L);return _?v(this._getMultilineMatchRange(C,l,L,b,_.index,_[0]),_,w):N.lineNumber!==1||N.column!==1?this._doFindNextMatchMultiline(C,new A.Position(1,1),R,w):null}static _doFindNextMatchLineByLine(C,N,R,w){const i=C.getLineCount(),l=N.lineNumber,d=C.getLineContent(l),L=this._findFirstMatchInLine(R,d,l,N.column,w);if(L)return L;for(let b=1;b<=i;b++){const _=(l+b-1)%i,E=C.getLineContent(_+1),S=this._findFirstMatchInLine(R,E,_+1,1,w);if(S)return S}return null}static _findFirstMatchInLine(C,N,R,w,i){C.reset(w-1);const l=C.next(N);return l?v(new g.Range(R,l.index+1,R,l.index+1+l[0].length),l,i):null}static findPreviousMatch(C,N,R,w){const i=N.parseSearchRequest();if(!i)return null;const l=new h(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(C,R,l,w):this._doFindPreviousMatchLineByLine(C,R,l,w)}static _doFindPreviousMatchMultiline(C,N,R,w){const i=this._doFindMatchesMultiline(C,new g.Range(1,1,N.lineNumber,N.column),R,w,10*p);if(i.length>0)return i[i.length-1];const l=C.getLineCount();return N.lineNumber!==l||N.column!==C.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(C,new A.Position(l,C.getLineMaxColumn(l)),R,w):null}static _doFindPreviousMatchLineByLine(C,N,R,w){const i=C.getLineCount(),l=N.lineNumber,d=C.getLineContent(l).substring(0,N.column-1),L=this._findLastMatchInLine(R,d,l,w);if(L)return L;for(let b=1;b<=i;b++){const _=(i+l-b-1)%i,E=C.getLineContent(_+1),S=this._findLastMatchInLine(R,E,_+1,w);if(S)return S}return null}static _findLastMatchInLine(C,N,R,w){let i=null,l;for(C.reset(0);l=C.next(N);)i=v(new g.Range(R,l.index+1,R,l.index+1+l[0].length),l,w);return i}}n.TextModelSearch=f;function s(y,C,N,R,w){if(R===0)return!0;const i=C.charCodeAt(R-1);if(y.get(i)!==0||i===13||i===10)return!0;if(w>0){const l=C.charCodeAt(R);if(y.get(l)!==0)return!0}return!1}function u(y,C,N,R,w){if(R+w===N)return!0;const i=C.charCodeAt(R+w);if(y.get(i)!==0||i===13||i===10)return!0;if(w>0){const l=C.charCodeAt(R+w-1);if(y.get(l)!==0)return!0}return!1}function c(y,C,N,R,w){return s(y,C,N,R,w)&&u(y,C,N,R,w)}class h{constructor(C,N){this._wordSeparators=C,this._searchRegex=N,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(C){this._searchRegex.lastIndex=C,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(C){const N=C.length;let R;do{if(this._prevMatchStartIndex+this._prevMatchLength===N||(R=this._searchRegex.exec(C),!R))return null;const w=R.index,i=R[0].length;if(w===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){r.getNextCodePoint(C,N,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=w,this._prevMatchLength=i,!this._wordSeparators||c(this._wordSeparators,C,N,w,i))return R}while(R);return null}}n.Searcher=h}),Y(X[59],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.findSectionHeaders=A;const r=/\bMARK:\s*(.*)$/d,x=/^-+|-+$/g;function A(a,v){var e;let f=[];if(v.findRegionSectionHeaders&&(!((e=v.foldingRules)===null||e===void 0)&&e.markers)){const s=g(a,v);f=f.concat(s)}if(v.findMarkSectionHeaders){const s=m(a);f=f.concat(s)}return f}function g(a,v){const e=[],f=a.getLineCount();for(let s=1;s<=f;s++){const u=a.getLineContent(s),c=u.match(v.foldingRules.markers.start);if(c){const h={startLineNumber:s,startColumn:c[0].length+1,endLineNumber:s,endColumn:u.length+1};if(h.endColumn>h.startColumn){const y={range:h,...o(u.substring(c[0].length)),shouldBeInComments:!1};(y.text||y.hasSeparatorLine)&&e.push(y)}}}return e}function m(a){const v=[],e=a.getLineCount();for(let f=1;f<=e;f++){const s=a.getLineContent(f);p(s,f,v)}return v}function p(a,v,e){r.lastIndex=0;const f=r.exec(a);if(f){const s=f.indices[1][0]+1,u=f.indices[1][1]+1,c={startLineNumber:v,startColumn:s,endLineNumber:v,endColumn:u};if(c.endColumn>c.startColumn){const h={range:c,...o(f[1]),shouldBeInComments:!0};(h.text||h.hasSeparatorLine)&&e.push(h)}}}function o(a){a=a.trim();const v=a.startsWith("-");return a=a.replace(x,""),{text:a,hasSeparatorLine:v}}}),Y(X[60],Z([0,1,2,58,6,12,30]),function(O,n,r,x,A,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class p{static computeUnicodeHighlights(f,s,u){const c=u?u.startLineNumber:1,h=u?u.endLineNumber:f.getLineCount(),y=new a(s),C=y.getCandidateCodePoints();let N;C==="allNonBasicAscii"?N=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):N=new RegExp(`${o(Array.from(C))}`,"g");const R=new x.Searcher(null,N),w=[];let i=!1,l,d=0,L=0,b=0;e:for(let _=c,E=h;_<=E;_++){const S=f.getLineContent(_),M=S.length;R.reset(0);do if(l=R.next(S),l){let D=l.index,T=l.index+l[0].length;if(D>0){const Q=S.charCodeAt(D-1);A.isHighSurrogate(Q)&&D--}if(T+1<M){const Q=S.charCodeAt(T-1);A.isHighSurrogate(Q)&&T++}const k=S.substring(D,T);let q=(0,m.getWordAtText)(D+1,m.DEFAULT_WORD_REGEXP,S,0);q&&q.endColumn<=D+1&&(q=null);const H=y.shouldHighlightNonBasicASCII(k,q?q.word:null);if(H!==0){if(H===3?d++:H===2?L++:H===1?b++:(0,g.assertNever)(H),w.length>=1e3){i=!0;break e}w.push(new r.Range(_,D+1,_,T+1))}}while(l)}return{ranges:w,hasMore:i,ambiguousCharacterCount:d,invisibleCharacterCount:L,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(f,s){const u=new a(s);switch(u.shouldHighlightNonBasicASCII(f,null)){case 0:return null;case 2:return{kind:1};case 3:{const h=f.codePointAt(0),y=u.ambiguousCharacters.getPrimaryConfusable(h),C=A.AmbiguousCharacters.getLocales().filter(N=>!A.AmbiguousCharacters.getInstance(new Set([...s.allowedLocales,N])).isAmbiguous(h));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:C}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=p;function o(e,f){return`[${A.escapeRegExpCharacters(e.map(u=>String.fromCodePoint(u)).join(""))}]`}class a{constructor(f){this.options=f,this.allowedCodePoints=new Set(f.allowedCodePoints),this.ambiguousCharacters=A.AmbiguousCharacters.getInstance(new Set(f.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const f=new Set;if(this.options.invisibleCharacters)for(const s of A.InvisibleCharacters.codePoints)v(String.fromCodePoint(s))||f.add(s);if(this.options.ambiguousCharacters)for(const s of this.ambiguousCharacters.getConfusableCodePoints())f.add(s);for(const s of this.allowedCodePoints)f.delete(s);return f}shouldHighlightNonBasicASCII(f,s){const u=f.codePointAt(0);if(this.allowedCodePoints.has(u))return 0;if(this.options.nonBasicASCII)return 1;let c=!1,h=!1;if(s)for(const y of s){const C=y.codePointAt(0),N=A.isBasicASCII(y);c=c||N,!N&&!this.ambiguousCharacters.isAmbiguous(C)&&!A.InvisibleCharacters.isInvisibleCharacter(C)&&(h=!0)}return!c&&h?0:this.options.invisibleCharacters&&!v(f)&&A.InvisibleCharacters.isInvisibleCharacter(u)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(u)?3:0}}function v(e){return e===" "||e===`
`||e==="	"}}),Y(X[61],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.ShowLightbulbIconMode=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.PartialAcceptTriggerKind=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.NewSymbolNameTag=n.MouseTargetType=n.MinimapSectionHeaderStyle=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineEditTriggerKind=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var r;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(r||(n.AccessibilitySupport=r={}));var x;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(x||(n.CodeActionTriggerType=x={}));var A;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(A||(n.CompletionItemInsertTextRule=A={}));var g;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(g||(n.CompletionItemKind=g={}));var m;(function(t){t[t.Deprecated=1]="Deprecated"})(m||(n.CompletionItemTag=m={}));var p;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(n.CompletionTriggerKind=p={}));var o;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(o||(n.ContentWidgetPositionPreference=o={}));var a;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(a||(n.CursorChangeReason=a={}));var v;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(v||(n.DefaultEndOfLine=v={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var f;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(f||(n.EditorAutoIndentStrategy=f={}));var s;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.autoClosingComments=7]="autoClosingComments",t[t.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=9]="autoClosingDelete",t[t.autoClosingOvertype=10]="autoClosingOvertype",t[t.autoClosingQuotes=11]="autoClosingQuotes",t[t.autoIndent=12]="autoIndent",t[t.automaticLayout=13]="automaticLayout",t[t.autoSurround=14]="autoSurround",t[t.bracketPairColorization=15]="bracketPairColorization",t[t.guides=16]="guides",t[t.codeLens=17]="codeLens",t[t.codeLensFontFamily=18]="codeLensFontFamily",t[t.codeLensFontSize=19]="codeLensFontSize",t[t.colorDecorators=20]="colorDecorators",t[t.colorDecoratorsLimit=21]="colorDecoratorsLimit",t[t.columnSelection=22]="columnSelection",t[t.comments=23]="comments",t[t.contextmenu=24]="contextmenu",t[t.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",t[t.cursorBlinking=26]="cursorBlinking",t[t.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",t[t.cursorStyle=28]="cursorStyle",t[t.cursorSurroundingLines=29]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",t[t.cursorWidth=31]="cursorWidth",t[t.disableLayerHinting=32]="disableLayerHinting",t[t.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",t[t.domReadOnly=34]="domReadOnly",t[t.dragAndDrop=35]="dragAndDrop",t[t.dropIntoEditor=36]="dropIntoEditor",t[t.emptySelectionClipboard=37]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",t[t.extraEditorClassName=39]="extraEditorClassName",t[t.fastScrollSensitivity=40]="fastScrollSensitivity",t[t.find=41]="find",t[t.fixedOverflowWidgets=42]="fixedOverflowWidgets",t[t.folding=43]="folding",t[t.foldingStrategy=44]="foldingStrategy",t[t.foldingHighlight=45]="foldingHighlight",t[t.foldingImportsByDefault=46]="foldingImportsByDefault",t[t.foldingMaximumRegions=47]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=49]="fontFamily",t[t.fontInfo=50]="fontInfo",t[t.fontLigatures=51]="fontLigatures",t[t.fontSize=52]="fontSize",t[t.fontWeight=53]="fontWeight",t[t.fontVariations=54]="fontVariations",t[t.formatOnPaste=55]="formatOnPaste",t[t.formatOnType=56]="formatOnType",t[t.glyphMargin=57]="glyphMargin",t[t.gotoLocation=58]="gotoLocation",t[t.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",t[t.hover=60]="hover",t[t.inDiffEditor=61]="inDiffEditor",t[t.inlineSuggest=62]="inlineSuggest",t[t.inlineEdit=63]="inlineEdit",t[t.letterSpacing=64]="letterSpacing",t[t.lightbulb=65]="lightbulb",t[t.lineDecorationsWidth=66]="lineDecorationsWidth",t[t.lineHeight=67]="lineHeight",t[t.lineNumbers=68]="lineNumbers",t[t.lineNumbersMinChars=69]="lineNumbersMinChars",t[t.linkedEditing=70]="linkedEditing",t[t.links=71]="links",t[t.matchBrackets=72]="matchBrackets",t[t.minimap=73]="minimap",t[t.mouseStyle=74]="mouseStyle",t[t.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=76]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",t[t.multiCursorModifier=78]="multiCursorModifier",t[t.multiCursorPaste=79]="multiCursorPaste",t[t.multiCursorLimit=80]="multiCursorLimit",t[t.occurrencesHighlight=81]="occurrencesHighlight",t[t.overviewRulerBorder=82]="overviewRulerBorder",t[t.overviewRulerLanes=83]="overviewRulerLanes",t[t.padding=84]="padding",t[t.pasteAs=85]="pasteAs",t[t.parameterHints=86]="parameterHints",t[t.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",t[t.quickSuggestions=89]="quickSuggestions",t[t.quickSuggestionsDelay=90]="quickSuggestionsDelay",t[t.readOnly=91]="readOnly",t[t.readOnlyMessage=92]="readOnlyMessage",t[t.renameOnType=93]="renameOnType",t[t.renderControlCharacters=94]="renderControlCharacters",t[t.renderFinalNewline=95]="renderFinalNewline",t[t.renderLineHighlight=96]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=98]="renderValidationDecorations",t[t.renderWhitespace=99]="renderWhitespace",t[t.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",t[t.roundedSelection=101]="roundedSelection",t[t.rulers=102]="rulers",t[t.scrollbar=103]="scrollbar",t[t.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=105]="scrollBeyondLastLine",t[t.scrollPredominantAxis=106]="scrollPredominantAxis",t[t.selectionClipboard=107]="selectionClipboard",t[t.selectionHighlight=108]="selectionHighlight",t[t.selectOnLineNumbers=109]="selectOnLineNumbers",t[t.showFoldingControls=110]="showFoldingControls",t[t.showUnused=111]="showUnused",t[t.snippetSuggestions=112]="snippetSuggestions",t[t.smartSelect=113]="smartSelect",t[t.smoothScrolling=114]="smoothScrolling",t[t.stickyScroll=115]="stickyScroll",t[t.stickyTabStops=116]="stickyTabStops",t[t.stopRenderingLineAfter=117]="stopRenderingLineAfter",t[t.suggest=118]="suggest",t[t.suggestFontSize=119]="suggestFontSize",t[t.suggestLineHeight=120]="suggestLineHeight",t[t.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",t[t.suggestSelection=122]="suggestSelection",t[t.tabCompletion=123]="tabCompletion",t[t.tabIndex=124]="tabIndex",t[t.unicodeHighlighting=125]="unicodeHighlighting",t[t.unusualLineTerminators=126]="unusualLineTerminators",t[t.useShadowDOM=127]="useShadowDOM",t[t.useTabStops=128]="useTabStops",t[t.wordBreak=129]="wordBreak",t[t.wordSegmenterLocales=130]="wordSegmenterLocales",t[t.wordSeparators=131]="wordSeparators",t[t.wordWrap=132]="wordWrap",t[t.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=135]="wordWrapColumn",t[t.wordWrapOverride1=136]="wordWrapOverride1",t[t.wordWrapOverride2=137]="wordWrapOverride2",t[t.wrappingIndent=138]="wrappingIndent",t[t.wrappingStrategy=139]="wrappingStrategy",t[t.showDeprecated=140]="showDeprecated",t[t.inlayHints=141]="inlayHints",t[t.editorClassName=142]="editorClassName",t[t.pixelRatio=143]="pixelRatio",t[t.tabFocusMode=144]="tabFocusMode",t[t.layoutInfo=145]="layoutInfo",t[t.wrappingInfo=146]="wrappingInfo",t[t.defaultColorDecorators=147]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(s||(n.EditorOption=s={}));var u;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(u||(n.EndOfLinePreference=u={}));var c;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(c||(n.EndOfLineSequence=c={}));var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(h||(n.GlyphMarginLane=h={}));var y;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(y||(n.IndentAction=y={}));var C;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(C||(n.InjectedTextCursorStops=C={}));var N;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(N||(n.InlayHintKind=N={}));var R;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(R||(n.InlineCompletionTriggerKind=R={}));var w;(function(t){t[t.Invoke=0]="Invoke",t[t.Automatic=1]="Automatic"})(w||(n.InlineEditTriggerKind=w={}));var i;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(i||(n.KeyCode=i={}));var l;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(l||(n.MarkerSeverity=l={}));var d;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(d||(n.MarkerTag=d={}));var L;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(L||(n.MinimapPosition=L={}));var b;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(b||(n.MinimapSectionHeaderStyle=b={}));var _;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(_||(n.MouseTargetType=_={}));var E;(function(t){t[t.AIGenerated=1]="AIGenerated"})(E||(n.NewSymbolNameTag=E={}));var S;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(S||(n.OverlayWidgetPositionPreference=S={}));var M;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(M||(n.OverviewRulerLane=M={}));var D;(function(t){t[t.Word=0]="Word",t[t.Line=1]="Line",t[t.Suggest=2]="Suggest"})(D||(n.PartialAcceptTriggerKind=D={}));var T;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(T||(n.PositionAffinity=T={}));var k;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(k||(n.RenderLineNumbersType=k={}));var q;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(q||(n.RenderMinimap=q={}));var H;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(H||(n.ScrollType=H={}));var Q;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(Q||(n.ScrollbarVisibility=Q={}));var F;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(F||(n.SelectionDirection=F={}));var I;(function(t){t.Off="off",t.OnCode="onCode",t.On="on"})(I||(n.ShowLightbulbIconMode=I={}));var W;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(W||(n.SignatureHelpTriggerKind=W={}));var V;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(V||(n.SymbolKind=V={}));var z;(function(t){t[t.Deprecated=1]="Deprecated"})(z||(n.SymbolTag=z={}));var U;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(U||(n.TextEditorCursorBlinkingStyle=U={}));var se;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(se||(n.TextEditorCursorStyle=se={}));var he;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(he||(n.TrackedRangeStickiness=he={}));var de;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(de||(n.WrappingIndent=de={}))}),Y(X[62],Z([0,1,9,13]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class A{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(p){this._onDidChange.fire({changedLanguages:p,changedColorMap:!1})}register(p,o){return this._tokenizationSupports.set(p,o),this.handleChange([p]),(0,x.toDisposable)(()=>{this._tokenizationSupports.get(p)===o&&(this._tokenizationSupports.delete(p),this.handleChange([p]))})}get(p){return this._tokenizationSupports.get(p)||null}registerFactory(p,o){var a;(a=this._factories.get(p))===null||a===void 0||a.dispose();const v=new g(this,p,o);return this._factories.set(p,v),(0,x.toDisposable)(()=>{const e=this._factories.get(p);!e||e!==v||(this._factories.delete(p),e.dispose())})}async getOrCreate(p){const o=this.get(p);if(o)return o;const a=this._factories.get(p);return!a||a.isResolved?null:(await a.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const a=this._factories.get(p);return!!(!a||a.isResolved)}setColorMap(p){this._colorMap=p,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=A;class g extends x.Disposable{get isResolved(){return this._isResolved}constructor(p,o,a){super(),this._registry=p,this._languageId=o,this._factory=a,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const p=await this._factory.tokenizationSupport;this._isResolved=!0,p&&!this._isDisposed&&this._register(this._registry.register(this._languageId,p))}}}),Y(X[63],Z([19,64]),function(O,n){return O.create("vs/base/common/platform",n)}),Y(X[17],Z([0,1,63]),function(O,n,r){"use strict";var x,A;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.webWorkerOrigin=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.LANGUAGE_DEFAULT=void 0,n.isLittleEndian=_,n.LANGUAGE_DEFAULT="en";let g=!1,m=!1,p=!1,o=!1,a=!1,v=!1,e=!1,f=!1,s=!1,u=!1,c,h=n.LANGUAGE_DEFAULT,y=n.LANGUAGE_DEFAULT,C,N;const R=globalThis;let w;typeof R.vscode<"u"&&typeof R.vscode.process<"u"?w=R.vscode.process:typeof process<"u"&&typeof((x=process==null?void 0:process.versions)===null||x===void 0?void 0:x.node)=="string"&&(w=process);const i=typeof((A=w?.versions)===null||A===void 0?void 0:A.electron)=="string",l=i&&w?.type==="renderer";if(typeof w=="object"){g=w.platform==="win32",m=w.platform==="darwin",p=w.platform==="linux",o=p&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,e=i,s=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=n.LANGUAGE_DEFAULT,h=n.LANGUAGE_DEFAULT;const E=w.env.VSCODE_NLS_CONFIG;if(E)try{const S=JSON.parse(E),M=S.availableLanguages["*"];c=S.locale,y=S.osLocale,h=M||n.LANGUAGE_DEFAULT,C=S._translationsConfigFile}catch{}a=!0}else typeof navigator=="object"&&!l?(N=navigator.userAgent,g=N.indexOf("Windows")>=0,m=N.indexOf("Macintosh")>=0,f=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=N.indexOf("Linux")>=0,u=N?.indexOf("Mobi")>=0,v=!0,c=r.getConfiguredDefaultLocale(r.localize(0,null))||n.LANGUAGE_DEFAULT,h=c,y=navigator.language):console.error("Unable to resolve platform.");let d=0;m?d=1:g?d=3:p&&(d=2),n.isWindows=g,n.isMacintosh=m,n.isLinux=p,n.isNative=a,n.isWeb=v,n.isWebWorker=v&&typeof R.importScripts=="function",n.webWorkerOrigin=n.isWebWorker?R.origin:void 0,n.isIOS=f,n.isMobile=u,n.userAgent=N,n.language=h,n.setTimeout0IsFaster=typeof R.postMessage=="function"&&!R.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const E=[];R.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let D=0,T=E.length;D<T;D++){const k=E[D];if(k.id===M.data.vscodeScheduleAsyncWork){E.splice(D,1),k.callback();return}}});let S=0;return M=>{const D=++S;E.push({id:D,callback:M}),R.postMessage({vscodeScheduleAsyncWork:D},"*")}}return E=>setTimeout(E)})(),n.OS=m||f?2:g?1:3;let L=!0,b=!1;function _(){if(!b){b=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,L=new Uint16Array(E.buffer)[0]===513}return L}n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(X[65],Z([0,1,17]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let x;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const g=A.process;x={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?x={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:x={get platform(){return r.isWindows?"win32":r.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=x.cwd,n.env=x.env,n.platform=x.platform}),Y(X[66],Z([0,1,65]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const x=65,A=97,g=90,m=122,p=46,o=47,a=92,v=58,e=63;class f extends Error{constructor(l,d,L){let b;typeof d=="string"&&d.indexOf("not ")===0?(b="must not be",d=d.replace(/^not /,"")):b="must be";const _=l.indexOf(".")!==-1?"property":"argument";let E=`The "${l}" ${_} ${b} of type ${d}`;E+=`. Received type ${typeof L}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function s(i,l){if(i===null||typeof i!="object")throw new f(l,"Object",i)}function u(i,l){if(typeof i!="string")throw new f(l,"string",i)}const c=r.platform==="win32";function h(i){return i===o||i===a}function y(i){return i===o}function C(i){return i>=x&&i<=g||i>=A&&i<=m}function N(i,l,d,L){let b="",_=0,E=-1,S=0,M=0;for(let D=0;D<=i.length;++D){if(D<i.length)M=i.charCodeAt(D);else{if(L(M))break;M=o}if(L(M)){if(!(E===D-1||S===1))if(S===2){if(b.length<2||_!==2||b.charCodeAt(b.length-1)!==p||b.charCodeAt(b.length-2)!==p){if(b.length>2){const T=b.lastIndexOf(d);T===-1?(b="",_=0):(b=b.slice(0,T),_=b.length-1-b.lastIndexOf(d)),E=D,S=0;continue}else if(b.length!==0){b="",_=0,E=D,S=0;continue}}l&&(b+=b.length>0?`${d}..`:"..",_=2)}else b.length>0?b+=`${d}${i.slice(E+1,D)}`:b=i.slice(E+1,D),_=D-E-1;E=D,S=0}else M===p&&S!==-1?++S:S=-1}return b}function R(i,l){s(l,"pathObject");const d=l.dir||l.root,L=l.base||`${l.name||""}${l.ext||""}`;return d?d===l.root?`${d}${L}`:`${d}${i}${L}`:L}n.win32={resolve(...i){let l="",d="",L=!1;for(let b=i.length-1;b>=-1;b--){let _;if(b>=0){if(_=i[b],u(_,"path"),_.length===0)continue}else l.length===0?_=r.cwd():(_=r.env[`=${l}`]||r.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==l.toLowerCase()&&_.charCodeAt(2)===a)&&(_=`${l}\\`));const E=_.length;let S=0,M="",D=!1;const T=_.charCodeAt(0);if(E===1)h(T)&&(S=1,D=!0);else if(h(T))if(D=!0,h(_.charCodeAt(1))){let k=2,q=k;for(;k<E&&!h(_.charCodeAt(k));)k++;if(k<E&&k!==q){const H=_.slice(q,k);for(q=k;k<E&&h(_.charCodeAt(k));)k++;if(k<E&&k!==q){for(q=k;k<E&&!h(_.charCodeAt(k));)k++;(k===E||k!==q)&&(M=`\\\\${H}\\${_.slice(q,k)}`,S=k)}}}else S=1;else C(T)&&_.charCodeAt(1)===v&&(M=_.slice(0,2),S=2,E>2&&h(_.charCodeAt(2))&&(D=!0,S=3));if(M.length>0)if(l.length>0){if(M.toLowerCase()!==l.toLowerCase())continue}else l=M;if(L){if(l.length>0)break}else if(d=`${_.slice(S)}\\${d}`,L=D,D&&l.length>0)break}return d=N(d,!L,"\\",h),L?`${l}\\${d}`:`${l}${d}`||"."},normalize(i){u(i,"path");const l=i.length;if(l===0)return".";let d=0,L,b=!1;const _=i.charCodeAt(0);if(l===1)return y(_)?"\\":i;if(h(_))if(b=!0,h(i.charCodeAt(1))){let S=2,M=S;for(;S<l&&!h(i.charCodeAt(S));)S++;if(S<l&&S!==M){const D=i.slice(M,S);for(M=S;S<l&&h(i.charCodeAt(S));)S++;if(S<l&&S!==M){for(M=S;S<l&&!h(i.charCodeAt(S));)S++;if(S===l)return`\\\\${D}\\${i.slice(M)}\\`;S!==M&&(L=`\\\\${D}\\${i.slice(M,S)}`,d=S)}}}else d=1;else C(_)&&i.charCodeAt(1)===v&&(L=i.slice(0,2),d=2,l>2&&h(i.charCodeAt(2))&&(b=!0,d=3));let E=d<l?N(i.slice(d),!b,"\\",h):"";return E.length===0&&!b&&(E="."),E.length>0&&h(i.charCodeAt(l-1))&&(E+="\\"),L===void 0?b?`\\${E}`:E:b?`${L}\\${E}`:`${L}${E}`},isAbsolute(i){u(i,"path");const l=i.length;if(l===0)return!1;const d=i.charCodeAt(0);return h(d)||l>2&&C(d)&&i.charCodeAt(1)===v&&h(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,d;for(let _=0;_<i.length;++_){const E=i[_];u(E,"path"),E.length>0&&(l===void 0?l=d=E:l+=`\\${E}`)}if(l===void 0)return".";let L=!0,b=0;if(typeof d=="string"&&h(d.charCodeAt(0))){++b;const _=d.length;_>1&&h(d.charCodeAt(1))&&(++b,_>2&&(h(d.charCodeAt(2))?++b:L=!1))}if(L){for(;b<l.length&&h(l.charCodeAt(b));)b++;b>=2&&(l=`\\${l.slice(b)}`)}return n.win32.normalize(l)},relative(i,l){if(u(i,"from"),u(l,"to"),i===l)return"";const d=n.win32.resolve(i),L=n.win32.resolve(l);if(d===L||(i=d.toLowerCase(),l=L.toLowerCase(),i===l))return"";let b=0;for(;b<i.length&&i.charCodeAt(b)===a;)b++;let _=i.length;for(;_-1>b&&i.charCodeAt(_-1)===a;)_--;const E=_-b;let S=0;for(;S<l.length&&l.charCodeAt(S)===a;)S++;let M=l.length;for(;M-1>S&&l.charCodeAt(M-1)===a;)M--;const D=M-S,T=E<D?E:D;let k=-1,q=0;for(;q<T;q++){const Q=i.charCodeAt(b+q);if(Q!==l.charCodeAt(S+q))break;Q===a&&(k=q)}if(q!==T){if(k===-1)return L}else{if(D>T){if(l.charCodeAt(S+q)===a)return L.slice(S+q+1);if(q===2)return L.slice(S+q)}E>T&&(i.charCodeAt(b+q)===a?k=q:q===2&&(k=3)),k===-1&&(k=0)}let H="";for(q=b+k+1;q<=_;++q)(q===_||i.charCodeAt(q)===a)&&(H+=H.length===0?"..":"\\..");return S+=k,H.length>0?`${H}${L.slice(S,M)}`:(L.charCodeAt(S)===a&&++S,L.slice(S,M))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=n.win32.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===a){if(l.charCodeAt(1)===a){const d=l.charCodeAt(2);if(d!==e&&d!==p)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(C(l.charCodeAt(0))&&l.charCodeAt(1)===v&&l.charCodeAt(2)===a)return`\\\\?\\${l}`;return i},dirname(i){u(i,"path");const l=i.length;if(l===0)return".";let d=-1,L=0;const b=i.charCodeAt(0);if(l===1)return h(b)?i:".";if(h(b)){if(d=L=1,h(i.charCodeAt(1))){let S=2,M=S;for(;S<l&&!h(i.charCodeAt(S));)S++;if(S<l&&S!==M){for(M=S;S<l&&h(i.charCodeAt(S));)S++;if(S<l&&S!==M){for(M=S;S<l&&!h(i.charCodeAt(S));)S++;if(S===l)return i;S!==M&&(d=L=S+1)}}}}else C(b)&&i.charCodeAt(1)===v&&(d=l>2&&h(i.charCodeAt(2))?3:2,L=d);let _=-1,E=!0;for(let S=l-1;S>=L;--S)if(h(i.charCodeAt(S))){if(!E){_=S;break}}else E=!1;if(_===-1){if(d===-1)return".";_=d}return i.slice(0,_)},basename(i,l){l!==void 0&&u(l,"ext"),u(i,"path");let d=0,L=-1,b=!0,_;if(i.length>=2&&C(i.charCodeAt(0))&&i.charCodeAt(1)===v&&(d=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let E=l.length-1,S=-1;for(_=i.length-1;_>=d;--_){const M=i.charCodeAt(_);if(h(M)){if(!b){d=_+1;break}}else S===-1&&(b=!1,S=_+1),E>=0&&(M===l.charCodeAt(E)?--E===-1&&(L=_):(E=-1,L=S))}return d===L?L=S:L===-1&&(L=i.length),i.slice(d,L)}for(_=i.length-1;_>=d;--_)if(h(i.charCodeAt(_))){if(!b){d=_+1;break}}else L===-1&&(b=!1,L=_+1);return L===-1?"":i.slice(d,L)},extname(i){u(i,"path");let l=0,d=-1,L=0,b=-1,_=!0,E=0;i.length>=2&&i.charCodeAt(1)===v&&C(i.charCodeAt(0))&&(l=L=2);for(let S=i.length-1;S>=l;--S){const M=i.charCodeAt(S);if(h(M)){if(!_){L=S+1;break}continue}b===-1&&(_=!1,b=S+1),M===p?d===-1?d=S:E!==1&&(E=1):d!==-1&&(E=-1)}return d===-1||b===-1||E===0||E===1&&d===b-1&&d===L+1?"":i.slice(d,b)},format:R.bind(null,"\\"),parse(i){u(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const d=i.length;let L=0,b=i.charCodeAt(0);if(d===1)return h(b)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(h(b)){if(L=1,h(i.charCodeAt(1))){let k=2,q=k;for(;k<d&&!h(i.charCodeAt(k));)k++;if(k<d&&k!==q){for(q=k;k<d&&h(i.charCodeAt(k));)k++;if(k<d&&k!==q){for(q=k;k<d&&!h(i.charCodeAt(k));)k++;k===d?L=k:k!==q&&(L=k+1)}}}}else if(C(b)&&i.charCodeAt(1)===v){if(d<=2)return l.root=l.dir=i,l;if(L=2,h(i.charCodeAt(2))){if(d===3)return l.root=l.dir=i,l;L=3}}L>0&&(l.root=i.slice(0,L));let _=-1,E=L,S=-1,M=!0,D=i.length-1,T=0;for(;D>=L;--D){if(b=i.charCodeAt(D),h(b)){if(!M){E=D+1;break}continue}S===-1&&(M=!1,S=D+1),b===p?_===-1?_=D:T!==1&&(T=1):_!==-1&&(T=-1)}return S!==-1&&(_===-1||T===0||T===1&&_===S-1&&_===E+1?l.base=l.name=i.slice(E,S):(l.name=i.slice(E,_),l.base=i.slice(E,S),l.ext=i.slice(_,S))),E>0&&E!==L?l.dir=i.slice(0,E-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(c){const i=/\\/g;return()=>{const l=r.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>r.cwd()})();n.posix={resolve(...i){let l="",d=!1;for(let L=i.length-1;L>=-1&&!d;L--){const b=L>=0?i[L]:w();u(b,"path"),b.length!==0&&(l=`${b}/${l}`,d=b.charCodeAt(0)===o)}return l=N(l,!d,"/",y),d?`/${l}`:l.length>0?l:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===o,d=i.charCodeAt(i.length-1)===o;return i=N(i,!l,"/",y),i.length===0?l?"/":d?"./":".":(d&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===o},join(...i){if(i.length===0)return".";let l;for(let d=0;d<i.length;++d){const L=i[d];u(L,"path"),L.length>0&&(l===void 0?l=L:l+=`/${L}`)}return l===void 0?".":n.posix.normalize(l)},relative(i,l){if(u(i,"from"),u(l,"to"),i===l||(i=n.posix.resolve(i),l=n.posix.resolve(l),i===l))return"";const d=1,L=i.length,b=L-d,_=1,E=l.length-_,S=b<E?b:E;let M=-1,D=0;for(;D<S;D++){const k=i.charCodeAt(d+D);if(k!==l.charCodeAt(_+D))break;k===o&&(M=D)}if(D===S)if(E>S){if(l.charCodeAt(_+D)===o)return l.slice(_+D+1);if(D===0)return l.slice(_+D)}else b>S&&(i.charCodeAt(d+D)===o?M=D:D===0&&(M=0));let T="";for(D=d+M+1;D<=L;++D)(D===L||i.charCodeAt(D)===o)&&(T+=T.length===0?"..":"/..");return`${T}${l.slice(_+M)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===o;let d=-1,L=!0;for(let b=i.length-1;b>=1;--b)if(i.charCodeAt(b)===o){if(!L){d=b;break}}else L=!1;return d===-1?l?"/":".":l&&d===1?"//":i.slice(0,d)},basename(i,l){l!==void 0&&u(l,"ext"),u(i,"path");let d=0,L=-1,b=!0,_;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let E=l.length-1,S=-1;for(_=i.length-1;_>=0;--_){const M=i.charCodeAt(_);if(M===o){if(!b){d=_+1;break}}else S===-1&&(b=!1,S=_+1),E>=0&&(M===l.charCodeAt(E)?--E===-1&&(L=_):(E=-1,L=S))}return d===L?L=S:L===-1&&(L=i.length),i.slice(d,L)}for(_=i.length-1;_>=0;--_)if(i.charCodeAt(_)===o){if(!b){d=_+1;break}}else L===-1&&(b=!1,L=_+1);return L===-1?"":i.slice(d,L)},extname(i){u(i,"path");let l=-1,d=0,L=-1,b=!0,_=0;for(let E=i.length-1;E>=0;--E){const S=i.charCodeAt(E);if(S===o){if(!b){d=E+1;break}continue}L===-1&&(b=!1,L=E+1),S===p?l===-1?l=E:_!==1&&(_=1):l!==-1&&(_=-1)}return l===-1||L===-1||_===0||_===1&&l===L-1&&l===d+1?"":i.slice(l,L)},format:R.bind(null,"/"),parse(i){u(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const d=i.charCodeAt(0)===o;let L;d?(l.root="/",L=1):L=0;let b=-1,_=0,E=-1,S=!0,M=i.length-1,D=0;for(;M>=L;--M){const T=i.charCodeAt(M);if(T===o){if(!S){_=M+1;break}continue}E===-1&&(S=!1,E=M+1),T===p?b===-1?b=M:D!==1&&(D=1):b!==-1&&(D=-1)}if(E!==-1){const T=_===0&&d?1:_;b===-1||D===0||D===1&&b===E-1&&b===_+1?l.base=l.name=i.slice(T,E):(l.name=i.slice(T,b),l.base=i.slice(T,E),l.ext=i.slice(b,E))}return _>0?l.dir=i.slice(0,_-1):d&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=c?n.win32.normalize:n.posix.normalize,n.resolve=c?n.win32.resolve:n.posix.resolve,n.relative=c?n.win32.relative:n.posix.relative,n.dirname=c?n.win32.dirname:n.posix.dirname,n.basename=c?n.win32.basename:n.posix.basename,n.extname=c?n.win32.extname:n.posix.extname,n.sep=c?n.win32.sep:n.posix.sep}),Y(X[18],Z([0,1,66,17]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.URI=void 0,n.uriToFsPath=N;const A=/^\w[\w\d+.-]*$/,g=/^\//,m=/^\/\//;function p(d,L){if(!d.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!A.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!g.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(m.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(d,L){return!d&&!L?"file":d}function a(d,L){switch(d){case"https":case"http":case"file":L?L[0]!==e&&(L=e+L):L=e;break}return L}const v="",e="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(L){return L instanceof s?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,b,_,E,S,M=!1){typeof L=="object"?(this.scheme=L.scheme||v,this.authority=L.authority||v,this.path=L.path||v,this.query=L.query||v,this.fragment=L.fragment||v):(this.scheme=o(L,M),this.authority=b||v,this.path=a(this.scheme,_||v),this.query=E||v,this.fragment=S||v,p(this,M))}get fsPath(){return N(this,!1)}with(L){if(!L)return this;let{scheme:b,authority:_,path:E,query:S,fragment:M}=L;return b===void 0?b=this.scheme:b===null&&(b=v),_===void 0?_=this.authority:_===null&&(_=v),E===void 0?E=this.path:E===null&&(E=v),S===void 0?S=this.query:S===null&&(S=v),M===void 0?M=this.fragment:M===null&&(M=v),b===this.scheme&&_===this.authority&&E===this.path&&S===this.query&&M===this.fragment?this:new c(b,_,E,S,M)}static parse(L,b=!1){const _=f.exec(L);return _?new c(_[2]||v,l(_[4]||v),l(_[5]||v),l(_[7]||v),l(_[9]||v),b):new c(v,v,v,v,v)}static file(L){let b=v;if(x.isWindows&&(L=L.replace(/\\/g,e)),L[0]===e&&L[1]===e){const _=L.indexOf(e,2);_===-1?(b=L.substring(2),L=e):(b=L.substring(2,_),L=L.substring(_)||e)}return new c("file",b,L,v,v)}static from(L,b){return new c(L.scheme,L.authority,L.path,L.query,L.fragment,b)}static joinPath(L,...b){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let _;return x.isWindows&&L.scheme==="file"?_=s.file(r.win32.join(N(L,!0),...b)).path:_=r.posix.join(L.path,...b),L.with({path:_})}toString(L=!1){return R(this,L)}toJSON(){return this}static revive(L){var b,_;if(L){if(L instanceof s)return L;{const E=new c(L);return E._formatted=(b=L.external)!==null&&b!==void 0?b:null,E._fsPath=L._sep===u&&(_=L.fsPath)!==null&&_!==void 0?_:null,E}}else return L}}n.URI=s;const u=x.isWindows?1:void 0;class c extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=N(this,!1)),this._fsPath}toString(L=!1){return L?R(this,!0):(this._formatted||(this._formatted=R(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=u),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function y(d,L,b){let _,E=-1;for(let S=0;S<d.length;S++){const M=d.charCodeAt(S);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||L&&M===47||b&&M===91||b&&M===93||b&&M===58)E!==-1&&(_+=encodeURIComponent(d.substring(E,S)),E=-1),_!==void 0&&(_+=d.charAt(S));else{_===void 0&&(_=d.substr(0,S));const D=h[M];D!==void 0?(E!==-1&&(_+=encodeURIComponent(d.substring(E,S)),E=-1),_+=D):E===-1&&(E=S)}}return E!==-1&&(_+=encodeURIComponent(d.substring(E))),_!==void 0?_:d}function C(d){let L;for(let b=0;b<d.length;b++){const _=d.charCodeAt(b);_===35||_===63?(L===void 0&&(L=d.substr(0,b)),L+=h[_]):L!==void 0&&(L+=d[b])}return L!==void 0?L:d}function N(d,L){let b;return d.authority&&d.path.length>1&&d.scheme==="file"?b=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?L?b=d.path.substr(1):b=d.path[1].toLowerCase()+d.path.substr(2):b=d.path,x.isWindows&&(b=b.replace(/\//g,"\\")),b}function R(d,L){const b=L?C:y;let _="",{scheme:E,authority:S,path:M,query:D,fragment:T}=d;if(E&&(_+=E,_+=":"),(S||E==="file")&&(_+=e,_+=e),S){let k=S.indexOf("@");if(k!==-1){const q=S.substr(0,k);S=S.substr(k+1),k=q.lastIndexOf(":"),k===-1?_+=b(q,!1,!1):(_+=b(q.substr(0,k),!1,!1),_+=":",_+=b(q.substr(k+1),!1,!0)),_+="@"}S=S.toLowerCase(),k=S.lastIndexOf(":"),k===-1?_+=b(S,!1,!0):(_+=b(S.substr(0,k),!1,!0),_+=S.substr(k))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const k=M.charCodeAt(1);k>=65&&k<=90&&(M=`/${String.fromCharCode(k+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const k=M.charCodeAt(0);k>=65&&k<=90&&(M=`${String.fromCharCode(k+32)}:${M.substr(2)}`)}_+=b(M,!0,!1)}return D&&(_+="?",_+=b(D,!1,!1)),T&&(_+="#",_+=L?T:y(T,!1,!1)),_}function w(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+w(d.substr(3)):d}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(d){return d.match(i)?d.replace(i,L=>w(L)):d}}),Y(X[70],Z([0,1,5,9,13,14,17,6]),function(O,n,r,x,A,g,m,p){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SimpleWorkerServer=n.SimpleWorkerClient=void 0,n.logOnceWebWorkerWarning=v,n.create=i;const o="$initialize";let a=!1;function v(l){m.isWeb&&(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}class e{constructor(d,L,b,_){this.vsWorker=d,this.req=L,this.method=b,this.args=_,this.type=0}}class f{constructor(d,L,b,_){this.vsWorker=d,this.seq=L,this.res=b,this.err=_,this.type=1}}class s{constructor(d,L,b,_){this.vsWorker=d,this.req=L,this.eventName=b,this.arg=_,this.type=2}}class u{constructor(d,L,b){this.vsWorker=d,this.req=L,this.event=b,this.type=3}}class c{constructor(d,L){this.vsWorker=d,this.req=L,this.type=4}}class h{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,L){const b=String(++this._lastSentReq);return new Promise((_,E)=>{this._pendingReplies[b]={resolve:_,reject:E},this._send(new e(this._workerId,b,d,L))})}listen(d,L){let b=null;const _=new x.Emitter({onWillAddFirstListener:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,_),this._send(new s(this._workerId,b,d,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(b),this._send(new c(this._workerId,b)),b=null}});return _.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let b=d.err;d.err.$isError&&(b=new Error,b.name=d.err.name,b.message=d.err.message,b.stack=d.err.stack),L.reject(b);return}L.resolve(d.res)}_handleRequestMessage(d){const L=d.req;this._handler.handleMessage(d.method,d.args).then(_=>{this._send(new f(this._workerId,L,_,void 0))},_=>{_.detail instanceof Error&&(_.detail=(0,r.transformErrorForSerialization)(_.detail)),this._send(new f(this._workerId,L,void 0,(0,r.transformErrorForSerialization)(_)))})}_handleSubscribeEventMessage(d){const L=d.req,b=this._handler.handleEvent(d.eventName,d.arg)(_=>{this._send(new u(this._workerId,L,_))});this._pendingEvents.set(L,b)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){const L=[];if(d.type===0)for(let b=0;b<d.args.length;b++)d.args[b]instanceof ArrayBuffer&&L.push(d.args[b]);else d.type===1&&d.res instanceof ArrayBuffer&&L.push(d.res);this._handler.sendMessage(d,L)}}class y extends A.Disposable{constructor(d,L,b){super();let _=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",k=>{this._protocol.handleMessage(k)},k=>{_?.(k)})),this._protocol=new h({sendMessage:(k,q)=>{this._worker.postMessage(k,q)},handleMessage:(k,q)=>{if(typeof b[k]!="function")return Promise.reject(new Error("Missing method "+k+" on main thread host."));try{return Promise.resolve(b[k].apply(b,q))}catch(H){return Promise.reject(H)}},handleEvent:(k,q)=>{if(N(k)){const H=b[k].call(b,q);if(typeof H!="function")throw new Error(`Missing dynamic event ${k} on main thread host.`);return H}if(C(k)){const H=b[k];if(typeof H!="function")throw new Error(`Missing event ${k} on main thread host.`);return H}throw new Error(`Malformed event name ${k}`)}}),this._protocol.setWorkerId(this._worker.getId());let E=null;const S=globalThis.require;typeof S<"u"&&typeof S.getConfig=="function"?E=S.getConfig():typeof globalThis.requirejs<"u"&&(E=globalThis.requirejs.s.contexts._.config);const M=(0,g.getAllMethodNames)(b);this._onModuleLoaded=this._protocol.sendMessage(o,[this._worker.getId(),JSON.parse(JSON.stringify(E)),L,M]);const D=(k,q)=>this._request(k,q),T=(k,q)=>this._protocol.listen(k,q);this._lazyProxy=new Promise((k,q)=>{_=q,this._onModuleLoaded.then(H=>{k(R(H,D,T))},H=>{q(H),this._onError("Worker failed to load "+L,H)})})}getProxyObject(){return this._lazyProxy}_request(d,L){return new Promise((b,_)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,L).then(b,_)},_)})}_onError(d,L){console.error(d),console.info(L)}}n.SimpleWorkerClient=y;function C(l){return l[0]==="o"&&l[1]==="n"&&p.isUpperAsciiLetter(l.charCodeAt(2))}function N(l){return/^onDynamic/.test(l)&&p.isUpperAsciiLetter(l.charCodeAt(9))}function R(l,d,L){const b=S=>function(){const M=Array.prototype.slice.call(arguments,0);return d(S,M)},_=S=>function(M){return L(S,M)},E={};for(const S of l){if(N(S)){E[S]=_(S);continue}if(C(S)){E[S]=L(S,void 0);continue}E[S]=b(S)}return E}class w{constructor(d,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new h({sendMessage:(b,_)=>{d(b,_)},handleMessage:(b,_)=>this._handleMessage(b,_),handleEvent:(b,_)=>this._handleEvent(b,_)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,L){if(d===o)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,L))}catch(b){return Promise.reject(b)}}_handleEvent(d,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(N(d)){const b=this._requestHandler[d].call(this._requestHandler,L);if(typeof b!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return b}if(C(d)){const b=this._requestHandler[d];if(typeof b!="function")throw new Error(`Missing event ${d} on request handler.`);return b}throw new Error(`Malformed event name ${d}`)}initialize(d,L,b,_){this._protocol.setWorkerId(d);const M=R(_,(D,T)=>this._protocol.sendMessage(D,T),(D,T)=>this._protocol.listen(D,T));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(M),Promise.resolve((0,g.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy<"u"&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((D,T)=>{(globalThis.require||O)([b],q=>{if(this._requestHandler=q.create(M),!this._requestHandler){T(new Error("No RequestHandler!"));return}D((0,g.getAllMethodNames)(this._requestHandler))},T)}))}}n.SimpleWorkerServer=w;function i(l){return new w(l,null)}}),Y(X[67],Z([19,64]),function(O,n){return O.create("vs/editor/common/languages",n)}),Y(X[68],Z([0,1,42,18,2,62,67]),function(O,n,r,x,A,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.InlineEditTriggerKind=n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.NewSymbolNameTag=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.symbolKindNames=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.DocumentPasteTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0,n.isLocationLink=h,n.getAriaLabelForSymbol=y;class p{constructor(_,E,S){this.offset=_,this.type=E,this.language=S,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=p;class o{constructor(_,E){this.tokens=_,this.endState=E,this._tokenizationResultBrand=void 0}}n.TokenizationResult=o;class a{constructor(_,E){this.tokens=_,this.endState=E,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=a;var v;(function(b){const _=new Map;_.set(0,r.Codicon.symbolMethod),_.set(1,r.Codicon.symbolFunction),_.set(2,r.Codicon.symbolConstructor),_.set(3,r.Codicon.symbolField),_.set(4,r.Codicon.symbolVariable),_.set(5,r.Codicon.symbolClass),_.set(6,r.Codicon.symbolStruct),_.set(7,r.Codicon.symbolInterface),_.set(8,r.Codicon.symbolModule),_.set(9,r.Codicon.symbolProperty),_.set(10,r.Codicon.symbolEvent),_.set(11,r.Codicon.symbolOperator),_.set(12,r.Codicon.symbolUnit),_.set(13,r.Codicon.symbolValue),_.set(15,r.Codicon.symbolEnum),_.set(14,r.Codicon.symbolConstant),_.set(15,r.Codicon.symbolEnum),_.set(16,r.Codicon.symbolEnumMember),_.set(17,r.Codicon.symbolKeyword),_.set(27,r.Codicon.symbolSnippet),_.set(18,r.Codicon.symbolText),_.set(19,r.Codicon.symbolColor),_.set(20,r.Codicon.symbolFile),_.set(21,r.Codicon.symbolReference),_.set(22,r.Codicon.symbolCustomColor),_.set(23,r.Codicon.symbolFolder),_.set(24,r.Codicon.symbolTypeParameter),_.set(25,r.Codicon.account),_.set(26,r.Codicon.issues);function E(D){let T=_.get(D);return T||(console.info("No codicon found for CompletionItemKind "+D),T=r.Codicon.symbolProperty),T}b.toIcon=E;const S=new Map;S.set("method",0),S.set("function",1),S.set("constructor",2),S.set("field",3),S.set("variable",4),S.set("class",5),S.set("struct",6),S.set("interface",7),S.set("module",8),S.set("property",9),S.set("event",10),S.set("operator",11),S.set("unit",12),S.set("value",13),S.set("constant",14),S.set("enum",15),S.set("enum-member",16),S.set("enumMember",16),S.set("keyword",17),S.set("snippet",27),S.set("text",18),S.set("color",19),S.set("file",20),S.set("reference",21),S.set("customcolor",22),S.set("folder",23),S.set("type-parameter",24),S.set("typeParameter",24),S.set("account",25),S.set("issue",26);function M(D,T){let k=S.get(D);return typeof k>"u"&&!T&&(k=9),k}b.fromString=M})(v||(n.CompletionItemKinds=v={}));var e;(function(b){b[b.Automatic=0]="Automatic",b[b.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class f{constructor(_,E,S,M){this.range=_,this.text=E,this.completionKind=S,this.isSnippetText=M}equals(_){return A.Range.lift(this.range).equalsRange(_.range)&&this.text===_.text&&this.completionKind===_.completionKind&&this.isSnippetText===_.isSnippetText}}n.SelectedSuggestionInfo=f;var s;(function(b){b[b.Automatic=0]="Automatic",b[b.PasteAs=1]="PasteAs"})(s||(n.DocumentPasteTriggerKind=s={}));var u;(function(b){b[b.Invoke=1]="Invoke",b[b.TriggerCharacter=2]="TriggerCharacter",b[b.ContentChange=3]="ContentChange"})(u||(n.SignatureHelpTriggerKind=u={}));var c;(function(b){b[b.Text=0]="Text",b[b.Read=1]="Read",b[b.Write=2]="Write"})(c||(n.DocumentHighlightKind=c={}));function h(b){return b&&x.URI.isUri(b.uri)&&A.Range.isIRange(b.range)&&(A.Range.isIRange(b.originSelectionRange)||A.Range.isIRange(b.targetSelectionRange))}n.symbolKindNames={17:(0,m.localize)(0,null),16:(0,m.localize)(1,null),4:(0,m.localize)(2,null),13:(0,m.localize)(3,null),8:(0,m.localize)(4,null),9:(0,m.localize)(5,null),21:(0,m.localize)(6,null),23:(0,m.localize)(7,null),7:(0,m.localize)(8,null),0:(0,m.localize)(9,null),11:(0,m.localize)(10,null),10:(0,m.localize)(11,null),19:(0,m.localize)(12,null),5:(0,m.localize)(13,null),1:(0,m.localize)(14,null),2:(0,m.localize)(15,null),20:(0,m.localize)(16,null),15:(0,m.localize)(17,null),18:(0,m.localize)(18,null),24:(0,m.localize)(19,null),3:(0,m.localize)(20,null),6:(0,m.localize)(21,null),14:(0,m.localize)(22,null),22:(0,m.localize)(23,null),25:(0,m.localize)(24,null),12:(0,m.localize)(25,null)};function y(b,_){return(0,m.localize)(26,null,b,n.symbolKindNames[_])}var C;(function(b){const _=new Map;_.set(0,r.Codicon.symbolFile),_.set(1,r.Codicon.symbolModule),_.set(2,r.Codicon.symbolNamespace),_.set(3,r.Codicon.symbolPackage),_.set(4,r.Codicon.symbolClass),_.set(5,r.Codicon.symbolMethod),_.set(6,r.Codicon.symbolProperty),_.set(7,r.Codicon.symbolField),_.set(8,r.Codicon.symbolConstructor),_.set(9,r.Codicon.symbolEnum),_.set(10,r.Codicon.symbolInterface),_.set(11,r.Codicon.symbolFunction),_.set(12,r.Codicon.symbolVariable),_.set(13,r.Codicon.symbolConstant),_.set(14,r.Codicon.symbolString),_.set(15,r.Codicon.symbolNumber),_.set(16,r.Codicon.symbolBoolean),_.set(17,r.Codicon.symbolArray),_.set(18,r.Codicon.symbolObject),_.set(19,r.Codicon.symbolKey),_.set(20,r.Codicon.symbolNull),_.set(21,r.Codicon.symbolEnumMember),_.set(22,r.Codicon.symbolStruct),_.set(23,r.Codicon.symbolEvent),_.set(24,r.Codicon.symbolOperator),_.set(25,r.Codicon.symbolTypeParameter);function E(S){let M=_.get(S);return M||(console.info("No codicon found for SymbolKind "+S),M=r.Codicon.symbolProperty),M}b.toIcon=E})(C||(n.SymbolKinds=C={}));class N{}n.TextEdit=N;class R{static fromValue(_){switch(_){case"comment":return R.Comment;case"imports":return R.Imports;case"region":return R.Region}return new R(_)}constructor(_){this.value=_}}n.FoldingRangeKind=R,R.Comment=new R("comment"),R.Imports=new R("imports"),R.Region=new R("region");var w;(function(b){b[b.AIGenerated=1]="AIGenerated"})(w||(n.NewSymbolNameTag=w={}));var i;(function(b){function _(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}b.is=_})(i||(n.Command=i={}));var l;(function(b){b[b.Type=1]="Type",b[b.Parameter=2]="Parameter"})(l||(n.InlayHintKind=l={}));class d{constructor(_){this.createSupport=_,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(_=>{_&&_.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=d,n.TokenizationRegistry=new g.TokenizationRegistry;var L;(function(b){b[b.Invoke=0]="Invoke",b[b.Automatic=1]="Automatic"})(L||(n.InlineEditTriggerKind=L={}))}),Y(X[69],Z([0,1,39,9,37,18,4,2,43,68,61]),function(O,n,r,x,A,g,m,p,o,a,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyMod=void 0,n.createMonacoBaseAPI=f;class e{static chord(u,c){return(0,A.KeyChord)(u,c)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function f(){return{editor:void 0,languages:void 0,CancellationTokenSource:r.CancellationTokenSource,Emitter:x.Emitter,KeyCode:v.KeyCode,KeyMod:e,Position:m.Position,Range:p.Range,Selection:o.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:g.URI,Token:a.Token}}}),Y(X[71],Z([0,1,25,18,4,2,57,30,53,54,69,24,60,51,14,52,59]),function(O,n,r,x,A,g,m,p,o,a,v,e,f,s,u,c,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.EditorSimpleWorker=void 0,n.create=N;class y extends m.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(w){const i=[];for(let l=0;l<this._lines.length;l++){const d=this._lines[l],L=this.offsetAt(new A.Position(l+1,1)),b=d.matchAll(w);for(const _ of b)(_.index||_.index===0)&&(_.index=_.index+L),i.push(_)}return i}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(w){return this._lines[w-1]}getWordAtPosition(w,i){const l=(0,p.getWordAtText)(w.column,(0,p.ensureValidWordDefinition)(i),this._lines[w.lineNumber-1],0);return l?new g.Range(w.lineNumber,l.startColumn,w.lineNumber,l.endColumn):null}words(w){const i=this._lines,l=this._wordenize.bind(this);let d=0,L="",b=0,_=[];return{*[Symbol.iterator](){for(;;)if(b<_.length){const E=L.substring(_[b].start,_[b].end);b+=1,yield E}else if(d<i.length)L=i[d],_=l(L,w),b=0,d+=1;else break}}}getLineWords(w,i){const l=this._lines[w-1],d=this._wordenize(l,i),L=[];for(const b of d)L.push({word:l.substring(b.start,b.end),startColumn:b.start+1,endColumn:b.end+1});return L}_wordenize(w,i){const l=[];let d;for(i.lastIndex=0;(d=i.exec(w))&&d[0].length!==0;)l.push({start:d.index,end:d.index+d[0].length});return l}getValueInRange(w){if(w=this._validateRange(w),w.startLineNumber===w.endLineNumber)return this._lines[w.startLineNumber-1].substring(w.startColumn-1,w.endColumn-1);const i=this._eol,l=w.startLineNumber-1,d=w.endLineNumber-1,L=[];L.push(this._lines[l].substring(w.startColumn-1));for(let b=l+1;b<d;b++)L.push(this._lines[b]);return L.push(this._lines[d].substring(0,w.endColumn-1)),L.join(i)}offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.lineNumber-2)+(w.column-1)}positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const i=this._lineStarts.getIndexOf(w),l=this._lines[i.index].length;return{lineNumber:1+i.index,column:1+Math.min(i.remainder,l)}}_validateRange(w){const i=this._validatePosition({lineNumber:w.startLineNumber,column:w.startColumn}),l=this._validatePosition({lineNumber:w.endLineNumber,column:w.endColumn});return i.lineNumber!==w.startLineNumber||i.column!==w.startColumn||l.lineNumber!==w.endLineNumber||l.column!==w.endColumn?{startLineNumber:i.lineNumber,startColumn:i.column,endLineNumber:l.lineNumber,endColumn:l.column}:w}_validatePosition(w){if(!A.Position.isIPosition(w))throw new Error("bad position");let{lineNumber:i,column:l}=w,d=!1;if(i<1)i=1,l=1,d=!0;else if(i>this._lines.length)i=this._lines.length,l=this._lines[i-1].length+1,d=!0;else{const L=this._lines[i-1].length+1;l<1?(l=1,d=!0):l>L&&(l=L,d=!0)}return d?{lineNumber:i,column:l}:w}}class C{constructor(w,i){this._host=w,this._models=Object.create(null),this._foreignModuleFactory=i,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(w){return this._models[w]}_getModels(){const w=[];return Object.keys(this._models).forEach(i=>w.push(this._models[i])),w}acceptNewModel(w){this._models[w.url]=new y(x.URI.parse(w.url),w.lines,w.EOL,w.versionId)}acceptModelChanged(w,i){if(!this._models[w])return;this._models[w].onEvents(i)}acceptRemovedModel(w){this._models[w]&&delete this._models[w]}async computeUnicodeHighlights(w,i,l){const d=this._getModel(w);return d?f.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,i,l):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(w,i){const l=this._getModel(w);return l?(0,h.findSectionHeaders)(l,i):[]}async computeDiff(w,i,l,d){const L=this._getModel(w),b=this._getModel(i);return!L||!b?null:C.computeDiff(L,b,l,d)}static computeDiff(w,i,l,d){const L=d==="advanced"?s.linesDiffComputers.getDefault():s.linesDiffComputers.getLegacy(),b=w.getLinesContent(),_=i.getLinesContent(),E=L.computeDiff(b,_,l),S=E.changes.length>0?!1:this._modelsAreIdentical(w,i);function M(D){return D.map(T=>{var k;return[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,(k=T.innerChanges)===null||k===void 0?void 0:k.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])]})}return{identical:S,quitEarly:E.hitTimeout,changes:M(E.changes),moves:E.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,M(D.changes)])}}static _modelsAreIdentical(w,i){const l=w.getLineCount(),d=i.getLineCount();if(l!==d)return!1;for(let L=1;L<=l;L++){const b=w.getLineContent(L),_=i.getLineContent(L);if(b!==_)return!1}return!0}async computeMoreMinimalEdits(w,i,l){const d=this._getModel(w);if(!d)return i;const L=[];let b;i=i.slice(0).sort((E,S)=>{if(E.range&&S.range)return g.Range.compareRangesUsingStarts(E.range,S.range);const M=E.range?0:1,D=S.range?0:1;return M-D});let _=0;for(let E=1;E<i.length;E++)g.Range.getEndPosition(i[_].range).equals(g.Range.getStartPosition(i[E].range))?(i[_].range=g.Range.fromPositions(g.Range.getStartPosition(i[_].range),g.Range.getEndPosition(i[E].range)),i[_].text+=i[E].text):(_++,i[_]=i[E]);i.length=_+1;for(let{range:E,text:S,eol:M}of i){if(typeof M=="number"&&(b=M),g.Range.isEmpty(E)&&!S)continue;const D=d.getValueInRange(E);if(S=S.replace(/\r\n|\n|\r/g,d.eol),D===S)continue;if(Math.max(S.length,D.length)>C._diffLimit){L.push({range:E,text:S});continue}const T=(0,r.stringDiff)(D,S,l),k=d.offsetAt(g.Range.lift(E).getStartPosition());for(const q of T){const H=d.positionAt(k+q.originalStart),Q=d.positionAt(k+q.originalStart+q.originalLength),F={text:S.substr(q.modifiedStart,q.modifiedLength),range:{startLineNumber:H.lineNumber,startColumn:H.column,endLineNumber:Q.lineNumber,endColumn:Q.column}};d.getValueInRange(F.range)!==F.text&&L.push(F)}}return typeof b=="number"&&L.push({eol:b,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(w){const i=this._getModel(w);return i?(0,o.computeLinks)(i):null}async computeDefaultDocumentColors(w){const i=this._getModel(w);return i?(0,c.computeDefaultDocumentColors)(i):null}async textualSuggest(w,i,l,d){const L=new e.StopWatch,b=new RegExp(l,d),_=new Set;e:for(const E of w){const S=this._getModel(E);if(S){for(const M of S.words(b))if(!(M===i||!isNaN(Number(M)))&&(_.add(M),_.size>C._suggestionsLimit))break e}}return{words:Array.from(_),duration:L.elapsed()}}async computeWordRanges(w,i,l,d){const L=this._getModel(w);if(!L)return Object.create(null);const b=new RegExp(l,d),_=Object.create(null);for(let E=i.startLineNumber;E<i.endLineNumber;E++){const S=L.getLineWords(E,b);for(const M of S){if(!isNaN(Number(M.word)))continue;let D=_[M.word];D||(D=[],_[M.word]=D),D.push({startLineNumber:E,startColumn:M.startColumn,endLineNumber:E,endColumn:M.endColumn})}}return _}async navigateValueSet(w,i,l,d,L){const b=this._getModel(w);if(!b)return null;const _=new RegExp(d,L);i.startColumn===i.endColumn&&(i={startLineNumber:i.startLineNumber,startColumn:i.startColumn,endLineNumber:i.endLineNumber,endColumn:i.endColumn+1});const E=b.getValueInRange(i),S=b.getWordAtPosition({lineNumber:i.startLineNumber,column:i.startColumn},_);if(!S)return null;const M=b.getValueInRange(S);return a.BasicInplaceReplace.INSTANCE.navigateValueSet(i,E,S,M,l)}loadForeignModule(w,i,l){const d=(_,E)=>this._host.fhr(_,E),b={host:(0,u.createProxyObject)(l,d),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(b,i),Promise.resolve((0,u.getAllMethodNames)(this._foreignModule))):new Promise((_,E)=>{O([w],S=>{this._foreignModule=S.create(b,i),_((0,u.getAllMethodNames)(this._foreignModule))},E)})}fmr(w,i){if(!this._foreignModule||typeof this._foreignModule[w]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+w));try{return Promise.resolve(this._foreignModule[w].apply(this._foreignModule,i))}catch(l){return Promise.reject(l)}}}n.EditorSimpleWorker=C,C._diffLimit=1e5,C._suggestionsLimit=1e4;function N(R){return new C(R,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,v.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map